; version PICEMULATOR
; rev 22 octobre RB2 en INPUT !
; rev 21 octobre 2002 pour adaptation PIC16F628  ... not OK!!!!
; 10 octobre 2002
; deux lignes Rs_Tx (RB2) et Rs_Rx sur RB1 

	include <p16f628_.inc>

#define miniSimDE

	ifdef miniSimDE
	p=16F628
	else
	ERRORLEVEL      -302
	Processor       16F628
	endif
	Radix           DEC
	EXPAND
  	;__CONFIG _CP_OFF & _DATA_CP_OFF & _LVP_OFF & _BODEN_OFF & _MCLRE_ON & _WDT_OFF & _PWRTE_ON  &
	;_EXTCLK_OSC &  _XT_OSC 

	__CONFIG 0x3F21


Rs_Tx           EQU     0x02
Rs_Rx           EQU     0x01
Rs_Port         EQU     PORTB


;Registres du programme

#define Ram 0x20
W_TEMP 		EQU Ram
STATUS_TEMP	EQU Ram+1 

#define RamRS Ram+2

TEMP            EQU     RamRS             ;registre temporaire
RsCount         EQU     RamRS+1
TIME            EQU     RamRS+2
TIME1           EQU     RamRS+3
TIME2           EQU     RamRS+4
Temp1           EQU     RamRS+5
Temp2           EQU     RamRS+6
Temp3           EQU     RamRS+7
Temp4           EQU     RamRS+8
RsBuffer        EQU     RamRS+9
; ..... 8 octets .......
OverCnt		EQU	RamRS+18
TX_INDEX	EQU 	RamRS+19
DELAY1		EQU	RamRS+20
DELAY2		EQU	RamRS+21

#define RamCN RamRS+22

bcent		EQU RamCN+0
bdix		EQU RamCN+1
bun		EQU RamCN+2
btmp		EQU RamCN+3
btmp1		EQU RamCN+4
dixmil		EQU RamCN+5
mille		EQU RamCN+6
cent		EQU RamCN+7
dix		EQU RamCN+8
un		EQU RamCN+9
Cpt1		EQU RamCN+10
Cpt2		EQU RamCN+11

#define Ram16 RamCN+12
valx		EQU Ram16	; reg de sauvegarde
val1		EQU Ram16+2	; reg de travail
val2		EQU Ram16+4	; nb car OK
val3		EQU Ram16+6	; nb de car BAD
 
        ORG     0x0000             
	goto Init
;--------------------------------
	org 0x04
	BCF INTCON,GIE		; masque toutes interruptions
	Movwf W_TEMP
	Swapf STATUS,W
	Movwf STATUS_TEMP
	BCF STATUS,RP0
;  recherche origine de l'interruption 
;	BTFSC	INTCON,T0IF	; Timer0 oveflow ?
;	Call    SPint_Timer0
;	BTFSC 	INTCON,INTF	; Change on RB0 ?
;	Call 	SPint_RB0
	BTFSC	PIR1,RCIF	; reception USART ?
	Call	Read_Char
;	BTFSC	PIR1,TXIF	; emission USART ?
;	Call	Emet_Car
;	BTFSC	PIR1,TMR1IF	; Timer 1 overflow ?
;	Call 	SPint_Timer1
	BCF STATUS,RP0
	MOVF W_TEMP,W
	SWAPF	STATUS_TEMP,W
	MOVWF	STATUS
	RETFIE

;--------------------------------------------------------------------
;Routine d'initialisation du PORTA et du PortB

Init   

		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear int-flags, Disable interrupts
		CLRF 	PIE1
		CLRF    PCLATH          ; Keep in lower 2KByte

		movlw	0x07		;turn comparators off and 
		movwf	CMCON		;enable RA0,1,2,3 pins for I/O functions
		CLRF    PORTA           ;ALL PORT outputs should output Low.
		CLRF    PORTB

		bank1

		MOVLW   0x07            ; RA 0,1,2 =inputs, RA 4 =outputs
		MOVWF   TRISA
		MOVLW   0x00	       ; RB0,1,2,3,4,5,6,7=output  		
		MOVWF	TRISB
	
Init_RS
	;reception
		bank0 
		movlw 	0x90		; SPEN=1 CREN=1  RB1,RB2 for UART,asynchrone
		MOVWF	RCSTA		; enable continous reception
		bank1    		
		MOVLW 	0x19		; 25 ->9600 bds
		MOVWF	SPBRG
		MOVLW	b'10100110'	; CSRC=1, TXEN=1,SYNC=0,BRGH=1 enable transmission
		MOVWF	TXSTA
		BSF	PIE1,RCIE	; RCIE=1 enable interrupt sur reception
	;emission
	;	bsf   	PIE1,TXIE   	; on autorise les interruptions d'emission
		BCF   	PIE1,TXIE	; disable transmission interrupt
		bank0
		MOVLW 	0     		; on envoi un octet vide ( --> bug sinon ! )
       	        MOVWF 	TXREG
   		MOVF  	RCREG,w     	; on vide le buffer
		BCF   	RCSTA,ADDEN  		; bit 3 : 0 =  , 1 = ( a voir )
		BCF  	OPTION_REG,NOT_RBPU 	; rappel resist  
	
       		CLRF INTCON
;arme interrupt RB0
;		BSF	OPTION_REG,INTEDG ; front montant RB0
;		BSF	INTCON,INTE	; RBO
;		nop
		BSF	INTCON,PEIE	; PEIE=1 enable peripheral interrupts
		NOP
		BSF	INTCON,GIE	; enables all unmasked interrup
		bank0   ; Select bank 0

;		MOVLW RsBuffer		; RAZ buffer
;		MOVWF FSR
;Init1
;		clrf INDF
;		btfss FSR,3		; 8 octets
;		goto Init1

	CLRF	valx
	CLRF	valx+1
	CLRF	val1
	CLRF	val1+1
	CLRF	val2
	CLRF 	val2+1

Start
	BSF	PORTA,0		; pour debugging!
	movlw 	12		; CLS
	call 	Emet_Car
	call Send_CRLF
	movlw 'S'
	call 	Emet_Car
	movlw	'T'
	call 	Emet_Car
	movlw 'A'
	call 	Emet_Car
	movlw	'R'
	call 	Emet_Car
	movlw 'T'
	call 	Emet_Car
	movlw	':'
	call 	Emet_Car
	call Send_CRLF

	MOVLW 0		;adresse message (<255)
	CALL	TX_MSG
	call Send_CRLF
	call Wait1

Start1	
	 Movlw   75           	;Nb de lettres  visualiser
         Movwf   Temp2          ;
         Movlw 	 48	        ;lettre de depart  '0'
	 movwf	Temp4
     	 BCF 	PORTA,0		; pour debugging!
Start2
	movf 	Temp4,w	
	Call    Emet_Car
	movlw	D'50'
	Call	X_DELAY5    
	incf	Temp4,F
	incf	val1+1,F		; incremente MSB
	BTFSC	STATUS,Z	; si debordement LSB=0=256
	incf	val1,F		; incremente MSB
	incf	Temp4,F
	Decfsz  Temp2,F
	Goto     Start2

	BCF INTCON,GIE
	BSF PORTA,0  		; pour debugging!
	CALL Wait1
	call Send_CRLF

	clrf Cpt1
Start3
	movf Cpt1,w
	CALL read_EE
	incf Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Suite1  	
	CALL Emet_Car
	goto Start3
Suite1
	movlw EE1-EE0
	MOVWF Cpt1
Start4
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Suite2  	
	CALL Emet_Car
	goto Start4
Suite2
	
	clrf val2
	clrf val2+1
	clrf val3
	clrf val3+1

Suite3
	
	BCF INTCON,GIE	; interdit interruptions
	Call Send_CRLF

	movlw EE2-EE0
	MOVWF Cpt1
Start5
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Suite4  	
	CALL Emet_Car
	goto Start5
Suite4

; boucle d'attente en mode interruption
	BSF INTCON,GIE
	nop
	CALL Wait1
	CALL Wait1
	CALL Wait1
	BCF INTCON,GIE
	nop

	Call Send_CRLF
	movf val2,W
	movwf	val1
	movf val2+1,W
	movwf	val1+1
	call 	bcd5	; affiche nb de car recus OK
	movf valx,W
	movwf	val2
	movf valx+1,W
	movwf	val2+1
	movlw '/'
	call Emet_Car

	movf val3,W
	movwf	val1
	movf val3+1,W
	movwf	val1+1
	call 	bcd5	; Affiche Nb de car BAD !!
	movf valx,W
	movwf	val3
	movf valx+1,W
	movwf	val3+1

	movlw 'b'
	call Emet_Car
	movlw 'a'
	call Emet_Car
	movlw 'd'
	call Emet_Car
	Goto  Suite3

;---------------------------------------
Read_Char
	incf	val2+1,F	; incremente MSB
	BTFSC	STATUS,Z	; si debordement LSB=0=256
	incf	val2,F	
	MOVWF RCSTA			
	ANDLW 0x06		; bits d'erreur arms FERR=1? OERR=1?
	BTFSC STATUS,Z
	goto Read_Err
	MOVF RCREG,W
	MOVWF RsBuffer
	btfsc PORTB,0		; echo si bit RB0  zero
	Call Emet_Car
        Return                    

Read_Err
	BCF RCSTA,CREN
  	MOVF  RCREG,W
; incremente compteur errueur
	incf	val3+1,F	; incremente MSB
	BTFSC	STATUS,Z	; si debordement LSB=0=256
	incf	val3,F	
;--------------
;       MOVLW	MSG_ERR-MSG
;	call TX_MSG
; ---ou ----
;	BCF	PORTB,4
;	call Wait1
;	BSF	PORTB,4
;	call Wait1
;------------
	return
;---------------------------------------------

TX_MSG
	nop			; W contient le deplacement dans la table message
TX_1
	MOVWF	TX_INDEX	; sauve index message 
	CALL	MSG
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	TX_END  
	call Emet_Car
	MOVF	TX_INDEX, W	; Pointe sur car suivant
	ADDLW	1
	GOTO	TX_1
TX_END
	RETURN
;-----------------------------



Emet_Car
        bank0      ; envoi l'octet contenu dans W sur le port serie 
        movwf TXREG         ; on envoi l'octet sur le port serie
        bank1
	BTFSS TXSTA,TRMT    ; 1=buffer d'emission vide ?
	goto Emet_1
	bank0
        RETURN

Emet_1
	bank0 
 	incf OverCnt,F		; incremente compteur error transmission 
	BCF	PORTB,5
	MOVLW 10
	Call X_DELAY5
	BSF	PORTB,5
	MOVLW 10
	Call X_DELAY5
  	return

;----------------------------
SPint_RB0:
	BCF	T1CON,TMR1ON
	MOVWF	TMR1H
	MOVWF	val1
	MOVWF	TMR1L
	MOVWF	val1+1
	CLRF	TMR1H
	CLRF	TMR1L
	BSF 	T1CON,TMR1ON
	BCF 	INTCON,INTF
	return
;-----------------------------
MSG
		addwf	PCL ,F		;Jump to char pointed to in W reg
		retlw	d'13'
		retlw	d'10'
		retlw	'6'
		retlw	'2'
		retlw	'8'
		retlw	'-'
		retlw	'r'
		retlw	's'
		retlw	'0'
		retlw	'5'
		retlw	'.'
		retlw	'A'
		retlw	'S'
		retlw	'M'
		retlw	' '
		retlw	'P'
		retlw	'I'
		retlw	'C'
		retlw	'1'
		retlw	'6'
		retlw	'F'
		retlw	'6'
		retlw	'2'
		retlw	'8'
		retlw   ':'
		retlw	d'13'
		retlw	d'10'
		retlw 0
		nop
		nop
		nop
		nop
		nop
		nop

MSG_ERR
		retlw	d'13'
		retlw	d'10'
		retlw	'E'
		retlw	'r'
		retlw	'r'
		retlw	'e'
		retlw	'u'
		retlw	'r'
		retlw	' '
		retlw	'F'
		retlw	'R'
		retlw	'-'
		retlw	'O'
		retlw	'V'
		retlw	d'13'
		retlw	d'10'
MSG_END
		retlw	0

	IF ( (MSG_ERR & 0x0FF) >= (MSG_END & 0x0FF) )
		MESSG   "ATTENTION - definition de Table 'MSG deborde la page modulo 256 "
	ENDIF

;-------------------------------------
;boucle d'attente (Wait1) de 1Hz

Wait1   MOVLW   03h                    ; Loop 3
         MOVWF   TIME2
LOOP2   MOVLW   0xD8                   ; 1 bit= 0,0046Hz
         MOVWF   TIME1
LOOP1   CLRWDT
         MOVLW   0xFF                   ; Loop 0
         MOVWF   TIME
LOOP0   DECFSZ  TIME,1
         GOTO    LOOP0
         NOP                             ;to adjust the loop to 1.000 sec.
         DECFSZ  TIME1,1
         GOTO    LOOP1
         DECFSZ  TIME2,1
         GOTO    LOOP2
         RETURN                        ; Back
;---------------------------
DELAY500	MOVLW	D'165'	; +1		1 cycle
		MOVWF	DELAY1		; +2		1 cycle
DELAY500_L
		DECFSZ	DELAY1, F	; step 1	1 cycle
		GOTO	DELAY500_L	; step 2	2 cycles
		RETURN			; +3		2 cycles

X_DELAY5	
		MOVWF	DELAY2		; +1		1 cycle
X_DL5
		CALL	DELAY500	; step1		wait 500uSec
		DECFSZ	DELAY2, F	; step2		1 cycle
		GOTO	X_DL5		; step3		2 cycles
		RETURN			; +2		2 cycles
;---------------------------
; affichage octet --> decimal 5 digits ( de 0 a 65535 )
bcd5
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1

	swapf  val1,w	
	iorlw  0xf0
	movwf  mille 
	addwf  mille,f 
	addlw  0xE2 
	movwf  cent 
	addlw  0x32 
	movwf  un 
	movf   val1,w 
	andlw  0x0F 
	addwf  cent,f 
	addwf  cent,f 
	addwf  un,f 
	addlw  0xE9 
	movwf  dix 
	addwf  dix,f 
	addwf  dix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  dix,f 
	addwf  un,f 
	rlf    dix,f 
	rlf    un,f 
	comf   un,f 
	rlf    un,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  un,f 
	rlf    mille,f 
	movlw  0x07 
	movwf  dixmil 
        movlw  0x0A
Lb1: 	addwf  un,f 
	decf   dix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  dix,f 
	decf   cent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  cent,f 
	decf   mille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  mille,f 
        decf   dixmil,f 
	btfss  STATUS,C
        goto   Lb4 
	movf   dixmil,w
	addlw  '0'
	call   Emet_Car
	movf   mille,w
	addlw  '0'
	call   Emet_Car
	movf   cent,w
	addlw  '0'
	call   Emet_Car
	movf   dix,w
	addlw  '0'
	call   Emet_Car
	movf   un,w
	addlw  '0'
	call   Emet_Car
	movlw	' '
	call Emet_Car

	movf valx,w
	movwf val1
	movf valx+1,w
	movwf	val1+1
	return

; ******************** EE write routine ************************
; see data sheet for full explanation on EEPROM programming operation

write_EE
	bsf     STATUS,RP0     	;page 1
	movlw   0x55            ;do write seq.
	movwf   EECON2          ;       /
	movlw   0xaa            ;      / 
	movwf   EECON2          ;     /  
	bsf     EECON1,WR       ;initiate write
wo1     
	btfsc   EECON1,WR       ;write complete?
	goto    wo1             ;no then keep checking
	bcf     STATUS,RP0     	;pg 0
	return

read_EE	
	bsf     STATUS,RP0     	; bank 1
	movwf   EEADR           ; defini offset addresse
	bsf     EECON1,RD       ; mode lecture
	movf    EEDATA,W       	; recupere lecture
	bcf     STATUS,RP0     	; bank 0
	return
; ---------------

Send_CRLF
     	Movlw   13
     	Call    Emet_Car
	Movlw   10
     	Call    Emet_Car
	return


	ORG EEPROM
	;"1234567890123456"
EE0 DT "Pic Rouge 23/10/02",10,13,0
EE1 DT "Version 628_rs05.asm  ",10,13,0
EE2 DT "Attente clavier: ",0
         END
