; programme de TEST subroutines ou morceaux de programme
; routine LCD 2lignes de 8 car  6 bits I/O : PortB 7 6 5 4 et PortA  0 1
; inclus routine delai4m.inc @4MHz
; programme simple pour decoder/ lire Telecommande Infrarouge Marantz 5200
;*******************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************
#define miniSimDE	
	
	ifdef miniSimDE
		p=16F84

;==========================================================================

;       Register Definitions

;==========================================================================

W                            EQU     H'0000'
F                            EQU     H'0001'

;----- Register Files------------------------------------------------------

INDF                         EQU     H'0000'
TMR0                         EQU     H'0001'
PCL                          EQU     H'0002'
STATUS                       EQU     H'0003'
FSR                          EQU     H'0004'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
EEDATA                       EQU     H'0008'
EEADR                        EQU     H'0009'
PCLATH                       EQU     H'000A'
INTCON                       EQU     H'000B'

OPTION_REG                   EQU     H'0081'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'
EECON1                       EQU     H'0088'
EECON2                       EQU     H'0089'

;----- STATUS Bits --------------------------------------------------------

IRP                          EQU     H'0007'
RP1                          EQU     H'0006'
RP0                          EQU     H'0005'
NOT_TO                       EQU     H'0004'
NOT_PD                       EQU     H'0003'
Z                            EQU     H'0002'
DC                           EQU     H'0001'
C                            EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------

GIE                          EQU     H'0007'
EEIE                         EQU     H'0006'
TOIE                         EQU     H'0005'
INTE                         EQU     H'0004'
RBIE                         EQU     H'0003'
TOIF                         EQU     H'0002'
INTF                         EQU     H'0001'
RBIF                         EQU     H'0000'

;----- OPTION Bits --------------------------------------------------------

NOT_RBPU                     EQU     H'0007'
INTEDG                       EQU     H'0006'
TOCS                         EQU     H'0005'
TOSE                         EQU     H'0004'
PSA                          EQU     H'0003'
PS2                          EQU     H'0002'
PS1                          EQU     H'0001'
PS0                          EQU     H'0000'

;----- EECON1 Bits --------------------------------------------------------

EEIF                         EQU     H'0004'
WRERR                        EQU     H'0003'
WREN                         EQU     H'0002'
WR                           EQU     H'0001'
RD                           EQU     H'0000'

;==========================================================================

;       RAM Definition

;==========================================================================

        __MAXRAM H'CF'
        __BADRAM H'07', H'50'-H'7F', H'87'

;==========================================================================

;       Configuration Bits

;==========================================================================

_CP_ON                       EQU     H'000F'
_CP_OFF                      EQU     H'3FFF'
_PWRTE_ON                    EQU     H'3FF7'
_PWRTE_OFF                   EQU     H'3FFF'
_WDT_ON                      EQU     H'3FFF'
_WDT_OFF                     EQU     H'3FFB'
_LP_OSC                      EQU     H'3FFC'
_XT_OSC                      EQU     H'3FFD'
_HS_OSC                      EQU     H'3FFE'
_RC_OSC                      EQU     H'3FFF'
;=============

EEPROM EQU 0x2100
#define bank0	bcf STATUS,RP0
#define bank1     bsf STATUS,RP0

	ELSE

		ERRORLEVEL -302
		Processor  16F84
        include <..\COMMON\p16f84_.inc>
	ENDIF
	
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************
RESET_V        	EQU     0x0000  ; Address of RESET Vector
ISR_V          	EQU     0x0004  ; Address of Interrupt Vector
;OSC_FREQ      	EQU     4000000 ; Oscillator Frequency is 4 MHz Quartz
OSC_FREQ       	EQU     3580000 ; Oscillator Frequency is 3.58MHz Cermique resonator
; afficheur LCD en mode 4 bits
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA	EQU PORTB	; LCD DATA 11,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL	EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
;                                 LCD 0V   1
;                                 LCD +5V  2
	IFDEF minisimDE
LCD_E       	EQU 2		; LCD: 6 de commande de controle de l'afficheur
LCD_RW         	EQU 1		; LCD: 5 de Lecture/Ecriture de l'afficheur
LCD_RS         	EQU 0		; LCD: 4 de selection de l'afficheur-> RA0
	else
LCD_E          	EQU 1		; LCD: 6 de commande de controle de l'afficheur
LCD_RS         	EQU 0		; LCD: 4 de selection de l'afficheur-> RA0
;RW forc  ZERo		; LCD: 5 de Lecture/Ecriture de l'afficheur

	endif
LINE1          	EQU  0x080   ; Set display to line 1 character 0
LINE2          	EQU  0x0C0   ; Set display to line 2 character 0

;-----------------------

#define	CLCK 	PORTB,3	;OUT ->  1  AD7715  SCLCK 
#define	DRDY	PORTB,2	;IN  <-	12  AD7715  /DRDY
#define	DOUT    PORTB,1	;IN  <-	13  AD7715  DOUT
#define	DIN 	PORTB,0	;OUT -> 14  AD7715  DIN
#define CS     	PORTA,3	;OUT ->	 4  AD7715  CS
#define SERIAL_TX  PORTA,4 ; ->trans 11 du Max232 (RS232)
; +5V 	------------------->     5  AD7715  Reset
; +5V 	------------------->  	 6  AD7715  AVdd
; +5V 	------------------->  	15  AD7715  DVdd
; 0v 	------------------->	16  AD7715  DGnd
; 0v 	------------------->	11  AD7715  AGnd
; 0V	------------------->	 8  AD7715  AIn(-)
; 0V	------------------->	10  AD7715  Ref(-)
; LT1009 2,05V	----------->	 9  AD7715  Ref(+)
; ANA input	----------->	 7  AD7715  AIn(+)

#define  out_RS232	bsf drapeau,2
#define  out_LCD	bcf drapeau,2
;---------------

	IFDEF minisimDE
#DEFINE	RAMstart   0x0C		; pour 16F84
IndexP          EQU 	RAMstart
Cpt1            EQU 	RAMstart+1     ; A counter, used multiple places
count1          EQU	RAMstart+2
count2          EQU	RAMstart+3
count3          EQU	RAMstart+4
LCDtmp          EQU	RAMstart+5
LCDtmp1         EQU	RAMstart+6
; variable pour convertion binaire --> BCD 16bits
bdixmil         EQU 	RAMstart+10
bmille          EQU 	RAMstart+11
bcent		EQU 	RAMstart+12
bdix		EQU 	RAMstart+13
bun		EQU 	RAMstart+14
btmp		EQU 	RAMstart+15
; variables pour calcul 16 bits
valx		EQU 	RAMstart+16 
val1		EQU 	RAMstart+18  ; MSB puis LSB
val2		EQu	Ramstart+20
AdcNow	        EQU	RamStart+22    
Moyenne	        EQU	RamStart+24
CptV            EQU	RamStart+26
;---
TREG           EQU	RamStart+28
RCount         EQU	RamStart+29
RBuffer        EQU	RamStart+30
ECount         EQU	RamStart+31
EBuffer        EQU	RamStart+32
CCount         EQU	RamStart+33
CBuffer        EQU	RamStart+34
AdcLSB         EQU	RamStart+35
drapeau        EQU     RAMstart+36
result         EQU    RAMstart+37
valeur  EQU    RAMstart+39
ADR_HI  EQU     RAMstart+40
ADR_LO  EQU     RAMstart+41
Serie   EQU     RAMstart+42
        
;drapeau:2= choix output 1=Rs232 0=LCD
;drapeau:1=1 format XXXX.X   
;drapeau:0 pour effacer zero inutile

LastRam EQU     RAMstart+44

	else
	 cblock     0x0C
IndexP  
Cpt1   
count1  
count2  
count3 
LCDtmp  
LCDtmp1  
; variable pour convertion binaire --> BCD 16bits
bdixmil  
bmille     
bcent	
bdix	
bun	
btmp

; variables pour calcul 16 bits
CptV:2   
valx:2	
val1:2		
val2:2	
result :2	
AdcNow:2	  
Moyenne:2
TREG	
RCount 
RBuffer  
ECount   
EBuffer 
CCount  
CBuffer 
drapeau   
AdcLSB 
;drapeau:3= affichage nombre sur LCD 1=5 digit 0=3 digits
;drapeau:2= choix output 0=Rs232 1=LCD
;drapeau:1=1 format XXXX.X   
;drapeau:0 pour effacer zero inutile
LastRam  
	endc
	endif

	IF ( (LastRam) > 0x4F )
		ERROR   "Attention debordement zone RAM"
	ENDIF
;**************************************************************
; Program start
;**************************************************************
	ORG     RESET_V                 ; RESET vector location
RESET   
	GOTO    DEBUT
;**************************************************************
; This is the Periperal Interrupt routine. Should NOT get here
;**************************************************************
	ORG     ISR_V                   ; Interrupt vector location
INTERRUPT       BCF     STATUS, RP0     ; Select bank 0
                nop
                nop
		GOTO    INTERRUPT

;=============================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=============================================================================

TABLE_ST       
	  IFDEF miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
          ENDIF
               MOVWF  PCL  
          
MSG_InitAD 
		RETLW   'I'
                RETLW   'N'
		RETLW   'I'
		RETLW   'T'
		RETLW   ' '
		RETLW   'A'
		RETLW   'D'
                RETLW   'C'
                 RETLW   ' '
		RETLW   0x00

MSG_TREG
                RETLW   'T'
		RETLW   'R'
		RETLW   'E'
		RETLW   'G'
		RETLW   '='
		RETLW   0x00
                            
MSG_OK      
		RETLW   ' '
                RETLW   'O'
		RETLW   'K'
		RETLW   0x00
MSG_PB        
		RETLW   ' '
                RETLW   'B'
		RETLW   'A'
		RETLW   'D'
		RETLW   '.'
		RETLW   0x00
MSG_AutoCal      
                RETLW   'A'
                RETLW   'U'
		RETLW   'T'
                RETLW   'O'
                RETLW   '-'
                RETLW   'C'
                RETLW   'A'
                RETLW   'L'
		RETLW   0x00
		
MSG_Normal      
                RETLW   'N'
                RETLW   'O'
		RETLW   'R'
                RETLW   'M'
                RETLW   'A'
                RETLW   'L'
		RETLW   0x00
		
MSG_Mesure      
                RETLW   'M'
                RETLW   'E'
		RETLW   'S'
		RETLW   '='
		RETLW   0x00
MSG_NB
                RETLW   'N'
		RETLW   'B'
		RETLW   '='
		RETLW   0x00

MSG_mV      
                RETLW   'M'
                RETLW   'V'
		RETLW   0x00


MSG_Pts    
                RETLW   'P'
                RETLW   'T'
		RETLW   'S'
		RETLW   0x00
;*****************************************************************************
; Initialize processor registers
;*****************************************************************************
DEBUT:                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB

		CLRF	valx             ;MSB
		CLRF	valx+1           ;LSB
		CLRF	val2             ;MSB
		CLRF	val2+1           ;LSB
		CLRF	val1
		CLRF	val1+1
		CLRF 	AdcNow
		CLRF	AdcNow+1
		CLRF	CptV
		CLRF	CptV+1
		CLRF	drapeau
	
		bank1
        	MOVLW   0x00           ;all outputs
        	MOVWF   TRISA
		MOVLW   0x06           ; RB-7-6-5-4-3-0 =outputs  RB-1-2= inputs
		MOVWF   TRISB
		MOVLW	0x07    	; Option register setup:
					; RB Pullups
					; TMR0 fed from internal clock
					; Assign prescaler to TMR0
					; use 1/256 prescaling ratio
		MOVWF	OPTION_REG

		bank0
		CALL    LCD_Init         ; Initialize LCDisplay
		
;============================
Pres

		call LCD_Cls
		clrf Cpt1
		MOVLW	LINE1	;
		CALL	LCD_Cde		; Set to first line
Pres1
      		movf Cpt1,w
		CALL read_EE
		incf Cpt1,f
		ANDLW	0x0FF		; test sur (W)
		BTFSC	STATUS, Z	; zero= fin de message ?
		GOTO	Pres2  
		Call LCD_Putchar
 		goto Pres1
Pres2	
		MOVLW	LINE1			;
		CALL	LCD_Cde		; Set to first line
		movlw EE1-EE0
		MOVWF Cpt1
Pres3
		movf Cpt1,w
		CALL read_EE
		incf	Cpt1,f
		ANDLW	0x0FF		; test sur (W)
		BTFSC	STATUS, Z	; zero= fin de message ?
		GOTO Pres4  	
		call LCD_Putchar
		goto Pres3
Pres4
      		call delay_2_5s
	
		call LCD_Clear1
		MOVLW	LINE1			;
		CALL	LCD_Cde		; Set to first line
		movlw EE2-EE0
		MOVWF Cpt1
Pres5
		movf Cpt1,w
		CALL read_EE
		incf	Cpt1,f
		ANDLW	0x0FF		; test sur (W)
		BTFSC	STATUS, Z	; zero= fin de message ?
		GOTO	Pres6  	
		call LCD_Putchar
		goto Pres5
Pres6

      		call delay_2_5s
		call LCD_Clear1

		MOVLW   LINE1
		CALL    LCD_Cde       
		MOVLW   MSG_InitAD      ; Point to Command messag
		CALL    TABLE_MSG       ; Display the message
   
      		call InitAD7715
      		call delay_1s
		
		call LCD_Clear1
		MOVLW   LINE1
		CALL    LCD_Cde         
		MOVLW   MSG_TREG    
		CALL    TABLE_MSG   
		
		Call Lecture_Reg
		movf TREG,W
		call bcd3
		movf TREG,W		; test TREGister doit etre null
		andlw 0xFF
		btfss STATUS,Z
		goto Pres7
		MOVLW   MSG_OK
		goto Pres8
Pres7
		MOVLW   MSG_PB          ; Point to Command message
Pres8
		CALL    TABLE_MSG       ; Display the message
     		call delay_1s
		
		call AutoCalibration
  		
		call LCD_Clear1
		MOVLW   LINE1
		CALL    LCD_Cde       
		MOVLW   MSG_AutoCal    
		CALL    TABLE_MSG      
		call delay_1s
		
		call LCD_Clear1
		MOVLW   LINE1
		CALL    LCD_Cde       
		MOVLW   MSG_Normal    
		CALL    TABLE_MSG      
		call delay_1s	
	
                clrf ADR_LO
                CLRF ADR_HI
                CLRF Serie
                CLRF Serie+1
Boucle_ICI		


        	call LCD_Clear1
		MOVLW   LINE1
		CALL    LCD_Cde         
		MOVLW   MSG_Mesure      
		CALL    TABLE_MSG 
	
;#define  valeur 2049                    ; simulation AD7715
 ;               movlw valeur >> 8       ; MSB
 ;               movwf AdcNow
 ;               movlw valeur % 256      ; LSB
 ;               movwf AdcNow+1
                movf valeur,W
                movwf AdcNow
                movF valeur+1,W      ; LSB
                movwf AdcNow+1

    ;test compteur pour eprom
                movlw 64
        	movwf val2+1
        	clrf val2
	       movf   val2,w		; addition 16 bits
	       addwf  ADR_HI,f		
        	movf   val2+1,w
	       addwf  ADR_LO,f
	       btfsc  STATUS, C
	       incf   ADR_HI,f

	       movf ADR_HI,w   
	       movWf val1      ;MSB
	       movf ADR_LO,w
	       movWf val1+1    ;LSB
    		call bcd5V            ; affiche value 16 bits
		MOVLW   LINE1+10
		CALL    LCD_Cde     
                MOVLW   MSG_Pts    
		CALL    TABLE_MSG   
	        call delay_2_5s


                incf Serie+1,f
        	btfsc STATUS,Z
        	incf Serie,f
        
        	call LCD_Clear2
		MOVLW   LINE2
		CALL    LCD_Cde         
		MOVLW   MSG_Mesure      
		CALL    TABLE_MSG 
	
                movf Serie,w	 ;MSB
		movwf val1
            	movf Serie+1,w	 ; LSB
		movwf val1+1
		call bcd5V

	        movlw 2
        	andwf Serie,w          ; MSB=2 ?
        	btfsc STATUS,Z		; 512 . 64x512=32768 octets

	       goto Boucle_ICI








; 65536 / 32 = 2048  si ref =2,048V affichage 2.048xx
; xx en 1/32 de mV 
; affichage en 1/100em de mV
; 32000 pts -> 1000.00mV

                clrf AdcLSB                
                movlw 5
                movwf Cpt1
div_32
  		bcf STATUS,C
                rrf AdcNow,F            ;HSB   
                RRF AdcNow+1,F          ;MSB
	        RRF AdcLSB              ;LSB
                decfsz Cpt1,f
                goto div_32
          
       		movf AdcNow,w	 ;MSB
		movwf val1
            	movf AdcNow+1,w	 ; LSB
		movwf val1+1
		call bcd5V
		movlw '.'
		call LCD_Putchar
; pour test valeur reste      
;              movf AdcLSB,W
;              call bcd3
;		call delay_2_5s
;	        call LCD_Clear1
        	MOVLW   LINE2+10
		CALL    LCD_Cde     
               ; reste ramn en % de mV 
               ; reste *100 /256
                clrf val1
                clrf val2
                movlw 100
                movwf val1+1
                movf AdcLSB,W
        	movwf val2+1
                call mult16

                movlw 8
                movwf Cpt1
div_256
  		bcf STATUS,C
                rrf val1,F            ;HSB   
                RRF val1+1,F          ;MSB
                decfsz Cpt1,f
                goto div_256
                bsf drapeau,3
                movf val1+1,W
		call bcd3
                bCf drapeau,3
		MOVLW   LINE2+13
		CALL    LCD_Cde     
                MOVLW   MSG_mV    
		CALL    TABLE_MSG   
		call delay_2_5s



;------------------------------------------------------------
;               goto strap1
;		call LCD_Clear1
		MOVLW   LINE1+10
		CALL    LCD_Cde         
		MOVLW   MSG_NB      
		CALL    TABLE_MSG    
            	INCF	CptV+1,F	        ; incremente LSB
		BTFSC	STATUS,Z	; si debordement LSB=0=256
		incf	CptV,F	; incremente MSB
	
		;16 bit subtraction with borrow   Rudy Wieser
		movf CptV,w	
		movwf val1
	      	movf CptV+1,w	
		movwf val1+1
		movlw 1000 >> 8	; MSB
		movwf val2
		movlw 1000 % 256	; LSB
		movwf val2+1
		
		movf    val2+1,W		; source
	        subwf   val1+1,F		; dest
        	movf    val2,W
	        btfss   STATUS,C
	        incfsz  val2,W
	        subwf   val1,F		;dest = dest - source, WITH VALID CARRY
                btfss STATUS,C
                goto B_1
        ;turn over 999 donc RAZ
                clrf CptV
                CLRF  CptV+1
B_1        
        	movf CptV,w	
		movwf val1
	      	movf CptV+1,w	
		movwf val1+1
                bsf drapeau,3
;		call bcd5V
                bCf drapeau,3
strap1:	
		call delay_10ms 
		goto Boucle_ICI

	
;*****************************************					
; Sous-programmes specifiques AD7715  
;*****************************************
Envoie_Cde
	bcf CS
	movwf	EBuffer
       	bsf 	CLCK
	Movlw      8            ;correspond  un byte de 8 bits
       	Movwf      ECount     ;place dans RCount
Envoie_1 
        Bcf      CLCK
	nop
       	BCF STATUS,C
        Rlf     EBuffer,F  ;shift gauche dans carry
        Btfsc   STATUS,C    ;si carry 0 alors saute
        Goto    Envoie_2         ;carry =1
        BCF     DIN
        Goto    Envoie_3
Envoie_2 
        BSF     DIN
Envoie_3 
	nop
        BSF     CLCK  
 	nop
        Decfsz   ECount,F   ;ECount =ECount -1
        Goto     Envoie_1
	nop
	bsf 	CLCK
	nop
	bsf CS
     	return
;----------------
mult16	clrf   result		; multiplication 16 bits
	clrf   result+1		; val1 = val1 * val2
	movlw  16
	movwf  count1
mult161	rrf    val1,f
	rrf    val1+1,f
	btfss  STATUS,C
	goto   mult162
	movf   val2,w
	addwf  result,f
	movf   val2+1,w
	addwf  result+1,f
	btfsc  STATUS,C
	incf   result,f
mult162	bcf    STATUS,C
	rlf    val2+1,f 
	rlf    val2,f
	decfsz count1,f
	goto   mult161
fin16	
       movf   result,w
	movwf  val1
	movf   result+1,w
	movwf  val1+1
	return

;-------------------
microdelai
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	return
	
;-----------------------
InitAD7715
; 32 bits  1 et 8 bits  0 -> TREG
	movlw 0x20
	call Envoie_Cde
	movlw 0xFF
	call Envoie_Cde
	movlw 0x20
	call Envoie_Cde
	movlw 0xFF
	call Envoie_Cde
	movlw 0x20
	call Envoie_Cde
	movlw 0xFF
	call Envoie_Cde
	movlw 0x20
	call Envoie_Cde
	movlw 0xFF
	call Envoie_Cde
	movlw 0x20
	call Envoie_Cde
	movlw 0x00
	call Envoie_Cde
 	return

;----------------------------------
AutoCalibration
	movlw 0x10		; acces reg SETUP en ecriture
	call Envoie_Cde
	movlw 0x44		; setup =Autocal Unipolar
	call Envoie_Cde
;	movlw 0x10		;  acces reg SETUP en ecriture
;	call Envoie_Cde
;	movlw 0x04		; setup= Normal Unipolar
;	call Envoie_Cde
	return
;----------------------------
Lecture_AD7715

 	clrf AdcNow
	clrf AdcNow+1
	bsf CLCK
	movlw 0x38		; mode lecture DATA 16 bits
	call Envoie_Cde
	call delay_1ms
	bcf CS			; /CS=0=chip select ON
	nop
	movlw 8			; MSB
	movwf	RCount
Lect_4
	bcf CLCK		; clk =0
	call microdelai
   	bcf STATUS,C		; C=0
   	nop
 	btfsc DOUT		; lecture Bit data
	bsf STATUS,C		; C=1
	RLF AdcNow,F 	 	; rotation  gauche via carry
 	bsf CLCK		; clk =1
	call microdelai
	Decfsz RCount,F  	
        Goto Lect_4

	movlw 8			; LSB
	movwf	RCount
Lect_5
	bcf CLCK		; clk =0
	call microdelai
 	bcf STATUS,C		; C=0
	nop
	btfsc DOUT		; lecture Bit data	
	bsf STATUS,C		; C=1
	RLF AdcNow+1,F  	; rotation  gauche via carry
	bsf CLCK		; clk =1
	call microdelai
 	Decfsz RCount,F 		
        Goto Lect_5
  	bsf CS
	return
;-------------------------------
Lecture_Reg
	movlw 0x28
	bcf CS			; /CS=0=chip select ON
	nop
	clrf TREG
	movlw 8			; LSB
	movwf	RCount
Lecture_2
	bcf CLCK               ; clock=0
	call microdelai
 	bcf STATUS,C           ; C=0
	btfsc DOUT	
	bsf STATUS,C           ; C=1
	RLF TREG,F             ; rotation  gauche via carry
	bsf CLCK		; clk =1
	call microdelai
	Decfsz RCount,F
       Goto Lecture_2
       	bsf CLCK
       	nop
       	bsf CS			; /CS=1=chip select OFF
       	return


;**************************************************************
; Envoi de message via table de message dans la zone programme
;**************************************************************
TABLE_MSG
		MOVWF   Cpt1         ; Point to the first char. we want
LOOP_WR         
		MOVF   Cpt1,W         ; Renew the pointer
		CALL    TABLE_ST        ; Initiate table lookup
		XORLW   0x00            ; Is this the terminating char?
		BTFSC   STATUS,Z
		GOTO    END_WR
		CALL    LCD_Putchar      ; Actually put the char on display
		INCF    Cpt1,f	; Point to the next char
		GOTO    LOOP_WR         ; Do next character
END_WR
		RETURN
;=========================
; rev 24 juill 05 ldc4d.inc rajout tempo dans init
;pour LCD 1 ligne de 16car
;-----------------

LCD_Cls  
	movlw	D'01'			; effacage de l'ecran
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Clear1				; effacage de la 1ere ligne
	movlw	D'16'			
	movwf	LCDtmp1
	movlw	LINE1			; 0x80
	call	LCD_Cde
	call	delay_2_5ms

LCDc111
	movlw	' '
	call	LCD_Putchar
	decfsz	LCDtmp1,f
	goto	LCDc111
LCD_Line1
	movlw	LINE1
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Clear2				; effacage de la deuxieme ligne
	movlw	D'16'		
	movwf	LCDtmp1
	movlw	LINE2
	call	LCD_Cde
	call	delay_2_5ms
LCDcl21
	movlw	' '
	call	LCD_Putchar
	decfsz LCDtmp1,f
	goto	LCDcl21
LCD_Line2
	movlw	LINE2
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Home
	movlw	D'02'
	call	LCD_Cde
	goto delay_2_5ms

LCD_Putchar
	bank0				; rajout 7/03/03 
	movwf	LCDtmp
	call	delay_1ms
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	IFDEF minisimDE
	bcf     LCD_CTRL, LCD_RW
	nop
	endif
	bsf     LCD_CTRL, LCD_RS
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call	delay_25us
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	nop
	bsf     LCD_CTRL, LCD_E
	call	delay_25us
	bcf     LCD_CTRL, LCD_E
	call	delay_25us
	return

LCD_Init
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bcf     LCD_CTRL, LCD_RS
	call 	delay_2_5ms
	IFDEF minisimDE
	bcf     LCD_CTRL, LCD_RW
	endif
	call 	delay_2_5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bank1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	bank0
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms		
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_100ms	; tempo remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           ; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCD_Cde
	movlw   0x008		; display off
	call    LCD_Cde
	movlw   0x00C		; display on (0x00C sans curseur, 0x00E avec , 0x00F clign. )
	call    LCD_Cde
	movlw   0x006
	
LCD_Cde
	movwf   LCDtmp
	call 	delay_100ms	; tempo remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	IFDEF minisimDE
	bcf     LCD_CTRL,LCD_RW
	nop
	ENDIF
	bcf     LCD_CTRL,LCD_RS
	nop
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	return
;-----------------------
;special pour routine d'attente 4800 bauds 
; .58 pour 4800 bauds  3.58MHz
; .67 pour 4800 bauds  4MHZ
delay_RS
        IF OSC_FREQ == 4000000 
          MOVLW  67      
        ENDIF
        IF OSC_FREQ == 3580000
           MOVLW  58      
        ENDIF
         MOVLW  58 
         MOVWF           count1	; 1000000/4800=208S    
         DECFSZ          count1,F	; 1 cycle si pas de saut
         GOTO            $-1		; 2cycles
         Return				; 2 cycles 


delay_RS_Half
        IF OSC_FREQ == 4000000 
          MOVLW  38     
        ENDIF
        IF OSC_FREQ == 3580000
           MOVLW  25      
        ENDIF
         MOVLW           25     ;  pour 4800 bauds  3.58MHz
         MOVWF           count1	; < 100S
         DECFSZ          count1,F 
         GOTO            $-1		
         Return			

;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------

delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   0x05
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
        
delay_200us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   40
                movwf   count3
                goto    delay1
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1
;-----------------------
; variable pour convertion binaire --> BCD 16bits
;bcent	EQU 	RAMstart+32
;bdix		EQU 	RAMstart+33
;bun		EQU 	RAMstart+34
;btmp		EQU 	RAMstart+35
;btmp1	EQU 	RAMstart+36
;val1		EQU 	RAMstart+37		; variable pour stockage valeur 16 bits
;val2		EQU 	RAMstart+39
;=====================================================================

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31

bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32

bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
        btfsc drapeau,3
        goto Only_99
	movf   bcent,w
	call LCD_Putchar
Only_99
	movf   bdix,w
	call LCD_Putchar
	movf   bun,w
	call LCD_Putchar
	return

; affichage word --> decimal 5 digits , de 0 a 65535 
; rev 9 sept 04  avec blanc sur les chiffres non significatifs utilise drapeau:0 
; et traitement special XXXX.X si drapeau:1=1
bcd5V   bCf drapeau,0
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1
	swapf  val1,w	
	iorlw  0xf0
	movwf  bmille 
	addwf  bmille,f 
	addlw  0xE2 
	movwf  bcent 
	addlw  0x32 
	movwf  bun 
	movf   val1,w 
	andlw  0x0F 
	addwf  bcent,f 
	addwf  bcent,f 
	addwf  bun,f 
	addlw  0xE9 
	movwf  bdix 
	addwf  bdix,f 
	addwf  bdix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  bdix,f 
	addwf  bun,f 
	rlf    bdix,f 
	rlf    bun,f 
	comf   bun,f 
	rlf    bun,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  bun,f 
	rlf    bmille,f 
	movlw  0x07 
	movwf  bdixmil 
        movlw  0x0A
Lb1: 	addwf  bun,f 
	decf   bdix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  bdix,f 
	decf   bcent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  bcent,f 
	decf   bmille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  bmille,f 
        decf   bdixmil,f 
	btfss  STATUS,C
        goto   Lb4 

        btfsc drapeau,3
        goto only_999
        


	movf   bdixmil,w
        BTFSC STATUS,Z
        BTFSC drapeau,0
        goto Lb40a
        movlw ' '
        goto Lb40b
Lb40a:  bsf drapeau,0
	addlw  '0'

Lb40b:  
	call LCD_Putchar
	movf   bmille,w
        BTFSC STATUS,Z
        BTFSc drapeau,0
        goto Lb41a
        movlw ' '
        goto Lb41b
Lb41a:  bsf drapeau,0
	addlw  '0'
Lb41b:  call LCD_Putchar  


only_999
	movf   bcent,w
        BTFSC STATUS,Z
        BTFSc drapeau,0
        goto Lb42a
        movlw ' '
        goto Lb42b
Lb42a:  bsf drapeau,0
	addlw  '0'
Lb42b:  call LCD_Putchar 

	movf   bdix,w
        BTFSC STATUS,Z
        BTFSc drapeau,0
        goto Lb43a
        BTFSC drapeau,1         ; affichage ..0.0 
        goto Lb43a
        movlw ' '
        goto Lb43b
Lb43a:  bsf drapeau,0
	addlw  '0'
Lb43b:  call LCD_Putchar  

        BTFSS drapeau,1       ; affichage ...0.0 
        goto Lb44             ; si drapeau ......X. = 1
	movlw	'.'             	; sinon ....0
	call LCD_Putchar
Lb44:	movf   bun,w
	addlw  '0'
 	call LCD_Putchar
;	movlw	' '
;   	call LCD_Putchar
	movf valx,w
	movwf val1
	movf valx+1,w
	movwf	val1+1
        BCF drapeau,1
	return
;---------
;Choix_Out
;        btfsC drapeau,2         ; si bit 2  zero choix=RS232 sinon LCD
;        goto Send_Char
;        goto  LCD_Putchar
  
;--------------
;Send_Char
;	 movwf	        CBuffer
;	 Movlw           8           ;correspond  un byte de 8 bits
;        Movwf           CCount         ;place dans RsCount
;         Bcf             SERIAL_TX       ;bit start  0
;         Call            delay_RS           ;wait valeur 1bit 4800 Bauds
;         Rrf             CBuffer,F        ;shift droite dans carry
;         Btfsc           STATUS,C        ;si carry 0 alors saute
;         Goto            $+3             ;carry =1
;         Bcf             SERIAL_TX       ;Tx =0
;         Goto            $+2
;         Bsf             SERIAL_TX       ;Tx =1
;         Call            delay_RS
;         Decfsz          CCount,F       ;RsCount =RsCount -1
;         Goto            $-8
;         Bsf             SERIAL_TX       ;bit de stop  1
;        Call            delay_RS           ;byte envoy
;  	return

;****************************************************************************		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture
	return


	ORG 0x2100
      ;"1234567890123456"
EE0 DT "16F84  3.58MHZ",0
EE1 DT "AD7715Li.asm  ",0
EE2 DT "LCD 84-9941 ",0  
EE3 DT "25 juillet 05 ",0
   

		END
