; version PICEmulateur
;rev 8 mars ..test choix sequence 
; rev 15 fev 03 .. essai sur valeurs Texter 10 fois plus grande pour filtrage exponentiel
; rev 14 fev 03 .. test Temp Exter negative
; 26/12/02
; LCD_tstz.asm 
; issu de LCD_08z.asm
; port B -> 8 lignes =DATA
; port A0,A1,A2 = CRTL
; 24 aout 2002

	include <p16f84_.inc>

define miniSimDE
ifdef miniSimDE
	p=16F84
#define processor p16F84
else
	ERRORLEVEL      -302
	Processor       16F84
endif
	Radix           DEC
	EXPAND

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
;***********************
;
; This program interfaces to a Hitachi HD77480-based LC-Display
; Currently a 4 line * 20 characters display module.
; This program assembles for an 8-bit data interface.
; See AN587 for 4-bit and 8-bit interfaces.
; Program	LCD.ASM
; Last update	96-01-12
; Author	Peter Ouwehand
;***********************
; Fosc		= 4MHz
; Cycle_time	= 1/Fosc / 4 = 1/(4*10^6) / 4	= 1uSec
;***********************

;***********************
; Equates, I/O, vars
;***********************
RESET_V	EQU	0x0000		; Address of RESET Vector
ISR_V		EQU	0x0004		; Address of Interrupt Vector
OSC_FREQ	EQU	D'4000000'	; Oscillator Frequency is 4 MHz

LCD_DATA		EQU	PORTB		; LCD data lines interface
LCD_DATA_TRIS	EQU	TRISB
LCD_CTRL		EQU	PORTA		; LCD control lines interface

LCD_LINE0	EQU	0x000
LCD_LINE1	EQU	0x040
LCD_LINE2	EQU	0x014
LCD_LINE3	EQU	0x054

; PORTA bits
LCD_E		EQU	2		; LCD Enable control line
LCD_RW	EQU	1		; LCD Read/Write control line
LCD_RS	EQU	0		; LCD Register-Select control line

; PORTB bits
DB7		EQU	7		; LCD dataline 7 (MSB)
DB6		EQU	6		; LCD dataline 6
DB5		EQU	5		; LCD dataline 5
DB4		EQU	4		; LCD dataline 4
DB3		EQU	3		; LCD dataline 3
DB2		EQU	2		; LCD dataline 2
DB1		EQU	1		; LCD dataline 1
DB0		EQU	0		; LCD dataline 0 (LSB)

FirstCar	EQU	'A'		; espace
KELVIN EQU 2730
Sel_Taccu	equ 	0	; voie 0
Sel_Tamb	equ	0x0010	; voie 1
Sel_Texter	equ 	0x0020	; voie 2
Sel_JN	equ 	0x0030	; voie 3
Sel_Aucun	equ 	0x00ff -(Sel_Tamb + Sel_Texter+ Sel_JN)

#define Relais_1  PORTA,4	; relais chauffage accumulateur 4Kw
#define Relais_2  PORTB,3	; relais Ventilos evacuation air chaud accumulateur

	ORG 0x020
LCD_TEMP	EQU	$		; LCD subroutines internal use
T1_INDEX	EQU	$+1		; Index to table1 strings
RsByte	EQU	$+2		; Index to table2 strings
sequence	EQU	$+3		; Index to table3 strings
COUNT		EQU	$+4		; A counter
DELAY		equ	$+5		; Used in DELAYxxx routines
X_DELAY	equ	$+6		; Used in X_DELAYxxx routines
Cpt1		equ	$+7
Cpt2		equ	$+8
Cpt3		equ	$+9
Cpt4		EQU	$+10
;---------------------
	ORG 0x20+11
	dummy		EQU $
	bcent		EQU $+1
	bdix		EQU $+2
	bun		EQU $+3
	btmp		EQU $+4
	btmp1		EQU $+5
	val1		EQU $+6	;2
	val2		EQU $+8	;2
	dixmil	EQU $+10
	mille		EQU $+11
	cent		EQU $+12
	dix		EQU $+13
	un		EQU $+14
	Special_MAE EQU $+15
	valx		EQU $+16	;2
	result	EQU $+18	;2
	
	Hi_Temp	EQU $+20
	Lo_Temp	EQU $+21
	Hi_Tst	EQU $+22
	Lo_Tst	EQU $+23
	count1	EQU $+24
	Selecteur	EQU $+25
	Drapeaux	EQU $+26
        ; Drapeaux de 8 bits  usage multiple
        ;	7	signe Temperature Exterieur 1=negatif
        ;	6
        ;	5
        ;	4
        ;	3
        ;	2
        ;	1	Traitement mesure Filtree
        ;	0	JOUR/NUIT 1=NUIT

	TN_Exter	EQU $+27
	TF_Exter	EQU $+29
	val3		EQU $+31
	reste		EQU $+33
	SommeTEX	EQU $+35


;EEPROM	EQU	0x2100

;***********************
; Program start
;***********************
	ORG	RESET_V			; RESET vector location
RESET		GOTO	START


;***********************
; This is the Periperal Interrupt routine. Should NOT get here
;***********************
	ORG	ISR_V			; Interrupt vector location
INTERRUPT	BCF     STATUS, RP0	; Select bank 0
		GOTO    INTERRUPT

;***********************
; Initialize processor registers
;***********************
START					; POWER_ON Reset (Beginning of program)
		CLRF	STATUS		; Do initialization, Select bank 0
		CLRF	INTCON		; Clear int-flags, Disable interrupts
		CLRF	PCLATH		; Keep in lower 2KByte

		CLRF	PORTA		; ALL PORT output should output Low.
		CLRF	PORTB

		BSF	STATUS, RP0	; Select bank 1
		MOVLW	0x0F8		; RA2-0 outputs, RA4-3 inputs
		MOVWF	TRISA
		MOVLW	0x000		; RB7-0 outputs
		MOVWF	TRISB
		BSF	OPTION_REG, NOT_RBPU
					; Disable PORTB pull-ups

		BCF	STATUS, RP0	; Select bank 0

Boucle:
		MOVLW	FirstCar
		MOVWF	Cpt1
		MOVLW	1		; was 13  *2=  26 majuscules alphabet 
		MOVWF	Cpt2
		clrf	Special_MAE
		CLRF	val1
		CLRF	val1+1
		CLRF	val2
		CLRF	val2+1
;preload 1650
		movlw (1650-(1650>>8)*256)  	; 0x72
		movwf	Lo_Tst
		movlw 1650 >>8 			; 0x06
		movwf Hi_Tst
; preload 2730
		movlw 0x0A
		movwf	Hi_Tst
		movlw 0x46
		movwf	Lo_Tst


Loop:

		movlw 'S'
		movwf RsByte
		clrf sequence
	


		CALL	LCDINIT		; Initialize LCDisplay
;------------------------
		;goto boucle3
;-------------------------

		MOVLW	0x030			; ASCII '0'
		MOVWF	COUNT
		MOVLW	LCD_LINE0
		CALL	LCDSDDA		; Position cursor leftmost on first line
		CALL	T1_MSG		; Display message
		MOVLW	LCD_LINE0 + 7
		CALL	LCDSDDA		; Position cursor
		MOVF	COUNT, W
		CALL	LCDPUTCHAR		; Display line number

		MOVLW	LCD_LINE0 + 10
		CALL	LCDSDDA
		movf	cpt1,w	
		CALL	LCDPUTCHAR
	

		MOVLW	LCD_LINE0 + 13
		CALL	LCDSDDA
		movf Cpt1,w	
		call Bcd3

; test pour sindds10.asm
NNN             movlw 30
                movwf dummy
NCOloop        	incf dummy,f
       	        MOVLW	LCD_LINE0 
		CALL	LCDSDDA
                movf dummy,w
		call Bcd3
                movf     dummy,W		; @ modif 10/09/04
            	subLw    35
                movWf Cpt1
            	btfsS    STATUS,Z
		goto  NCOLoop
 
                NOP
ToutDroit       NOP
                goto NNN



		incf Cpt1,F
		INCF	COUNT, F
		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		CALL	T1_MSG
		MOVLW	LCD_LINE1 + 7
		CALL	LCDSDDA
		MOVF	COUNT, W
		CALL	LCDPUTCHAR

		MOVLW	LCD_LINE1 + 10
		CALL	LCDSDDA
		movf	cpt1,w	
		CALL	LCDPUTCHAR
	;	incf Cpt1,F

		MOVLW	LCD_LINE1 + 12
		CALL	LCDSDDA
		movf Cpt1,w	
		movwf val1+1
		call bcd_temp
	
		decfsz Cpt2,f
		goto 	Loop

		call Tempo2s

		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		CALL Blankline

	
boucle2
		call LCDCLEAR
		goto strap1

		movlw 0x00		; T accu
		movwf Special_MAE	
		movlw 0
		movwf Selecteur
		movf portb,w
		andlw 255-24			; raz rb3 Rb4
		movwf portb

		movlw (1650-(1650>>8)*256)  	; 0x72
		movwf	val1+1
		movlw 1650 >>8 			; 0x06
		movwf	val1
		MOVLW	LCD_LINE0
		CALL	LCDSDDA
		CALL Blankline
		call Tempo2s
		MOVLW	LCD_LINE0
		CALL	LCDSDDA
		call	Affiche_Degres
		call Tempo2s

strap1	         
               

		movlw 0x01		; Text
		movwf Special_MAE	
		movlw 16
		movwf Selecteur
		movf portb,w
		andlw 255-24
		iorwf Selecteur,w
		movwf portb
	
; mesure ADC
		call Max187
	
	;movlw	0x0A		; 2630
	;movwf	val1
	;movlw 	0x46
	;movwf	val1+1
	
		call Max187		; simulation avec Hi_tst et Lo_tst
	
;mise  l'echelle mesure avec base= ZERO KELVIN 
		movlw (KELVIN >>8)	; 0A  
		movwf val2		; (msb)
		movlw (KELVIN-(KELVIN >> 8)*256)	; AA  
		movwf val2+1				; (lsb)
		call sub16				; val1=val1-val2

		btfss val1,7
		goto UpperZero
;cas negatif
		bsf	Drapeaux,7	; negative value
		comf val1,f
		comf val1+1,f
		incf val1+1,f	; complement  2
UpperZero
		movf val1,W
		movwf	TN_Exter
		movf val1+1,W
		movwf	TN_Exter+1

		MOVLW	LCD_LINE0
		CALL	LCDSDDA
		CALL Blankline
		MOVLW	LCD_LINE0
		CALL	LCDSDDA
		call	Affiche_Degres
		call Tempo2s
		goto strap3
	
; filtrage EXPONENTIEL
; K=0,125 soit 1/8   TF=TN*0.125 + TF(n-1)*(1-0.125)
		;TF(n-1)*7
		movlw 70
		movwf val2+1
		clrf val2
		movf TF_Exter,W
		movwf val1
		movf TF_Exter+1,W
		movwf val1+1
		call mult16		;val1=val1*val2  val1=TF*7
		movf val1,W		; sauvegarde intermediare
		movwf	val3
		movf val1+1,W
		movwf	val3+1	;val3=TF*7
		;TN*1
		movlw 1
		movwf val2+1
		clrf val2
		movf TN_Exter,W
		movwf val1
		movf TN_Exter+1,W
		movwf val1+1
		call mult16		;val1=val1*val2  val1=TN*1

		movf   val3,W	;addition 16 bits
		addwf  val1,f	
		movf   val3+1,W
		addwf  val1+1,f
		btfsc  STATUS, C
		incf   val1,f	;val1 = 7*TF + 1* TN

		movlw 8
		movwf val2+1
		clrf val2
		Call div16

		movf val1,W		; maj TF
		movwf	TF_Exter
		movf val1+1,W
		movwf	TF_Exter+1	; TF=(TN*1 + TF(n-1)*7):8

		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		CALL Blankline
		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		call	Affiche_Degres
strap3
;Filtrage Arithmetique
		movf TF_Exter,W
		movwf val2
		movf TF_Exter+1,W
		movwf val2+1
		movf TN_Exter,W
		movwf val1
		movf TN_Exter+1,W
		movwf val1+1
		call add16	
		movf val1,W
		movwf TF_Exter
		movf val1+1,W
		movwf TF_Exter+1
		incf SommeTEX,f
		movlw 60
		xorwf SommeTEX,w
		btfss STATUS,Z
		goto PasPret
	
		movlw 6
		movwf val2+1
		clrf val2
		Call div16

		bsf Drapeaux,1
		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		CALL Blankline
		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		call	Affiche_Degres
		bcf Drapeaux,7
		bcf Drapeaux,1
		clrf	SommeTEX
		clrf TF_Exter
		clrf TF_Exter+1

PasPret
		call Tempo2s



		btfsc Relais_2
		bcf Relais_2
		btfss Relais_2
		bsf Relais_2
		call Tempo2s


;		movlw 'S'
;		xorwf RsByte,W
;		btfsc STATUS,Z
;		goto aff_Seq


	
;		goto	boucle2

boucle3			; 08/03/03
;-----------------------

		movlw 5			; affiche message consigne ?
		xorwf RsByte,w
		btfss STATUS, Z	
		goto NotUpDown
		
		movlw 28			; up
		xorwf RsByte,w		;commande
		btfsc STATUS,Z
		goto UpConsigne
		
		movlw 29			; down
		xorwf RsByte,w		;commande
		btfsc STATUS,Z
		goto DownConsigne
	
NotUpDown

		nop
		movlw 0x2B			;43 droite
		xorwf RsByte,w		;commande
		btfsc STATUS,Z
		goto aff_Seq_D
	
		
		movlw 0x2C			; 44 gauche
		xorwf RsByte,w		;commande
		btfsc STATUS,Z
		goto aff_Seq_G

		clrf RsByte
		bsf Relais_1
;		bsf INTCON,INTE		; autorise interrupt RB0
		goto Boucle3

;----------------------
; sequencement  choix affichage (evolue de 0  8) 
; via touches < > telecde
;----------------------
aff_Seq_D	
		movf sequence,w
		sublw 7			;7-W positif ?
		btfss STATUS,C
		goto aff_S0
		incf sequence,f
aff_S0
	
		movf sequence,W
		clrf RsByte
		addwf PCL,F
		goto aff_Pres	;0
		goto aff_Heure	;1
		goto aff_ACCU	;2
		goto aff_TA		;3
		goto aff_TE		;4
		goto aff_TT		;5
		goto aff_Cons	;6
		goto aff_MAJRTC	;7
		goto aff_Debug	;8
		goto LostInSpace	
		goto Boucle3

;-----------------------
aff_Seq_G
		movf sequence,w
		sublw 1		; 1-W negatif ?
		btfsc STATUS,C
		goto aff_S0
		decf sequence,f
		goto aff_S0
		goto Boucle3


aff_Pres					;0
		nop
		goto boucle3
aff_Heure					;1
		nop
		goto boucle3
aff_ACCU					;2	
		nop
		goto boucle3
aff_TA					;3
		nop
		goto boucle3
aff_TE					;4
		nop
		goto boucle3
aff_TT					;5
		nop
		goto boucle3
aff_Cons					;6
		nop
		goto boucle3
aff_MAJRTC					;7
		nop
		goto boucle3
aff_Debug					;8
		nop
		goto boucle3
LostInSpace
		clrf RsByte
		clrf sequence
		goto Boucle3
	
UpConsigne			
		nop
		goto boucle3

DownConsigne
		nop
		goto boucle3


;--------------------------------------


Divise4				; mot val1= mot val1/4
		bcf STATUS,C	; carry=0
		rrf val1,F
		rrf val1+1,F	; division par 2 mot de 16bits
Divise2		
		bcf STATUS,C
		rrf val1,F
		rrf val1+1,F	; division par 2 mot de 16bits
		return



MemoMesure
	movf Hi_Temp,W
	movwf	val1
	movf Lo_Temp,W
	movwf	val1+1
	return

;=====================================
; Table message to display
;=====================================
MSG1
		addwf	PCL ,F		;Jump to char pointed to in W reg
		retlw	'L'
		retlw	'I'
		retlw	'G'
		retlw	'N'
		retlw	'E'
		retlw	' '
		retlw	'#'
		retlw	' '
		retlw	':'
		retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
MSG1_END
		retlw	0
;
	IF ( (MSG1 & 0x0FF) >= (MSG1_END & 0x0FF) )
		MESSG   "Warning - User Definded: Table 'MSG1' crosses page boundry in computed jump"
	ENDIF


MSG3
		addwf	PCL ,F		;Jump to char pointed to in W reg
		retlw	'C'
		retlw	'O'
		retlw	'M'
		retlw	'P'
		retlw	'T'
		retlw	' '
		retlw	'1'
		retlw	'6'
		retlw	'B'
		retlw	'= '
		retlw	'.'
		retlw	'.'
		retlw	'.'
		retlw	'.'
		retlw	'.'
		retlw	'.'
MSG3_END
		retlw	0
;
	IF ( (MSG3 & 0x0FF) >= (MSG3_END & 0x0FF) )
		MESSG   "Warning - User Definded: Table 'MSG3 crosses page boundry in computed jump"
	ENDIF



;***********************
; Send a message using a table to output a message
;***********************
T1_MSG
		MOVLW	0		; Startindex of table message
T1_1
		MOVWF	T1_INDEX	; Holds message address
		CALL	MSG1
		ANDLW	0x0FF		; Check if at end of message
		BTFSC	STATUS, Z	; (zero returned at end)
		GOTO	T1_END             
		CALL	LCDPUTCHAR	; Display character
		MOVF	T1_INDEX, W	; Point to next character
		ADDLW	1
		GOTO	T1_1
T1_END
		RETURN
;*************************
BlankLine
		movlw 16
		movwf	Cpt3
Blk1:		movlw	' '
		CALL	LCDPUTCHAR		
		decfsz Cpt3,f
		goto Blk1
		return
;***********************
; LCD Module Subroutines
;***********************
LCDINIT
; Initilize LC-Display Module	 Busy-flag is not yet valid
		CLRF	LCD_CTRL	; ALL PORT output should output Low.
		MOVLW	0x01E		; power-up delay
		CALL	X_DELAY500	; 30 * 0.5mS = 15mS
					; Busy Flag should be valid from here
		MOVLW	0x038		; 8-bit-interface, 2-lines
		CALL	LCDPUTCMD
		MOVLW	0x000		; disp.off, curs.off, no-blink
		CALL	LCDDMODE
		CALL	LCDCLEAR
		MOVLW	0x004		; disp.on, curs.off
		CALL	LCDDMODE
		MOVLW	0x002		; auto-inc (shift-cursor)
		CALL	LCDEMODE
		RETURN
;=========================
LCD_ENABLE
; Pulses LCD enable pin
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		RETURN
;=========================
LCDBUSY
; Returns when LCD busy-flag is inactive
		BSF	STATUS,RP0	; Select Register page 1
		MOVLW	0x0FF		; Set PORTB for input
		MOVWF	LCD_DATA_TRIS
		BCF	STATUS, RP0	; Select Register page 0
		BCF	LCD_CTRL, LCD_RS; Set LCD for command mode
		BSF	LCD_CTRL, LCD_RW; Setup to read busy flag
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		MOVF	LCD_DATA, W	; Read busy flag + DDram address
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		ANDLW	0x80		; Check Busy flag, High = Busy
		BTFSS	STATUS, Z
		GOTO	LCDBUSY
LCDNOTBUSY	BCF	LCD_CTRL, LCD_RW
		BSF	STATUS, RP0	; Select Register page 1
		MOVLW	0x000
		MOVWF	LCD_DATA_TRIS	; Set PORTB for output
		BCF	STATUS, RP0	; Select Register page 0
		RETURN
;=========================
LCDCLEAR
; Clears display and returns cursor to home position (upper-left corner).
		MOVLW	0x001
		CALL	LCDPUTCMD
		RETURN
;=========================
LCDHOME
; Returns cursor to home position.
; Returns display to original position (when shifted).
		MOVLW	0x002
		CALL	LCDPUTCMD
		RETURN
;=========================
LCDEMODE
; Sets entry mode of display.
; Required entry mode must be set in W
;  b0	: 0 = no display shift	1 = display shift
;  b1	: 0 = auto-decrement	1 = auto-increment
;  b2-7	: don't care
		ANDLW	0x003		; Strip upper bits
		IORLW	0x004		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
LCDDMODE
; Sets display control.
; Required display mode must be set in W
;  b0	: 0 = cursor blink off	1 = cursor blink on
;  b1	: 0 = cursor off	1 = cursor on
;  b2	: 0 = display off	1 = display on (display data remains in DDRAM)
;  b3-7	: don't care
		ANDLW	0x007		; Strip upper bits
		IORLW	0x008		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
LCDSCGA
; Sets Character-Generator-RAM address. CGRAM is read/written after this setting.
; Required CGRAM address must be set in W
;  b0-5	: required CGRAM address  b6-7	: don't care

		ANDLW	0x03F		; Strip upper bits
		IORLW	0x040		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
LCDSDDA
; Sets the Display-Data-RAM address. DDRAM data is read/written after
;  this setting.
; Required DDRAM address must be set in W
;  b0-6	: required DDRAM address,  b7	: don't care
		IORLW	0x080		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
LCDGADDR
; Returns address counter contents, used for both DDRAM and CGRAM.
; RAM address is returned in W
		BSF	STATUS,RP0	; Select Register page 1
		MOVLW	0x0FF		; Set PORTB for input
		MOVWF	LCD_DATA_TRIS
		BCF	STATUS, RP0	; Select Register page 0
		BCF	LCD_CTRL, LCD_RS; Set LCD for command mode
		BSF	LCD_CTRL, LCD_RW; Setup to read busy flag
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		MOVF	LCD_DATA, W	; Read busy flag + RAM address
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		ANDLW	0x07F		; Strip upper bit
		BCF	LCD_CTRL, LCD_RW
		BSF	STATUS, RP0	; Select Register page 1
		MOVLW	0x000
		MOVWF	LCD_DATA_TRIS	; Set PORTB for output
		BCF	STATUS, RP0	; Select Register page 0
		RETURN
;======================================
LCDPUTCHAR
; Sends character to LCD, Required character must be in W
		MOVWF	LCD_TEMP	; Character to be sent is in W
		CALL	LCDBUSY		; Wait for LCD to be ready
		BCF	LCD_CTRL, LCD_RW; Set LCD in read mode
		BSF	LCD_CTRL, LCD_RS; Set LCD in data mode
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		MOVF	LCD_TEMP, W
		MOVWF	LCD_DATA	; Send data to LCD
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		RETURN
;=====================================
LCDPUTCMD
; Sends command to LCD Required command must be in W
		MOVWF	LCD_TEMP	; Command to be sent is in W
		CALL	LCDBUSY		; Wait for LCD to be ready
		BCF	LCD_CTRL, LCD_RW; Set LCD in read mode
		BCF	LCD_CTRL, LCD_RS; Set LCD in command mode
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		MOVF	LCD_TEMP, W
		MOVWF	LCD_DATA	; Send data to LCD
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		RETURN
;=================================================

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bcent,w
	call   LCDPUTCHAR
	movf   bdix,w
	call   LCDPUTCHAR
	movf   bun,w
	goto   LCDPUTCHAR

;----------------------
Affiche_Degres
Aff0
	movf Selecteur,w	; choix message
Aff1	
	MOVWF Cpt1
Aff2
	movf Cpt1,w
	call read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	status,z	; zero= fin de message ?
	GOTO	Aff3  	
	call LCDPUTCHAR
	goto Aff2
Aff3
;	call Max187
;	movf Hi_Temp,W
;	movwf	val1
;	movf Lo_Temp,W
;	movwf	val1+1

	movlw 0xFF
	andwf Special_MAE,w	; traitement
	btfss status,z
	goto Aff4

;mise  l'echelle mesure Pt100
	movlw 50		; lo=50  decalage de zero
	movwf val2+1
	clrf val2
	call sub16		
	movlw 10
	movwf val2+1	;val2 16 bits =10
	clrf val2
	call mult16		; val1*10-> val1 
	bcf STATUS,C	; carry=0
	rrf val1,f
	rrf val1+1,f
	bcf STATUS,C
	rrf val1,f
	rrf val1+1,f		; division par 4 mot de 16bits
		
Aff4
	call 	bcd_temp
;	call cr_lf
	return
;-----------------

Max187
	;simulation
	movf Hi_Tst,W
	movwf Hi_Temp
	movwf val1
	movf Lo_Tst,W
	movwf Lo_Temp
	movwf val1+1
	return
	
;--------------------
; conv mot 16bits -->mv ou C
bcd_temp
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1
	swapf  val1,w	
	iorlw  0xf0
	movwf  mille 
	addwf  mille,f 
	addlw  0xE2 
	movwf  cent 
	addlw  0x32 
	movwf  un 
	movf   val1,w 
	andlw  0x0F 
	addwf  cent,f 
	addwf  cent,f 
	addwf  un,f 
	addlw  0xE9 
	movwf  dix 
	addwf  dix,f 
	addwf  dix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  dix,f 
	addwf  un,f 
	rlf    dix,f 
	rlf    un,f 
	comf   un,f 
	rlf    un,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  un,f 
	rlf    mille,f 
	movlw  0x07 
	movwf  dixmil 
      movlw  0x0A
Lb1: 	addwf  un,f 
	decf   dix,f 
	btfss  status,c
	goto   Lb1 
Lb2:	addwf  dix,f 
	decf   cent,f 
	btfss  status,c
	goto   Lb2 
Lb3:	addwf  cent,f 
	decf   mille,f 
	btfss  status,c
	goto   Lb3 
Lb4:	addwf  mille,f 
      decf   dixmil,f 
	btfss  status,c
      goto   Lb4 
;	movf   dixmil,w
;	addlw  '0'
;	call   LCDPUTCHAR

	movlw ' '
	btfss Drapeaux,7		; negatif ?
	goto Lb41
	movlw  '-'
;	bcf Drapeaux,7
Lb41	call   LCDPUTCHAR

	movf   mille,w
	btfsc STATUS,Z
	goto Lb42
	addlw  '0'
	goto Lb43
Lb42	movlw ' '
Lb43 call   LCDPUTCHAR

	movf   cent,w
	addlw  '0'
	call   LCDPUTCHAR

	btfss Drapeaux,1
	goto Lb51
	movlw ','
	call LCDPUTCHAR
Lb51
	movf   dix,w
	addlw  '0'
	call   LCDPUTCHAR

	movlw 24
	xorwf Selecteur,w
	btfsc status,z
	goto Lb7

	btfsc Drapeaux,1
	goto Lb7
	movlw ','
	call LCDPUTCHAR
Lb7	movf   un,w
	addlw  '0'
	call   LCDPUTCHAR


	movlw 24
	xorwf Selecteur,w
	btfsc status,z
	goto Lb8
	

	movlw	'D'
	call LCDPUTCHAR
	movlw 'G'
	call LCDPUTCHAR
	return
Lb8
	movlw ' '
	call LCDPUTCHAR
	movlw ' '
	call LCDPUTCHAR
	return
	
;=====================================
; Delay_time	= ((DELAY_value * 3) + 4) * Cycle_time
; DELAY_value	= (Delay_time - (4 * Cycle_time)) / (3 * Cycle_time)
; i.e. (@ 4MHz crystal)
; Delay_time	= ((32 * 3) + 4) * 1uSec = 100uSec
; DELAY_value	= (500uSec - 4) / 3 = 165.33	= 165
;-------------------
DELAY500
	MOVLW	D'165'		; +1		1 cycle
	MOVWF	DELAY		; +2		1 cycle
DELAY500_LOOP
	DECFSZ	DELAY, F	; step 1	1 cycle
	GOTO	DELAY500_LOOP	; step 2	2 cycles
	RETURN			; +3		2 cycles
;
X_DELAY500	
	MOVWF	X_DELAY		; +1		1 cycle
X_DELAY500_LOOP
	CALL	DELAY500	; step1		wait 500uSec
	DECFSZ	X_DELAY, F	; step2		1 cycle
	GOTO	X_DELAY500_LOOP	; step3		2 cycles
	RETURN			; +2		2 cycles
;---------------------
add16	movf   val2,w		; addition 16 bits
	addwf  val1,f		; val1 = val1 + val2
	movf   val2+1,w
	addwf  val1+1,f
	btfsc  STATUS, C
	incf   val1,f
	return
;-------------------
sub16	movf   val2,w		; soustraction 16 bits
	subwf  val1,f		; val1 = val1 - val2
	movf   val2+1,w
	subwf  val1+1,f
 	btfss  STATUS,C
	decf   val1,f
	return
;-----------------------------
mult16	clrf   result		; multiplication 16 bits
	clrf   result+1		; val1 = val1 * val2
	movlw  16
	movwf  count1
mult161	rrf    val1,f
	rrf    val1+1,f
	btfss  STATUS,C
	goto   mult162
	movf   val2,w
	addwf  result,f
	movf   val2+1,w
	addwf  result+1,f
	btfsc  STATUS,C
	incf   result,f
mult162	bcf    STATUS,C
	rlf    val2+1,f 
	rlf    val2,f
	decfsz count1,f
	goto   mult161
	movf   result,w
	movwf  val1
	movf   result+1,w
	movwf  val1+1
	return
;--------------------
div16	clrf    reste		; division 16 bits
	clrf    reste+1		; val1 = val1 / val2       ( reste )
	movlw   16
	movwf   count
div161	rlf     val1+1,f
	rlf     val1,f
	rlf     reste+1,f
	rlf     reste,f
	movf    val2,w
	subwf   reste,W
	btfss   STATUS,Z
	goto    div162
	movf    val2+1,W
	subwf   reste+1,W
div162	btfss   STATUS,C
	goto    div163
	movf    val2+1,W
	subwf   reste+1,f
	movf    val2,W
	btfss   STATUS,C
	incfsz  val2,f
	subwf   reste,f
div163 	rlf     result+1,f
 	rlf     result,f
	DECFSZ  count,f     
	goto    div161
fin16	movf   result,w
	movwf  val1
	movf   result+1,w
	movwf  val1+1
	return
;--------------------
Tempo2s			; tempo 2.sec 
	movlw   4
	movwf   Dummy
tp2	call 	X_DELAY500
	decfsz  Dummy,f
	goto    tp2
	return
;----------------
read_EE	
	ifdef miniSimDE
	bank0	
	else
	bank1		; pour PIC16F628  only
	endif
	movwf   EEADR           ; defini offset addresse
	bank1
	bsf     EECON1,RD     ; mode lecture
   ifdef miniSimDE
	bank0
	else
	bank1
	endif
	movf    EEDATA,W       	; recupere lecture
	
	return

;------------------------

org EEPROM
EE0 DT "T ACCU=",0	; 8 cars !!
EE1 DT "T AMBI=",0
EE2 DT "T EXTE=",0
EE3 DT "TEST..=",0



	END				; End of program

