;rev 24/07/03
; impossible d'utiliser adressage indirect INDF sur zone data code , il faut que 
; ce soit situ dans la zone RAM ..limit  36 octets!!! 0x0C .. 0x2F
; version pour PICSIMULATOR miSimDe 22juil 03
; 85RC5LCD.asm  version Affichage LCD SEULEMENT      ex readrc7L.asm	
; inclu routine LCD 2lignes de 8 car  6 bits I/O : PortB 7 6 5 4 et PortA  0 1
; inclus routine delai4m.inc @4MHz
; programme simple pour decoder/ lire Telecommande Infrarouge Marantz 5200
;*******************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************
define miniSimDE
	include <p16f84_.inc>

	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************
RESET_V         EQU     0x0000          ; Address of RESET Vector
ISR_V           EQU     0x0004          ; Address of Interrupt Vector
OSC_FREQ        EQU     D'4000000'      ; Oscillator Frequency is 4 MHz

;	constantes a definir dans le programme principal:
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA	EQU PORTB	; LCD DATA 11,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL	EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
	ifdef miniSimDE
LCD_E		EQU 2		; LCD: Ligne de commande de controle de l'afficheur
LCD_RW	EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
LCD_RS	EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	else
LCD_E		EQU 1		; LCD: Ligne de commande de controle de l'afficheur
; LCD_RW	EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
LCD_RS	EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	endif

; PORTA bits
DATA_IN		EQU     4       ; Input data from IR pickup
; misc.
LINE1           EQU     0x080   ; Set display to line 1 character 0
LINE2           EQU     0x0C0   ; Set display to line 2 character 0


#DEFINE	RAMstart  0x0C			; pour 16F84

IndexP	EQU 	RAMstart
COUNT           EQU     RAMstart+1      ; A counter, used multiple places
DELAY           EQU     RAMstart+2      ; Used in DELAYxxx routines
X_DELAY         EQU     RAMstart+3      ; Used in X_DELAYxxx routines
TOGGLE          EQU     RAMstart+4      ; The RC5 Toggle bit
SYSTEM          EQU     RAMstart+5      ; The RC5 System word
COMND           EQU     RAMstart+6      ; The RC5 Command word
MZDATA          EQU     RAMstart+7      ; The RC5 extra Data word
POINTER         EQU     RAMstart+8	; Used in TABLE_MSG subroutine
ASCII_O         EQU     RAMstart+9      ; ASCII One's digit to print
ASCII_T         EQU     RAMstart+10     ; ASCII Ten's digit to print
ASCII_H         EQU     RAMstart+11     ; ASCII Hundred's digit to print
BIT_COUNT	EQU	RAMstart+12	; Counter for incoming bits
BYTE_COUNT	EQU	RAMstart+13	; Counter for buffer bytes
TEMP		EQU	RAMstart+14	; Used by ANALYSE to hold the 2-bit pattern
SERIAL_BUF	EQU	RAMstart+15	; Buffer for incoming bitstream
SERIAL_2	EQU	RAMstart+16
SERIAL_3	EQU	RAMstart+17
SERIAL_4	EQU	RAMstart+18
SERIAL_5	EQU	RAMstart+19
SERIAL_6	EQU	RAMstart+20
FIELD		EQU	RAMstart+21	; Temporary storage for field bit
ANALYSE_FLAGS	EQU	RAMstart+22	; DECODE returns its data in this
MZ_FLAG		EQU	RAMstart+23	; Set if there is an extra data word in the bitstream
LCDtmp		EQU	RAMstart+24
LCDtmp1		EQU	RAMstart+25
count1		EQU	RAMstart+26
count2		EQU	RAMstart+27
count3		EQU	RAMstart+28
Cpt1		EQU 	RAMstart+29
VOLUME		EQU 	RAMstart+30
; variable pour convertion binaire --> BCD 16bits
bcent		EQU 	RAMstart+31
bdix		EQU 	RAMstart+32
bun		EQU 	RAMstart+33
btmp		EQU 	RAMstart+34
btmp1		EQU 	RAMstart+35
LastRam        EQU      RAMstart+35

	IF ( (LastRam) > 0x2F )
		ERROR   "Attention debordement zone RAM"
	ENDIF
;**************************************************************
ONE		EQU	B'00000001'	; 2-bit incoming pattern matches
ZERO		EQU	B'00000010'
;**************************************************************
; Program start
;**************************************************************
	ORG     RESET_V                 ; RESET vector location
RESET           GOTO    DEBUT
;**************************************************************
; This is the Periperal Interrupt routine. Should NOT get here
;**************************************************************
	ORG     ISR_V                   ; Interrupt vector location
INTERRUPT       BCF     STATUS, RP0     ; Select bank 0
                nop
                nop
		GOTO    INTERRUPT

;=============================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=============================================================================

TABLE_ST      	
            ifdef miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
            endif
               MOVWF  PCL 
                            
MSG_T      ;     nop 	          <- autre solution rajouter un nop
            RETLW   'T'
		RETLW   'O'
		RETLW   'G'
		RETLW   '='
		RETLW   ' '
		RETLW   0x00
MSG_S           RETLW   'S'
		RETLW   'Y'
		RETLW   'S'
		RETLW   '='
		RETLW   ' '
		RETLW   0x00
MSG_C           RETLW   'C'
		RETLW   'M'
		RETLW   'D'
		RETLW   '='
		RETLW   ' '
		RETLW   0x00
MSG_V           RETLW   'V'
		RETLW   'O'
		RETLW   'L'
		RETLW   '='
		RETLW	0x00


CodeTouche
	addwf PCL,f
  	RETLW 13
  	RETLW 15
  	RETLW 16
 	RETLW 17
	RETLW 22	
	RETLW 23
	RETLW 28
  	RETLW 29
  	RETLW 63
  	RETLW 43
  	RETLW 44
  	RETLW 82	
  	RETLW 83	
  	RETLW 87
  	RETLW 0

#define MaxMsg 14		
LibelleTouche			; libelles sur 7 car + terminateur 0 => modulo 8 pour LCD
	addwf	PCL ,F
	retlw 'M'              ;0
	retlw 'U'
	retlw 'T'
	retlw 'E'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw 0

	retlw 'O'              ;1
	retlw 'S'
	retlw 'D'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw ' '
	retlw 0

	retlw 'V'              ;2
	retlw 'O'
	retlw 'L'
	retlw 'U'
	retlw 'M'
	retlw ' '
	retlw '+'
	retlw 0

	retlw 'V'              ;3
	retlw 'O'
	retlw 'L'
	retlw 'U'
	retlw 'M'
	retlw ' '
	retlw '-'
	retlw 0

	retlw 'B'              ;4
	retlw 'A'
	retlw 'S'
	retlw 'S'
	retlw 'E'
	retlw ' '
	retlw '+'
	retlw 0

	retlw 'B'              ;5
	retlw 'A'
	retlw 'S'
	retlw 'S'
	retlw 'E'
	retlw ' '
	retlw '-'
	retlw 0

	retlw 'U'              ;6
	retlw 'P'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw ' '
	retlw ' '
	retlw 0

	retlw 'D'              ;7
	retlw 'O'
	retlw 'W'
	retlw 'N'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw 0

	retlw 'T'              ;8
	retlw 'V'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw ' '
	retlw ' '
	retlw 0

	retlw 'R'              ;9
	retlw 'I'
	retlw 'G'
	retlw 'H'
	retlw 'T'
	retlw '_'
	retlw ' '
	retlw 0

	retlw 'L'              ;10
	retlw 'E'
	retlw 'F'
	retlw 'T'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw 0

	retlw 'M'              ;11
	retlw 'E'
	retlw 'N'
	retlw 'U'
	retlw '_'
	retlw 'O'
	retlw 'N'
	retlw 0

	retlw 'M'              ;12
	retlw 'E'
	retlw 'N'
	retlw 'U'
	retlw '-'
	retlw 'O'
	retlw 'F'
	retlw 0

	retlw 'O'              ;13
	retlw 'K'
	retlw '_'
	retlw ' '
	retlw ' '
	retlw ' '
	retlw ' '
	retlw 0

	retlw '?'              ;14
	retlw '?'
	retlw '?'
	retlw '?'
	retlw '?'
	retlw '?'
	retlw '?'
	retlw 0

Chiffre
        ADDWF PCL,F  
	retlw 'C'              ;15
	retlw 'H'
	retlw 'I'
	retlw 'F'
	retlw 'F'
	retlw 'R'
	retlw 'E'
	retlw 0

                		
		
TABLE_END	RETLW	0X00
		
	IF ( (TABLE_ST & 0x0FF) >= (TABLE_END & 0x0FF) )
		;MESSG   "Warning - Message table 'TABLE_ST' crosses page boundary"
        	ERROR   "Attention Zone Message deborde la page de 256 octets"
	ENDIF

;*****************************************************************************
; Initialize processor registers
;*****************************************************************************
DEBUT                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB
		bank1
	ifdef miniSimDE
        	MOVLW   0x018           ; RA-2-1-0 outputs, RA4-3 inputs
	else
		MOVLW   0x0FC           ; RA1-0 outputs, RA4-3-2 inputs
       endif
		MOVWF   TRISA
		MOVLW   0x0F           ; RB7-6-5-4 outputs RB 3-2-1-0 inputs
		MOVWF   TRISB
		MOVLW	B'00010001'	; Option register setup:
					; RB Pullups
					; TMR0 fed from internal clock
					; Assign prescaler to TMR0
					; use 1:4 prescaling ratio
		MOVWF	OPTION_REG

		bank0
		CLRF	VOLUME
		CALL    LCD_Init         ; Initialize LCDisplay
		
;============================
Pres
	call LCD_Cls
	clrf Cpt1
	MOVLW	LINE1	;
	CALL	LCD_Cde		; Set to first line
Pres1

        movf Cpt1,w
	CALL read_EE
	incf Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Pres2  	
	Call LCD_Putchar
	goto Pres1
Pres2
	MOVLW	LINE2			;
	CALL	LCD_Cde		; Set to first line
	movlw EE1-EE0
	MOVWF Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call LCD_Putchar
	goto Pres3
Pres4
	call delay_2_5s
	call LCD_Clear1
	MOVLW	LINE1			;
	CALL	LCD_Cde		; Set to first line
	movlw EE2-EE0
	MOVWF Cpt1
Pres5
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Pres6  	
	Call LCD_Putchar
	goto Pres5
Pres6
	ifdef miniSimDE
        nop
        else
        call delay_2_5s
        endif
	call LCD_Clear2

Capture_IR
		call POLL_IR

; Affichage de la donne capture 
            
       
		call    LCD_Clear1
		MOVLW   LINE1       
		CALL    LCD_Cde         ; Position cursor leftmost on first line
		MOVLW   MSG_T           ; Point to Toggle message
		CALL    TABLE_MSG       ; Display message
		MOVF    TOGGLE,w        ; Load the toggle bit to display
		MOVWF   ASCII_O         ; Send data to conversion routine
		CALL    HEX_TO_ASC      ; Convert to ascii
		MOVF    ASCII_O,w       ; Ones digit is in ascii_o
		CALL    LCD_Putchar      ; Display TOGGLE 
		
		MOVLW   LINE1+8       
		CALL    LCD_Cde         ; Position cursor leftmost on first line
		MOVLW   MSG_S           ; Point to Toggle message
		CALL    TABLE_MSG       ; Display message
		MOVF    SYSTEM,w        ; Load the SYSTEM dat to display
		MOVWF   ASCII_O         ; Send data to conversion routine
		CALL    HEX_TO_ASC      ; Convert to ascii
		MOVF    ASCII_O,w       ; Ones digit is in ascii_o
		CALL    LCD_Putchar      ; Display SYSTEM data
		
             	call LCD_Clear2
		MOVLW   LINE2
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_C           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
		MOVF    COMND,w         ; Load the command byte to display
		MOVWF   ASCII_O         ; Send data to conversion routine
		CALL    HEX_TO_ASC      ; Convert to ascii
	;	MOVF    ASCII_H,w       ; Hundreds digit
	;	CALL    LCD_Putchar      ; Display it
		MOVF    ASCII_T,w       ; Tens digit
		CALL    LCD_Putchar      ; Display it
		MOVF    ASCII_O,w       ; Ones digit
		CALL    LCD_Putchar      ; Display COMMANDE

;-----------------------------------
; decodage code et association libell
;----------------------------------
	
		call LCD_Clear1
		MOVLW   LINE1
		CALL    LCD_Cde         ; Set cursor leftmost on line 2

                MOVf COMND,W
                SUBLW 9           ; si COMND<10 c'est un chiffre
                BTFSC STATUS,C 
                goto UnChiffre

UneCde
        	clrf IndexP
		movf COMND,W
	; recherche index correspondant au code lu
		
PosNotFind	movf IndexP,W
		call CodeTouche
		xorwf COMND,w		; valeur pointe = code lu ?
		btfsc STATUS,Z
		goto FundPosCode
		incf IndexP,f
		movlw MaxMsg
                xorwf IndexP,W     ; =13 limite nb de msg
                BTFSS STATUS,Z
		goto PosNotFind
		movlw MaxMsg
		movwf	IndexP		; 15em message par defaut
            
FundPosCode					; position code trouv
		bcf STATUS,C				
		rlf	IndexP,f		; * par 8
		rlf	IndexP,f
		rlf	IndexP,f
NextCarLib
		movf IndexP,W
		call LibelleTouche
		ANDLW 0xFF
		BTFSC STATUS,Z
		goto FinLibel
		call LCD_Putchar
		incf IndexP,f
		goto NextCarLib
FinLibel
	
                goto TraiteCde  



UnChiffre
               ; si COMND<10 c'est un chiffre
               clrf IndexP            ; affiche message "Chiffre"
NextChiffre
               	movf IndexP,W
		call Chiffre
		ANDLW 0xFF
		BTFSC STATUS,Z
		goto FinChiffre
		call LCD_Putchar
		incf IndexP,f
		goto NextChiffre
FinChiffre      
                 

;*******************

TraiteCde		
; traitement code telecommande

               call delay_1s
  

 		movf COMND,W
		xorlw 16	;+V
		btfsc STATUS,Z
		goto trait1
		
		movf COMND,W
		xorlw 17	;-V
		btfsc STATUS,Z
		goto trait2

		movf COMND,W
		xorlw 12	;BP ROUGE
		btfsc STATUS,Z
		goto trait3
		goto Capture_IR

trait1		incf VOLUME,f
		call affvolume
		goto Capture_IR

trait2		decf VOLUME,f
		call affvolume
		goto Capture_IR

trait3		clrf VOLUME
		goto Pres


; Fin du programme principal
;*************************************************************

affvolume
		MOVLW   LINE2 + 8       ; Position 8
		CALL    LCD_Cde         ; Set cursor
		MOVLW   MSG_V           ; Point to Data message
		CALL    TABLE_MSG       ; Display the message
		MOVF    VOLUME,w        ; Load the data byte to display
		call bcd3
		return
	
;**************************************************************
; Envoi de message via table de message dans la zone programme
;**************************************************************
TABLE_MSG
		MOVWF   POINTER         ; Point to the first char. we want
LOOP_WR         
		MOVF   POINTER,W         ; Renew the pointer
		CALL    TABLE_ST        ; Initiate table lookup
		XORLW   0x00            ; Is this the terminating char?
		BTFSC   STATUS,Z
		GOTO    END_WR
		CALL    LCD_Putchar      ; Actually put the char on display
		INCF    POINTER,f	; Point to the next char
		GOTO    LOOP_WR         ; Do next character
END_WR
		RETURN
;=========================
; rev 26 janv 2003 lcd4c.inc
; fichiers lis:   delais_b.inc  lcd4c.h
;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;	LCD_Init : initialisation de l'afficheur
;	LCD_Putchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCD_Cde  : envoi une commande ( contenue dans w)  l'afficheur
;	LCD_Cls  : efface l'afficheur
;	LCD_Clear1 : efface la premiere ligne de l'afficheur
;	LCD_Clear2 : efface la deuxieme ligne de l'afficheur
;	LCD_Home : renvoi le curseur en haut a gauche
;	LCD_Line1 : renvoi le curseur au debut de la ligne 1
;	LCD_Line2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset	call LCD_Cde
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset	call LCD_Cde
;
;	variables a definir dans le programme principal:
;	LCDtmp,LCDTmp1			; LCD
;
;	constantes a definir dans le programme principal:
;	LCD_DATA	EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CTRL	EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CTRL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E		EQU 1		; LCD: Ligne de commande de controle de l'afficheur
;not used LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur
;
;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes


LCD_Cls  
	movlw	D'01'			; effacage de l'ecran
	call	LCD_Cde
	goto	delay_2_5ms

;-----------------
LCD_Clear1				; effacage de la 1ere ligne
	movlw	D'15'			
	movwf	LCDtmp1
	movlw	LINE1			; 0x80
	call	LCD_Cde
	call	delay_2_5ms
LCDc111
	movlw	' '
	call	LCD_Putchar
	decfsz	LCDtmp1,f
	goto	LCDc111
LCD_Line1	movlw	LINE1
	call	LCD_Cde
	goto	delay_2_5ms
;--------------

LCD_Clear2				; effacage de la deuxieme ligne
	movlw	D'15'		
	movwf	LCDtmp1
	movlw	LINE2			; 0xC0
	call	LCD_Cde
	call	delay_2_5ms
LCDcl21
	movlw	' '
	call	LCD_Putchar
	decfsz LCDtmp1,f
	goto	LCDcl21
	
LCD_Line2
	movlw	LINE2
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Home
	movlw	D'02'
	call	LCD_Cde
	goto delay_2_5ms

LCD_Putchar
	bank0				; rajout 7/03/03 
	movwf	LCDtmp
	call	delay_1ms
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	nop
	endif
	bsf     LCD_CTRL, LCD_RS
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	return

LCD_Init
	bcf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_RS
	nop
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	endif
	call 	delay_2_5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bank1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	bank0
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms		
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           ; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCD_Cde
	movlw   0x008		; display off
	call    LCD_Cde
	movlw   0x00C		; display on (0x00C sans curseur, 0x00E avec , 0x00F clign. )
	call    LCD_Cde
	movlw   0x006
	
LCD_Cde
	movwf   LCDtmp
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL,LCD_RW
	nop
	endif
	bcf     LCD_CTRL,LCD_RS
	nop
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	return
;-----------------------
;delais4M.inc pour Fquartz=4Mhz
;last update: 28 mars 2003
;count1 count2 count3  en bank0 pour delay routines
;delay_RS special pour routine d'attente bit 4800 Bauds
;delay : 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us delay_100us  delay_200us 
;delay_1ms delay2_5ms  delay_10ms delay_100ms delay_500ms
;delay_1sec delay_10sec
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	   MOVLW           67           ; .67 pour 4800 bauds
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
         Return
;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------

delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   0x05
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
        
delay_200us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   40
                movwf   count3
                goto    delay1
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     	movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1
;-----------------------

; variable pour convertion binaire --> BCD 16bits
;bcent		EQU 	RAMstart+32
;bdix		EQU 	RAMstart+33
;bun		EQU 	RAMstart+34
;btmp		EQU 	RAMstart+35
;btmp1		EQU 	RAMstart+36
;val1		EQU 	RAMstart+37		; variable pour stockage valeur 16 bits
;val2		EQU 	RAMstart+39
;===============================================

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bcent,w
	call   LCD_Putchar
	movf   bdix,w
	call   LCD_Putchar
	movf   bun,w
	call   LCD_Putchar
	return
;-------------------
; voir 84_IRC5_.h pour environnment et variables
;*************************************************
; Boucle d'attente signal IR (Attention :
; pour TSOP1736 etat haut au repos sans signal!)
;*************************************************
POLL_IR
	ifdef miniSimDE
	        MOVf PORTB,W   ; MOVLW 16               ; simulation code recu
	        ANDLW 0x0F
                ADDLW 10
        	movwf COMND
		BCF STATUS,C
		return	    
	else

		BTFSC	PORTA, DATA_IN	; The pickup module has inverse logic
		GOTO    POLL_IR		; High is idle, low is active
		MOVLW	D'147'		; Found data, load timer for 444 uS   470
					; minus 11 overhead = 433 cycles
					; 255-147=108 counts x 4 prescaled
		MOVWF	TMR0		; Which creates a 1/4 bit wait
		BCF	INTCON,T0IF	; Clear timer overflow flag
		BCF	STATUS,C	; Initialize the carry flag
		CALL	READ		; Read the data stream
		BTFSC	STATUS,C	; Carry flag set means bogus data
		GOTO	POLL_IR		; Start over if bad datastream
		CALL	ANALYSE		; ANALYSE the data
		BTFSC	STATUS,C	; Carry flag set means no success
		GOTO	POLL_IR	; Start over if bad ANALYSE
		return
	endif

;*************************************************************************
;READ .. reads the incoming data stream and saves it into a 6-byte buffer
;        Remember again that the IR pickup output is active low
;*************************************************************************

READ		bank0			; First, zero all storage
		MOVLW	SERIAL_BUF	; Start of RAM buffer
		MOVWF	FSR		; Load indirect register
RD_LOOP1	CLRF	INDF		; Zero out the buffer
		INCF	FSR,f		; Increment to next byte
		MOVLW	SERIAL_BUF+6	; Test for 6 bytes done
		XORWF	FSR,w
		BTFSS	STATUS,Z
		GOTO	RD_LOOP1	; Loop till done
		
		CLRF	BIT_COUNT
		CLRF	BYTE_COUNT
		MOVLW	SERIAL_BUF	; Reset the indirect pointer back
		MOVWF	FSR		; to the start of the buffer space

RD_LOOP2	BTFSS	INTCON, T0IF	; Wait till timer goes 444 Usec
		GOTO	RD_LOOP2
		CALL	RESTART_TMR0	; Reset timer for 888 uSec
		BTFSC	PORTA,DATA_IN	; Check RAx signal (i.e. debounce)
		GOTO	BAD_DATA	; If it's high (logic 0), bail out

RD_LOOP3	BTFSS	INTCON, T0IF	; Wait till timer goes 888 uSec
		GOTO	RD_LOOP3

		CALL	RESTART_TMR0	; Restart 888 uSec timer
		INCF	BIT_COUNT,f
		MOVLW	D'43'		; See if we've done all 42 bits
		XORWF	BIT_COUNT,w
		BTFSC	STATUS,Z
		GOTO	RD_FINISH	; We've done all 42 bits
		BSF	STATUS,C	; Preset the carry bit
		BTFSC	PORTA,DATA_IN	; Test RA3
		BCF	STATUS,C	; Input bit is high (logic 0) so change carry
					; Now the input bit is in the carry flag
		RLF	INDF,f		; Rotate it into the buffer
		INCF	BYTE_COUNT,f	; 
		BTFSC	BYTE_COUNT,3	; See if all 8 bits are filled
		CALL	NEXT_BYTE	; Yes, use next buffer byte
		GOTO	RD_LOOP3	; Loop back & do the rest of the bits
		
RD_FINISH	BCF	STATUS,C	; 
		RLF	INDF,f		; The last buffer byte has only 2
		RLF	INDF,f		; bits loaded.
		RLF	INDF,f		; So we shift them up to the top
		RLF	INDF,f		; the hard way.
		RLF	INDF,f
		RLF	INDF,f
		BCF	STATUS,C	; Clear carry to show a successful capture
		RETURN
;******************************************************
;NEXT_BYTE .. Increment the FSR and clear the counter
;******************************************************
NEXT_BYTE	INCF	FSR,f
		CLRF	BYTE_COUNT
		RETURN

;*********************************************************************
;RESTART_TMR0 .. Restart the timer with an 888 uSec delay
;    	and refresh the overflow flag. MPLAB stopwatch says there is a loop 
;	overhead of 14 cycles, thus we need it to run for 888-14=874 uSec
;*********************************************************************
RESTART_TMR0
		BCF	INTCON, T0IF	; Clear the overflow flag
		MOVLW	D'37'		; 255 - 37 = 218 x 4 = 872 uSec
		MOVWF	TMR0
		RETURN
		
;***************************************************************************
;ANALYSE .. decodes the saved datastream into the various RC5 words and flags.
;***************************************************************************
ANALYSE
		MOVLW	SERIAL_BUF	; Put buffer start address into
		MOVWF	FSR		; the FSR
		CLRF	TEMP		; Initialize variables
		CLRF	BYTE_COUNT	;
		CLRF	MZ_FLAG		;
		CLRF	FIELD		;
		CLRF	TOGGLE		;
		CLRF	SYSTEM		;
		CLRF	COMND		;
		CLRF	MZDATA		;
	; First one is the field bit
		RLF	INDF,f		; First bit into carry
		RLF	TEMP,f		; Put it into TEMP for decoding
		RLF	INDF,f		; Second bit
		RLF	TEMP,f		; ditto
		INCF	BYTE_COUNT,f	; Start keeping track of INDF bit position
		CALL	DECODE
		BTFSC	ANALYSE_FLAGS,2	; Illegal pattern found
		GOTO	BAD_DATA
	; Must have found a good bit
		RRF	ANALYSE_FLAGS,f	; Put field bit into Carry
		RLF	FIELD,f		; Move it into FIELD
	; Next one is the toggle bit			
		CLRF	TEMP		
		RLF	INDF,f		; First bit into carry
		RLF	TEMP,f		; Put it into TEMP for decoding
		RLF	INDF,f		; Second bit
		RLF	TEMP,f		; ditto
		INCF	BYTE_COUNT,f	; keep track of INDF bit position
		CALL	DECODE
		BTFSC	ANALYSE_FLAGS,2	; Illegal pattern found
		GOTO	BAD_DATA
	; Must have found a good bit
		RRF	ANALYSE_FLAGS,f	; Put toggle bit into Carry
		RLF	TOGGLE,f	; Move it into TOGGLE
	; Next one is the system byte, 5 bits
		MOVLW	0x05		
		MOVWF	COUNT
SYS_1		CLRF	TEMP		
		RLF	INDF,f		; First bit into carry
		RLF	TEMP,f		; Put it into TEMP for decoding
		RLF	INDF,f		; Second bit
		RLF	TEMP,f		; ditto
		INCF	BYTE_COUNT,f	; keep track of INDF bit position
		BTFSC	BYTE_COUNT,2	; (there are two rotates per count)
		CALL	NEXT_BYTE	; Go to next buffer byte when count=4
		CALL	DECODE
		BTFSC	ANALYSE_FLAGS,2	; Illegal pattern found
		GOTO	BAD_DATA
	; Must have found a good bit
		RRF	ANALYSE_FLAGS,f	; Put bit into Carry
		RLF	SYSTEM,f	; Move it into SYSTEM
		DECFSZ	COUNT,f		; Have we done all 5 bits?
		GOTO	SYS_1		; No, not yet

	; Here we test for the two spaces present in the extended data format.
	; If they appear, we set a flag and skip over them to the command word.
		MOVLW	B'11000000'	; Mask for 2nd buffer byte
		ANDWF	SERIAL_2,w	; Are the 2 top bits zero?
		BTFSS	STATUS,Z	;
		GOTO	PHILIPS		; No space found
		
		CALL	NEXT_BYTE	; Skip over first space
		RLF	INDF,f		; Skip over second space
		RLF	INDF,f		;
		INCF	BYTE_COUNT,f
		MOVLW	0x01
		MOVWF	MZ_FLAG		; Set the flag
	
PHILIPS		MOVLW	0x06		; Next one is the command byte, 6 bits
		MOVWF	COUNT
CMD_1		CLRF	TEMP		
		RLF	INDF,f		; First bit into carry
		RLF	TEMP,f		; Put it into TEMP for decoding
		RLF	INDF,f		; Second bit
		RLF	TEMP,f		; ditto
		INCF	BYTE_COUNT,f	; keep track of INDF bit position
		BTFSC	BYTE_COUNT,2	; (there are two rotates per count)
		CALL	NEXT_BYTE	; Go to next buffer byte when count=4
		CALL	DECODE
		BTFSC	ANALYSE_FLAGS,2	; Illegal pattern found
		GOTO	BAD_DATA
	; Must have found a good bit
		RRF	ANALYSE_FLAGS,f	; Put bit into Carry
		RLF	COMND,f		; Move it into COMND
		DECFSZ	COUNT,f		; Have we done all 6 bits?
		GOTO	CMD_1		; No, not yet
		BTFSS	FIELD,0		; If field bit=0 then comnd=comnd+64
		BSF	COMND,6
		BTFSC	MZ_FLAG,0	; Test for extra data word
		GOTO	MDAT_1		; ANALYSE extra data word
		RETURN			; Finish here if Philips format
	; Next one is the data byte, 6 bits		
MDAT_1		MOVLW	0x06		
		MOVWF	COUNT
MDAT_2		CLRF	TEMP		
		RLF	INDF,f		; First bit into carry
		RLF	TEMP,f		; Put it into TEMP for decoding
		RLF	INDF,f		; Second bit
		RLF	TEMP,f		; ditto
		INCF	BYTE_COUNT,f	; keep track of INDF bit position
		BTFSC	BYTE_COUNT,2	; (there are two rotates per count)
		CALL	NEXT_BYTE	; Go to next buffer byte when count=4
		CALL	DECODE
		BTFSC	ANALYSE_FLAGS,2	; Illegal pattern found
		GOTO	BAD_DATA
	; Must have found a good bit
		RRF	ANALYSE_FLAGS,f	; Put bit into Carry
		RLF	MZDATA,f	; Move it into MZDATA
		DECFSZ	COUNT,f		; Have we done all 6 bits?
		GOTO	MDAT_2		; No, not yet
ANALYSE_DONE	RETURN


;**********************************************************
; DECODE .. enter with two-bit data in TEMP
;           return with result code in ANALYSE_FLAGS, thus
;           ANALYSE_FLAGS<0> = valid data, one or zero
;           ANALYSE_FLAGS<1> = unused
;           ANALYSE_FLAGS<2> = set if data is invalid
;***********************************************************
DECODE
		CLRF	ANALYSE_FLAGS
		MOVLW	ONE
		XORWF	TEMP,w		; Compare to bit pattern '01'
		BZ	ONE_EXIT
		MOVLW	ZERO
		XORWF	TEMP,w		; compare to bit pattern '10'
		BZ	ZERO_EXIT
BAD_EXIT	BSF	ANALYSE_FLAGS,2	; bit pattern neither 01 nor 10
		RETURN
ONE_EXIT	BSF	ANALYSE_FLAGS,0	; Return with valid data in LSB
ZERO_EXIT	RETURN			; of the ANALYSE_FLAGS variable
		
;**************************************************************************
; BAD_DATA .. Exit if Read or ANALYSE doesn't like what it finds.
;             The Carry flag is set as an error message.
;**************************************************************************
BAD_DATA
		BSF	STATUS,C	; Set the carry flag to show error
		RETURN

;==================================================================
; HEX_TO_ASC .. Converts a hex digit to three ASCII characters
;               Enter with the hex digit in ASCII_O
;               Exit with Hundreds ascii digit in ASCII_H,
;               Tens ascii digit in ASCII_T,
;               and Ones ascii digit in ASCII_O.
;               The incoming byte is not preserved.
;==================================================================

HEX_TO_ASC      MOVLW   '0'             ; Preload a zero into 10's & 100's
		MOVWF   ASCII_T
		MOVWF   ASCII_H
DO_100s         MOVLW   D'100'
		SUBWF   ASCII_O,w       ; Subtract 100 to test size
		BNC     DO_10s          ; It's less than 100, so branch
		MOVWF   ASCII_O         ; It was bigger, so decrement it
		INCF    ASCII_H,f       ; Bump up the 100's digit
		GOTO    DO_100s         ; Loop again till < 100
DO_10s          MOVLW   D'10'
		SUBWF   ASCII_O,w       ; Subtract 10 to test size
		BNC     ADJUST          ; It's less than 10, so branch
		MOVWF   ASCII_O         ; It was bigger, so decrement it
		INCF    ASCII_T,f       ; Bump up the 10's digit
		GOTO    DO_10s          ; Loop again till < 10
ADJUST          MOVLW   '0'             ; The # in ASCII_O is now < 10
		ADDWF   ASCII_O,f       ; Turn it into an ASCII character
BLANK_ZEROS     MOVLW   '0'
		XORWF   ASCII_H,w       ; Is the 100's char a 0?
		BTFSS   STATUS,Z
		GOTO    HEX_DONE        ; No.
		MOVLW   ' '             ; Yes,
		MOVWF   ASCII_H         ; So replace it with a space.
		MOVLW   '0'
		XORWF   ASCII_T,w       ; Is the 10's char a 0?
		BTFSS   STATUS,Z
		GOTO    HEX_DONE        ; No.
		MOVLW   ' '             ; Yes,
		MOVWF   ASCII_T         ; So replace it with a space
HEX_DONE        RETURN


;****************************************************************************		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture

	return


	ORG EEPROM
      ;"1234567890123456"
EE0 DT "miSimDE 1.7.7   ",0
EE1 DT "LCDtst_Z.asm    ",0
EE2 DT "24 juill 03     ",0
        

		END
#define MUTE_		13
#define OSD_		15
#define VOLUP_		16
#define VOLDOWN_	17
#define BASSUP_		22	
#define BASSDOWN_	23
#define UP_		28
#define DOWN_		29
#define TV_		63
#define RIGHT_		43
#define LEFT_		44
#define MENUON_		82	
#define MENUOFF_	83	
#define OK_		87
