; MAX12432.ASM : (c) 2000 Offset, PIC16F84 & ADC MAX1243
; V1.0 en version 10 bits
; http://www.multimania.com/offset
;
;**************************************************************************;
;
;
;	variables a definir dans le programme principal:
;
;	val1:2				; variable 16 bits pour calcul 16 bits
;	M43_tmp				; 1243 : - Valeur temporaire.
;
;	constantes a definir dans le programme principal:
;
;	M43_PORT	EQU PORTA	; 1243 : Port sur lequel est branch le convertisseur
;	M43_DATA 	EQU 3		; 1243 : Broche 'Serial Data' du 1243.
;	M43_CS		EQU 2		; 1243 : Broche 'CS' du 1243.
;	M43_CLK		EQU 1		; 1243 : Broche 'Serial Clock' du 1243.
;
;	la variable val1 est  definir si elle n'est pas dja definie par un autre module
;
;**************************************************************************;

M43init
	BANKSEL TRISA
	BCF	M43_PORT,M43_CLK	; CLK en sortie
	BCF	M43_PORT,M43_CS		; CS en sortie
	BSF	M43_PORT,M43_DATA	; DATA en entree
	BANKSEL PORTA
	BSF	M43_PORT,M43_CS
	BCF	M43_PORT,M43_CLK
	RETURN

M43read                             
	BCF	M43_PORT,M43_CS		; on lance la convertion
	CLRF	val1
	CLRF	val1+1
	BTFSS	M43_PORT,M43_DATA	; on regarde si la convertion est terminee
	GOTO	$-1

	MOVLW	.2			; 2 bits ( les 2 bits de poids fort )
	MOVWF	M43_tmp
M43bcl1	BSF	M43_PORT,M43_CLK	; 1 pulse pour envoi de donnee
	BCF	M43_PORT,M43_CLK
	BCF	STATUS,C		; si c'est un zero , effacer le Carry
	BTFSC	M43_PORT,M43_DATA
	BSF	STATUS,C		; sinon c'est un 1
	RLF	val1,f			; les 2 bits de poids fort sont dans val1
	DECFSZ	M43_tmp,f
	GOTO	M43bcl1

	MOVLW	.8			; 8 bits ( les 8 bits de poids faible )
	MOVWF	M43_tmp
M43bcl2	BSF	M43_PORT,M43_CLK	; 1 pulse pour envoi de donnee
	BCF	M43_PORT,M43_CLK
	BCF	STATUS,C		; si c'est un zero , effacer le Carry
	BTFSC	M43_PORT,M43_DATA
	BSF	STATUS,C		; sinon c'est un 1
	RLF	val1+1,f		; les 2 bits de poids faible sont dans val1+1
	DECFSZ	M43_tmp,f
	GOTO	M43bcl2

	BSF	M43_PORT,M43_CS		; on remet le 1243 en attente
	MOVF	val1+1,w		; on transfere les 8 bits de poids faible dans W
	RETURN

