; 5 juin 2005 passage sur minisim pour debugging
; vu PB sur raz zone RAM 
; 27/05/2005 sur PIC16F84 84-9941
; limite incrementation jour passe  31 au lieu de 28
; usage du LT1286  la place du MAX187
;-----------
; rev 10/12/02    100% OK
; renomm rtc16F84.asm
; rev 09/12/02   
; old: rtc1302g.asm
; arrangement E/S pour utiliser interrupt sur RB0 pour detecter
; appui de touche clavier et decodage touche sans bloquer l'acquisition.
; traitement valeur touche dans la boucle de fond, si <M>ise  l'heure
; traitement specifique par pooling clavier et ecriture dans RTC
; Acquisition Temperature LM35DZ 10mV/C via convertisseur 
; ADC 12 bits LTC1286  => 250 mV => affichage 25.0C
; RS232 baud rate  parity  data bits  stop bits  4800,N,8,1
; Dallas DS1302 circuit horloge temps reel en BCD via communication 3 fils
; year    month   day     hour    minute second  
; yyyy    mm      dd      hh      mm      ss      
;pin descriptions
; 16f84   pin     In/Out  function   
; ra0     17      I     serial out  ----> 11 ICL232 -> Tx
; ra1     18      O     rtc     /rst    pin5
; ra2     1       I/O   rtc     data	pin6
; ra3     2       O     rtc     clk     pin7
; ra4     3       I     IRsensor
; 	  4 		MLCR reset PIC
;	  5             VCC +5V alim
; rb0     6       I	RB0 serial in <---  12 ICL232 --< Rx
; rb1     7       O 	RB1 -> CS   5 LTC1286 
; rb2     9       I     RB2 <- DATA 6 LTC1286
; rb2     8       O 	RB3 -> CLCK 7 LTC1286
; rb4     10      I     not used
; rb5     11      I     not used  
; rb6     12      I     not used     
; rb7     13      I	not used
;	  14            masse 0V
;	  15		quartz
;	  16		quartz


#define miniSimDE
;	include <p16f84_.inc>
	ifdef miniSimDE
	p=16F84
	else
	Processor       16F84
        ERRORLEVEL      -302
	endif
	Radix           DEC
	EXPAND


__16F84__   equ     1
__14BIT__   equ     1
           

LOWRAM      equ     0x0c
HIGHRAM     equ     0x7f

; ----- I/O registers ------------
w               EQU     H'0000'
f               EQU     H'0001'
indf        	equ     0x00
tmr0        	equ     0x01
pcl         	equ     0x02
status      	equ     0x03
fsr         	equ     0x04
porta       	equ     0x05
portb       	equ     0x06
eedata      	equ     0x08
eeadr       	equ     0x09
pclath      	equ     0x0a
intcon      	equ     0x0b
option_reg	equ	0x81
trisa       	equ     0x85
trisb       	equ     0x86
eecon1      	equ     0x88
eecon2      	EQU     0x89
eeif        	EQU     H'0004'
wrerr       	EQU     H'0003'
rp1     	EQU     H'0006'
rp0	      	EQU     H'0005'
wren        	EQU     H'0002'
WR          	EQU     H'0001'
RD          	EQU     H'0000'
z           	EQU     H'0002'
dc          	EQU     H'0001'
c           	EQU     H'0000'

intf		equ	1
inte		equ 	4
gie		equ	7
same 		EQU 	1

_CP_ON          EQU     H'000F'
_CP_OFF         EQU     H'3FFF'
_PWRTE_ON       EQU     H'3FF7'
_PWRTE_OFF      EQU     H'3FFF'
_WDT_ON         EQU     H'3FFF'
_WDT_OFF        EQU     H'3FFB'
_LP_OSC         EQU     H'3FFC'
_XT_OSC         EQU     H'3FFD'
_HS_OSC         EQU     H'3FFE'
_RC_OSC         EQU     H'3FFF'

;-----------------------------
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC      ;3FF1h    
  
;-----------------------------

#define 	bank0	bcf status,rp0
#define 	bank1	bsf status,rp0

eerd		equ     0       ;eeprom eecon1,0 read bit
eewr		equ     1       ;eeprom eecon1,1 write bit
_rst		equ     1       ;5 rtc restart line LO=rst
dataq		equ     2       ;6 rtc dq data line (=I/O)
clk		equ     3       ;7 rtc clock 
IR_read		equ     4

Rs_Tx		equ     0      			;rs232 tx line  
Rs_Rx		equ     0      			;rs232 rx line 
#define     	SERIAL_TX	porta,Rs_Tx     ;rs232 serial transmit line
#define     	SERIAL_RX	portb,Rs_Rx     ;rs232 serial Receive  line

#define     	DS1302_RST 	porta,_rst	;5 RTC reset line LO=reset HI=active
#define    	DS1302_DATA	porta,dataq	;6 RTC I/O data line
#define     	DS1302_SCLK	porta,clk	;7 RTC clock line 

#define 	Ltc_CS		portb,_rst	;5 LTC output for CS
#define 	Ltc_DATA	portb,dataq	;6 LTC input DATA
#define 	Ltc_CLOCK	portb,clk	;7 LTC output clock

	IFDEF minisimDE
RamG	EQU	0X0C
m_porta                 	EQU	RamG
m_portb             	EQU	RamG+1
dummy                 	EQU	RamG+2
dummy1           	EQU	RamG+3
dummy2 	EQU	RamG+4
dummy3	EQU	RamG+5
Cpt1	EQU	RamG+6
Cpt2	EQU	RamG+7
count1                  	EQU	RamG+8
count2                 	EQU	RamG+9
count3               	EQU	RamG+10
count4             	EQU	RamG+11
count5                	EQU	RamG+12
up_count              	EQU	RamG+13
down_count          	EQU	RamG+14
Rdecal2              	EQU	RamG+15
second            	EQU	RamG+16
minute                	EQU	RamG+17
hour                	EQU	RamG+18
date                 	EQU	RamG+19
month                  	EQU	RamG+20
day                  	EQU	RamG+21
year                   	EQU	RamG+22
TOGGLE 	EQU	RamG+23
SYSTEM          	EQU	RamG+24
COMND           	EQU	RamG+25
MZDATA          	EQU	RamG+26
temp_f                	EQU	RamG+27
w_temp	EQU	RamG+28
status_temp 	EQU	RamG+29
buff_4                	EQU	RamG+30
buff_3                  	EQU	RamG+31
buff_2	EQU	RamG+32
buff_1	EQU	RamG+33
temp_a	EQU	RamG+34
temp_b	EQU	RamG+35
temp_c	EQU	RamG+36
temp_d	EQU	RamG+37
temp_e	EQU	RamG+38
RsBuffer	EQU	RamG+39
RsByte	EQU	RamG+40
RsCount	EQU	RamG+41
Drapeau	EQU	RamG+42
temp	EQU	RamG+43
bcent	EQU	RamG+44
bdix	EQU	RamG+45
bun	EQU	RamG+46
btmp	EQU	RamG+47
btmp1	EQU	RamG+48
dixmil	EQU	RamG+49
mille	EQU	RamG+50
cent	EQU	RamG+51
dix	EQU	RamG+52
un	EQU	RamG+53
valx	EQU	RamG+54	;16bits!
val1	EQU	RamG+56	;16 bits
Lo_Temp	EQU	RamG+58
Hi_Temp EQU	RamG+59
maxima  EQU     RamG+60
	else
        cblock  0x0C
 		m_porta                 ;mirror of port a
           	m_portb                 ;mirror of port b
           	dummy                 	;temporary use
 	    	dummy1                  ;for 8bit rotates in/out
	    	dummy2 
	    	dummy3
	    	Cpt1		
	    	Cpt2
           	count1                  ;delay routines
           	count2                  ;delay routines
           	count3                  ;delay routines
           	count4                  ;
           	count5                  ;used in binary-to-bcd routine
		up_count                ;count of 0.1 secs when UP switch closed
           	down_count              ;count of 0.1 secs when DOWN switch closed
      		Rdecal2                 ;per Mark Sullivan's code 25.7.96
     		second                  ;
           	minute                  ;
           	hour                    ;
           	date                    ;
           	month                   ;
           	day                     ;
           	year                    ;
		TOGGLE 			; The RC5 Toggle bit
		SYSTEM          	; The RC5 System word
		COMND           	; The RC5 Command word
		MZDATA          	; The RC5 extra Data word
           	temp_f                  ;for outputting binary-held data to 
		w_temp
		status_temp 
           	buff_4                  ; bcd 32 bits -to- 10 digits ascii 
           	buff_3                  
           	buff_2
           	buff_1
           	temp_a
           	temp_b
           	temp_c
           	temp_d
           	temp_e
		RsBuffer
	     	RsByte
	     	RsCount
	     	Drapeau
      		temp
		bcent				; conversion BCD 4 digits -> ascii
		bdix	
		bun	
		btmp	
		btmp1	
		dixmil
		mille	
		cent	
		dix	
		un	
		valx:2
		val1:2
		Lo_Temp			; Max187
	    	Hi_Temp 
        endc
    ENDIF
;-------------------------------------
                org     0x000
                goto    start
;-------------------------------------
                org     0x004

;------ routines interruption ---
	bank0
	bcf intcon,gie		;interdit all interrupt
	movwf w_temp            ;On sauve le registre W est le registre STATUS
	swapf status,w          ;Dans les variables W_TEMP et STATUS_TEMP
	movwf status_temp    
; interrupt sur RB0 ?
	bank1
	btfss intcon,intf
	goto other_int
	bank0
	bcf intcon,inte		; raz autorise int RB0
	bcf intcon,intf		; raz drapeau
	Clrf            RsByte
	Movlw           H'08'                   ;byte 8 bit
	Movwf           RsCount
Rx1 	call            Delay                   ;bit de start
        Bcf             status,c                ;Carry=0
        Btfsc           SERIAL_RX           ;lit et test l'entre RB0
     	Bsf             status,c                ;Rx =1, saute si Rx =0
        rrf             RsByte,f        
        Decfsz          RsCount,f
        Goto            Rx1                
; pour debugging interrupt change etat led 
;	movlw 	0x08
;	xorwf 	porta,f 
other_int
	bank0	
	swapf status_temp,W     ;Restaure les valeurs originales des registres
	movwf status            ;W et STATUS
	swapf w_temp,F
	swapf w_temp,W          
	retfie          

;-------------------------------------
	nop

MSG	addwf pcl,f
;	retlw 12
	retlw 'R'
	retlw 'T'
	retlw 'C'
	retlw '1'
	retlw '3'
	retlw '0'
	retlw '2'
	retlw ' '
	retlw '1'
	retlw '6'
	retlw 'F'
	retlw '8'
	retlw '4'
	retlw '-'
	retlw '0'
	retlw '4'
	retlw ' '
	retlw 'V'
	retlw 'e'
	retlw 'r'
	retlw ':'
	retlw ' '
	retlw '0'
	retlw '6'
	retlw ' '
	retlw 'j'
	retlw 'u'
	retlw 'i'
	retlw 'n'
	retlw ' '
	retlw '2'
	retlw '0'
	retlw '0'
	retlw '5'
	retlw 13
	retlw 10
	retlw 'L'
	retlw 'T'
	retlw 'C'
	retlw '1'
	retlw '2'
	retlw '8'
	retlw '6'
	retlw '8'
	retlw '-'
	retlw 'L'
	retlw 'M'
	retlw '3'
	retlw '3'
	retlw '5'
	retlw '-'
	retlw 'T'
	retlw 'a'
	retlw 'm'
	retlw 'b'
	retlw '.'
	retlw 13
	retlw 10
	retlw 'R'
	retlw 'S'
	retlw '2'
	retlw '3'
	retlw '2'
	retlw ' '
	retlw '4'
	retlw '8'
	retlw '0'
	retlw '0'
	retlw ','
	retlw '8'
	retlw ','
	retlw 'N'
	retlw ','
	retlw '1'
	retlw 13
	retlw 10
	retlw 0

start
	bank0
	clrf intcon	;no interrupts

;clear all ram registers
;           movlw   0x0C         ;start of ram
;          movwf   fsr
;           clrf    indf         ;$-3 to here
;           incf    fsr,f
;           btfss   fsr,7               <- Probleme!
;           goto    $-3          ;back to clrf indf   

; Effacer registres RAM
	movlw	0x0c		; initialisation pointeur
	movwf	FSR		; pointeur d'adressage indirect
init1
	clrf	INDF		; effacer ram
	incf	FSR,f		; pointer sur suivant
	btfss	FSR,6		; tester si fin zone atteinte (>=40)
	goto	init1		; non, boucler
	btfss	FSR,4		; tester si fin zone atteinte (>=50)
	goto	init1		; non, boucler

           movf fsr,w
           movwf maxima                       
           bank1
        ifdef minisimDE
	   movlw   '00010000b'	;Ra0,Ra1,Ra2,Ra3=outp  Ra4=input
           movwf   trisa            
           movlw   '00000101b'	;rb0,2 =inp  rb1,3,4,5,6,7=out
           movwf   trisb
        else
           movlw   00010000b
	   movwf   trisa            
           movlw   00000101b	;rb0,2 =inp  rb1,3,4,5,6,7=out
           movwf   trisb
           ENDIF
	   clrf option_reg
	   bcf option_reg,7	; enable pull_up
	   bcf option_reg,6	; int sur front descendant RB0
	   bank0
           clrf   porta
	 
;----------
Presentation
		movlw 0		; W contient le deplacement dans la table message
Pres1
		MOVWF	dummy	; sauve index message 
		CALL	MSG
		ANDLW	0x0FF		; test sur (W)
		BTFSC	status,z	; zero= fin de message ?
		GOTO	Pres2  
		call 	Send_Char
		MOVF	dummy, W	; Pointe sur car suivant
		ADDLW	1
		GOTO	Pres1
Pres2		
		call delay_1s
		call cr_lf

main_loop   
	    call cr_lf           
            call    delay_100ms
            call    Read_Clock      ;fetch the current contents of rtc itself
            bcf     second,7        ;clear `clock halt' CH bit
            bcf     hour,7          ;am/pm:24 -> 24 hr mode
            call    Write_Clock
	    call    Enable_TRKL 	; valide la fonction chargeur
            call    delay_1s
            call    Read_Clock
            call    Affiche_Degres
	    call    cr_lf
	    
	      bsf intcon,gie
	      nop	
	
main_loop1
	
		call  Read_Clock
		call  crush_dump      ;print one data dump only
		call 	Affiche_Degres
		clrf  RsByte
		bsf 	intcon,inte		; autorise interrupt RB0
		call delay_1s
;............... lecture 1 car possible pendant cette tempo
		bcf intcon,inte		;interdit interrupt RB0
		movlw 0xFF
		andwf RsByte,w
		btfsc status,z
		goto main_loop1		; pas de caracteres dans RsByte

		bcf RsByte,5		; passe de minuscule  majuscule
		movlw 'M'		; Mise a l'heure?
		xorwf RsByte,W
		btfsc status,z
		goto Actualise
			
		movlw 'L'		; Lecture ANA
		xorwf RsByte,W
		btfsc status,z
		goto LectureAna
		goto main_loop1
		
LectureAna
		clrf Cpt1
		bcf Drapeau,1
Lect1
		movf Cpt1,w
		call read_EE
		incf	Cpt1,f
		ANDLW	0x0FF		; test sur (W)
		BTFSC	status,z	; zero= fin de message ?
		GOTO	Lect2  	
		call Send_Char
		goto Lect1
Lect2		call Aff2
		bsf Drapeau,1
		goto main_loop1
		
Actualise
		call cr_lf
		movlw EE2-EE0
		MOVWF Cpt1
Actu0
		movf Cpt1,w
		CALL read_EE
		incf	Cpt1,f
		ANDLW	0x0FF		
		BTFSC	status,z	
		GOTO	Actu1 	
		CALL Send_Char
		goto Actu0
Actu1
		call cr_lf
 		movlw EE3-EE0
		MOVWF Cpt1
Actu2
		movf Cpt1,w
		CALL read_EE
		incf	Cpt1,f
		ANDLW	0x0FF		
		BTFSC	status,z	
		GOTO	Actu3 	
		CALL Send_Char
		goto Actu2
Actu3
		call Read_RS	; lecture 1 car par pooling
		movf RsByte,w
		call Send_Char

		movlw '1'
		xorwf RsByte,w
		btfss status,z
		goto NOT1 
		call inc_minute_bcd
		goto LoopActu
NOT1	
		movlw '0'
		xorwf RsByte,w
		btfss status,z
		goto NOT0 
		call dec_minute_bcd
		goto LoopActu
NOT0	
		movlw '3'
		xorwf RsByte,w
		btfss status,z
		goto NOT3 
		call inc_hour_bcd 
		goto LoopActu
NOT3	
		movlw '2'
		xorwf RsByte,w
		btfss status,z
		goto NOT2 
		call dec_hour_bcd 
		goto LoopActu
NOT2	
		movlw '5'
		xorwf RsByte,w
		btfss status,z
		goto NOT5 
		call inc_date_bcd 
		goto LoopActu
NOT5	
		movlw '4'
		xorwf RsByte,w
		btfss status,z
		goto NOT4 
		call dec_date_bcd 
		goto LoopActu
NOT4	
		movlw '7'
		xorwf RsByte,w
		btfss status,z
		goto NOT7 
		call inc_month_bcd 
		goto LoopActu
NOT7	
		movlw '6'
		xorwf RsByte,w
		btfss status,z
		goto NOT6 
		call dec_month_bcd 
		goto LoopActu
NOT6	
		movlw '9'
		xorwf RsByte,w
		btfss status,z
		goto NOT9 
		call inc_year_bcd 
		goto LoopActu
NOT9	
		movlw '8'
		xorwf RsByte,w
		btfss status,z
		goto NOT8
		call dec_year_bcd 
		goto LoopActu
NOT8
		ifdef minisimDE 
                MOVLW 27
                else
                movlw .27		;esc
                endif
		xorwf RsByte,w
		btfss status,z
		goto Actu1
		goto main_loop1

LoopActu	call modifie
		goto Actu1

modifie
		call    Write_Clock
         	call    crush_dump
         	call    delay_100ms 
		clrf	 RsByte
		return 

;---------------------------------------
; specific RTC ds1302 subroutines per Mark K Sullivan 25.7.96

Write_Clock  
	bcf     DS1302_SCLK            ;negate clock line
      	nop
	nop
	nop
	nop
	nop
	nop
      	bcf     DS1302_DATA
      	bsf     DS1302_RST          ;negate RST
      	bank1
      	bcf     trisa,dataq	;I/O as output
      	bank0
      	movlw   0x8E            ;write control register
      	call    wbyte
      	movlw   0x00            ;turn off Write Protect in rtc
      	call    wbyte
      	movlw   7			  ;nb de registres  parcourir
      	movwf   dummy3
      	movlw   0x80            ;rtc register address for `second'
      	movwf   count4
      	movlw   second		  ; fsr pointe sur zone stockage donnes Clock
      	movwf   fsr
wc1    
	bcf     DS1302_RST          ;assert RST
	nop
	bcf     DS1302_SCLK            ;negate clock
      	nop
      	nop
      	nop
      	bsf     DS1302_RST      ;negate RST
      	nop
      	movf    count4,W	;N registre CLOCK
      	call    wbyte		;envoie adresse du registre
      	movf    indf,W
      	call    wbyte
      	incf    fsr,f		;incremente pointeur ram PIC
      	incf    count4,f	;adresse registre modulo 2 car bit0=sens R/W
      	incf    count4,f
      	decfsz  dummy3,f	;decrement nb de registre  explorer
      	goto    wc1
      	bcf     DS1302_RST      ;assert RST
	nop
      	return
;--------------------
Enable_TRKL  
	bcf     DS1302_SCLK            ;negate clock line
     	nop
    	bcf     DS1302_DATA
	nop
     	bsf     DS1302_RST          ;negate RST
  	bank1
     	bcf     trisa,dataq	;I/O as output
     	bank0
     	bsf     DS1302_RST          ;negate RST
	nop
	movlw   0x8E            ;write control register
     	call    wbyte
     	movlw   0x00            ;turn off Write Protect in rtc
     	call    wbyte
     	movlw   0x90            ;adresse registre Trickle
     	call    wbyte
      	movlw   0xAA		;acces TCS diode 1 et diode 2 et Rs1=2K
      	call    wbyte
      	bcf     DS1302_RST      ;assert RST
	nop
    	return
;-----------
;       The Read_Clock routine following, reads the whole lot in `burst mode'
;       and puts the values into seconds --->year fregs

Read_Clock
	bcf     DS1302_SCLK      ;negate clock
        bcf     DS1302_RST       ; bon depart avec RST=0 
        bank1
        bcf     trisa,dataq
        bank0
	nop
        nop
        nop
        nop
        bcf     DS1302_DATA         ;negate I/O
        bsf     DS1302_RST          ;negate RST
        movlw   0xBF            ; burst read mode for clock registers
        call    wbyte
        bank1
        bsf     trisa,dataq		; DS1302 I/O = output to read
        bank0
        movlw   second
        movwf   fsr			; pointer sur RAM PIC second
        call    rbyte			; lecture secondes
        call    rbyte			;lecture minutes
        call    rbyte			;lecture heure
        call    rbyte			;lecture date
        call    rbyte			;lecture mois
        call    rbyte			;lecture jour
        call    rbyte			;lecture annee
        bcf     DS1302_RST          ;assert RST
	nop
        return
;--------------------
wbyte   movwf   Rdecal2
        movlw   8
        movwf   dummy2
wbit    bcf     DS1302_SCLK
        btfss   Rdecal2,0
        bcf     DS1302_DATA
        btfsc   Rdecal2,0
        bsf     DS1302_DATA
        nop
        nop                    
        nop
        bsf     DS1302_SCLK
        rrf     Rdecal2,f
        decfsz  dummy2,f
        goto    wbit
        return
;-------------------
rbyte   movlw   8
        movwf   dummy1
rbit    bcf     DS1302_SCLK
        nop
        nop                     ;clock to data delay
        rrf     indf,f
        bcf     indf,7
        btfsc   DS1302_DATA
        bsf     indf,7
        bsf     DS1302_SCLK
        nop
        nop
        decfsz  dummy1,f
        goto    rbit
        incf    fsr,f
        return
;-----------------
crush_dump
		movlw   0x20       
                call Send_Char   
      	    	movlw   0x20    
                call Send_Char   
		call    Read_Clock    
                movlw   '2'
                call 	Send_Char       
                movlw   '0'
                call 	Send_Char      
                goto    crush_dump2
crush_dump2
                movf    year,w          
                call    packBCD_to_ascii     
                movlw   '/'          
                call 	Send_Char  
                movf    month,w
                call    packBCD_to_ascii  
                movlw   0x2F       
                call 	Send_Char 
                movf    date,w
                call    packBCD_to_ascii 
                movlw   ' '      
                call Send_Char    
                movlw   0x20       
                call Send_Char  
                movf    hour,w
                call    packBCD_to_ascii  
                movlw   0x3A  
                call Send_Char    
                movf    minute,w
                call    packBCD_to_ascii 
                movlw   0x3A    
                call Send_Char  
                movf    second,w
                call    packBCD_to_ascii       
                movlw   ' '
                call Send_Char   
		movlw   ' '
                call Send_Char     
	        return
;---------------------------------
packBCD_to_ascii
;takes packed bcd byte in w -> ascii ->tx rs232 HI nibble first        
                movwf   dummy         ;eg w=98 dummy=98 for years, say
                movwf   dummy1
                swapf   dummy,f    	;eg dummy=89
                movlw   0x0F        ;mask nibble for years 10s
                andwf   dummy,f    	;eg dummy=09
                movlw   0x30        ;convert to ascii
                addwf   dummy,w     ;eg dummy=39 , produces years 10s , in ascii, in w
                call 	Send_Char   ;char out  HI nibble
                movf    dummy1,w    ;eg year=98
                movwf   dummy       ;eg dummy=98
                movlw   0x0F        ;mask nibble for years units               
                andwf   dummy,f     ;eg dummy=08
                movlw   0x30        ;convert to ascii
                addwf   dummy,w     ;eg dummy=38="8"
                call Send_Char      ;char out LO nibble
        return          

cr_lf           ;carriage return + line feed to rs232 port
                movlw   0x0D       ;CR
                call Send_Char
                movlw   0x0A      ;LF
                call Send_Char
                return          
;---------------------------
blancs      				;10 blancs sur la gauche
                movlw   0x0A
                movwf   dummy
                movlw   ' '  
                call Send_Char
                decfsz  dummy,f
                goto    $-3
        return  
;--------------------
  ;Binary - BCD   32 bits :  FFFFFFFF -> 10 digits
    ;Input in buff_4|buff_3|buff_2|buff_1,
    ;Converts to *packed* bcd in temp_a, temp_b, temp_c, temp_d and temp_e
    ;with the MSD temp_a.
    ;Handles full range:  ff ff ff ff -> 4,294,967,296
    ;Also uses temp_f and count.
    ;2940 cycles including call and return.

bin2bcd:
   bcf     status,c
   movlw   32
   movwf   count5
   clrf    temp_a
   clrf    temp_b
   clrf    temp_c
   clrf    temp_d
   clrf    temp_e
bin2bcd_loop:
   rlf     buff_1, F
   rlf     buff_2, F
   rlf     buff_3, F
   rlf     buff_4, F
   rlf     temp_e, F
   rlf     temp_d, F
   rlf     temp_c, F
   rlf     temp_b, F
   rlf     temp_a, F
   decfsz  count5, F
   goto    adj_dec
   goto    done
adj_dec:
   movlw   temp_e
   movwf   fsr
   call    adj_bcd
   movlw   temp_d
   movwf   fsr
   call    adj_bcd
   movlw   temp_c
   movwf   fsr
   call    adj_bcd
   movlw   temp_b
   movwf   fsr
   call    adj_bcd
   movlw   temp_a
   movwf   fsr
   call    adj_bcd
   goto    bin2bcd_loop
adj_bcd:
   movlw   h'3'
   addwf   indf, W
   movwf   temp_f
   btfsc   temp_f, 3
   movwf   indf
   movlw   h'30'
   addwf   indf, W
   movwf   temp_f
   btfsc   temp_f, 7
   movwf   indf
   return
done:
   return


;--------------------------
incw_bcd        ;increment a packed bcd 8bit freg., enter with data in w
                ;ex T Scott Dattalo, 20/4/98
                movwf   dummy
        IFDEF minisimDE
                movlw   '11111110b'       
        else
                movlw   11111110b 
        Endif
                addlw   0x9A+1
                subwf   dummy,w
                rlf     dummy,f
                btfss   status,dc
                addlw   -0x06
                btfss   dummy,0
                addlw   -0x60
                rrf     dummy,f    ;result in w
	        return          

decw_bcd        ;decrement a packed bcd freg., enter sub with data in w
                ;ex T Scott Dattalo, 20/4/98
                movwf   dummy
                movlw   1
                subwf   dummy,w
                rlf     dummy,f
                btfss   status,dc
                addlw   -0x06   
                btfss   dummy,0
                addlw   -0x60
                rrf     dummy,f    ;result in w
      	  return

inc_minute_bcd  ;incr minutes reg by 1, check for not overflow 60s
                movf    minute,w
                sublw   0x60            ;59hex means 59dec in packed bcd
                btfsc   status,z
                return                  ;z got set if minutes=59,so don't incr
                movf    minute,w
                call    incw_bcd
                movwf   minute
        return

dec_minute_bcd  ;decrement minute reg, check for zero underflow
                movf    minute,w
                btfsc   status,z
                return                  ;underflow danger, don't decr
                call    decw_bcd
                movwf   minute
        return

inc_hour_bcd    ;incr hours, packed bcd representation
                movf    hour,w
                sublw   0x24
                btfsc   status,z
                return
                movf    hour,w
                call    incw_bcd
                movwf   hour
        return

dec_hour_bcd    ;decrement hour reg, check for zero underflow
                movf    hour,w
                btfsc   status,z
                return                  ;underflow danger, don't decr
                call    decw_bcd
                movwf   hour
        return

inc_date_bcd    ;incr date of month,packed bcd,cheat & assume all months <= 31days
                movf    date,w
                sublw   0x31
                btfsc   status,z
                return
                movf    date,w
                call    incw_bcd
                movwf   date
        return
dec_date_bcd    ;decrement date reg, check for zero underflow
                movf    date,w
                btfsc   status,z
                return                  ;underflow danger, don't decr
                call    decw_bcd
                movwf   date
        return

inc_month_bcd   ;incr month,packed bcd
                movf    month,w
                sublw   0x12
                btfsc   status,z
                return
                movf    month,w
                call    incw_bcd
                movwf   month
        return
dec_month_bcd   ;decrement date reg, check for zero underflow
                movf    month,w
                btfsc   status,z
                return                  ;underflow danger, don't decr
                call    decw_bcd
                movwf   month
        return

inc_year_bcd    ;incr year, packed bcd
                movf    year,w
                sublw   0x99
                btfsc   status,z
                return
                movf    year,w
                call    incw_bcd
                movwf   year
        return
dec_year_bcd    ;decrement date reg, check for zero underflow
                movf    year,w
                btfsc   status,z
                return                  ;underflow danger, don't decr
                call    decw_bcd
                movwf   year
        return

;specific bcd handling routines end

;-----------------------------------
;delais4M.inc pour Fquartz=4Mhz
;count1	;delay routines
;count2      ;delay routines
;count3      ;delay routines
;delay
;delay1	; 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us
;delay_100us  
;delay_200us 
;delay_1ms 
;delay_100ms
;Delay_1sec 
;delay_10sec
;last update: 28 mars 2003
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	  ifdef minisimDE
          MOVLW          67
        ELSE
         MOVLW           .67          ; .67 pour 4800 bauds
        ENDIF
         MOVWF           count1		; 1000000/4800=208S
         DECFSZ          count1,F	; 1 cycle si pas de saut
         GOTO            $-1		; 2cycles
         Return				; 67* 3*1=201S
;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------

delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   0x05
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
        
delay_200us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   40
                movwf   count3
                goto    delay1
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     	movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1

;--------------------------------------------
;*General purpose 16F84 EEPROM register read/write
;The following `eprom write' routine requires that eeadr @ loc 0x009
;in bank0 contains the address of the eeprom data byte to be loaded.
;The data must be pre-loaded in eedata @ loc 0x008 in bank0
;In addition, the  eecon1,wren   bit in bank1 regs. must be set before 
;calling this routine. Then cleared after using it.

read_EE	
	movwf   eeadr           ; defini offset addresse
	bank1			; pour PIC16F84  only
	bsf     eecon1,eerd     ; mode lecture
	bank0
	movf    eedata,W       	; recupere lecture
	return

eeprom_wr                       ;write byte to eeprom loc.
        bcf     intcon,gie      ;make sure ints disabled, work on bank1
        btfsc   intcon,gie      ;to-be-suuuure
        goto    $-1
        bank1			  ;set to bank 1,see c84 para 7.2
        movlw   0x055           ;fairy-godmother value, given by uchip
        movwf   eecon2          ;-actually for diode pump charging hv cell drives-
        movlw   0x0AA           ;another fairy-godmother value
        movwf   eecon2
        bsf     eecon1,eewr     ;set write control bit & begin write
        btfsc   eecon1,eewr     ;poll write control bit until h/w resets it LO
        goto    $-1             ;write until job done
        bcf     eecon1,eeif     ;must clear this bit, don't know why??
        bank0
   ;enable global ints here, if using them.ie  bsf  intcon,gie
        return

;following routine requires eeadr to be pre-loaded with the eeprom location
;--like a pointer. The contents of the location are returned in eedata reg.
eeprom_rd                       ;read byte value from eeprom ->w reg
        bank1
        bsf     eecon1,eerd     ;ee read
        bank0
        return
;--------------------------------------
; Lecture octet sur port RS232 @ 4800bds
Read_RS  Clrf            RsByte
         Movlw           H'08'                   ;byte 8 bit
         Movwf           RsCount
         Btfsc           SERIAL_RX           ;Attendre bit start
         Goto            $-1                     ;si zero = bit start = goto loop
Rx_Loop    call            Delay                   ;bit de start
         Bcf             status,c                ;Carry=0
         Btfsc           SERIAL_RX           ;lit et test l'entre RB0
         Bsf             status,c                ;Rx =1, saute si Rx =0
         rrf             RsByte,f        
         Decfsz          RsCount,f
         Goto            Rx_Loop                
         Return                       
;---------------------------
Send_Char
	 movwf	 RsBuffer
	 Movlw           8           ;correspond  un byte de 8 bits
         Movwf           RsCount         ;place dans RsCount
         Bcf             SERIAL_TX       ;bit start  0
         Call            Delay           ;wait valeur 1bit 4800 Bauds
         Rrf             RsBuffer,F        ;shift droite dans carry
         Btfsc           status,c        ;si carry 0 alors saute
         Goto            $+3             ;carry =1
         Bcf             SERIAL_TX       ;Tx =0
         Goto            $+2
         Bsf             SERIAL_TX       ;Tx =1
         Call            Delay
         Decfsz          RsCount,F       ;RsCount =RsCount -1
         Goto            $-8
         Bsf             SERIAL_TX       ;bit de stop  1
      Call            Delay           ;byte envoy
	Call            Delay 

  	return
;--------------------------
; conv mot 16bits --> C
bcd_temp
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1
	swapf  val1,w	
	iorlw  0xf0
	movwf  mille 
	addwf  mille,f 
	addlw  0xE2 
	movwf  cent 
	addlw  0x32 
	movwf  un 
	movf   val1,w 
	andlw  0x0F 
	addwf  cent,f 
	addwf  cent,f 
	addwf  un,f 
	addlw  0xE9 
	movwf  dix 
	addwf  dix,f 
	addwf  dix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  dix,f 
	addwf  un,f 
	rlf    dix,f 
	rlf    un,f 
	comf   un,f 
	rlf    un,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  un,f 
	rlf    mille,f 
	movlw  0x07 
	movwf  dixmil 
        movlw  0x0A
Lb1: 	addwf  un,f 
	decf   dix,f 
	btfss  status,c
	goto   Lb1 
Lb2:	addwf  dix,f 
	decf   cent,f 
	btfss  status,c
	goto   Lb2 
Lb3:	addwf  cent,f 
	decf   mille,f 
	btfss  status,c
	goto   Lb3 
Lb4:	addwf  mille,f 
      decf   dixmil,f 
	btfss  status,c
      goto   Lb4 
Lb5:
	movf   mille,w
	addlw  '0'
	call   Send_Char
	movf   cent,w
	addlw  '0'
	call   Send_Char
	movf   dix,w
	addlw  '0'
	call   Send_Char
	btfsc Drapeau,1
	goto Lb6
	movlw ','
	Call Send_Char
Lb6	movf   un,w
	addlw  '0'
	call   Send_Char
	btfss Drapeau,1
	goto Lb8
	movlw	'.'
	call Send_Char
	movlw 'C'
	call Send_Char
Lb7	movlw ' '
	call Send_Char
	return
Lb8	movlw	'm'
	call Send_Char
	movlw	'V'
	call Send_Char
	goto Lb7
	
;-----------------------
Affiche_Degres
	bsf Drapeau,1
	movlw EE1-EE0
	MOVWF Cpt1
Aff1
	movf Cpt1,w
	call read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	status,z	; zero= fin de message ?
	GOTO	Aff2  	
	call Send_Char
	goto Aff1
Aff2
	call LTC1286
	movf Hi_Temp,W
	movwf	val1
	movf Lo_Temp,W
	movwf	val1+1
	call 	bcd_temp
	call cr_lf
	return
;-----------------
LTC1286
	bsf Ltc_CS
	nop
	nop
	bcf Ltc_CLOCK
	nop
	bcf Ltc_CS		; CS=0
	clrf Lo_Temp
	clrf Hi_Temp
	movlw 10		; delai de convertion
	movwf Cpt2
Ltc0
	nop
	Decfsz Cpt2,f
	goto Ltc0
	
	movlw 4
	movwf Cpt2
	call L_clk
	call L_clk
	call L_clk
Ltc1
	rlf Hi_Temp,f
	btfss Ltc_DATA
	bcf Hi_Temp,0
	btfsc Ltc_DATA
	bsf Hi_Temp,0
	call L_clk
	Decfsz Cpt2,f
	goto Ltc1

	movlw 8
	movwf Cpt2
Ltc2
	rlf Lo_Temp,f
	btfss Ltc_DATA
	bcf Lo_Temp,0
	btfsc Ltc_DATA
	bsf Lo_Temp,0
	call L_clk
	Decfsz Cpt2,f
	goto Ltc2
	bsf Ltc_CS
	return
	
L_clk
	bsf Ltc_CLOCK
	nop
	nop
	bcf Ltc_CLOCK
	nop
	return
;----------------------------------

	org 0x2100
;      '1234567890123456'
EE0 DT "Val.ANA=",0
EE1 DT "Temp=",0
EE2 DT "Modif RTC",13,10
    DT "  AMJHM",13,10
    DT "+ 97531",13,10
    DT "- 86420",13,10,0
EE3 DT "Cde=",0

        end

