; attention un EQU sans label devant bloque l'assemblage!!!
; usage des plugins:  lCD 2x16/4 bits sur port B et CTRL sur port A  et Clavier/port B7..4
;**************************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************
        include <p16f84_.inc>
	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************

OSC_FREQ        EQU     D'4000000'      ; Oscillator Frequency is 4 MHz
;	constantes a definir dans le programme principal:
; afficheur LCD en mode 4 bits
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA	EQU PORTB	; LCD DATA 1,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL	EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
	ifdef miniSimDE
LCD_E           EQU 2		; LCD: Ligne de commande de controle de l'afficheur
LCD_RW          EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	else
LCD_E           EQU 1		; LCD: Ligne de commande de controle de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	endif
LINE1           EQU     0x080   ; Set display to line 1 character 0
LINE2           EQU     0x0C0   ; Set display to line 2 character 0

#DEFINE	Led_Hecto   3       ; led entre RA3 et +5V 1=eteint 0=allum
#define	 Trx        PORTA,4

;==== Currently set for 100 MHz Oscillator =======
ref_osc_3   equ 0x2A              ; Most significant osc byte
ref_osc_2   equ 0xF3              ; Next byte
ref_osc_1   equ 0x1D              ; Next byte
ref_osc_0   equ 0xC4              ; Least significant byte

; Limit contains the upper limit frequency as a 32 bit integer.
limit_3   equ 0x01                ; Most significant byte for 30 MHz
limit_2   equ 0xC9                ; Next byte
limit_1   equ 0xC3                ; Next byte
limit_0   equ 0x80                ; Least significant byte
; Default contains the default startup frequency as a 32 bit integer.
default_3 equ 0x00                ; Most significant byte for 14.025 MHz
default_2 equ 0xD6                ; Next byte
default_1 equ 0x01                ; Next byte
default_0 equ 0x28                ; Least significant byte 

#define RAMstart 0x0C			; pour 16F84


IndexP          	EQU 	RAMstart
Cpt1            	EQU 	RAMstart+1     
count1          	EQU	RAMstart+2
count2          	EQU	RAMstart+3
count3          	EQU	RAMstart+4
LCDtmp          	EQU	RAMstart+5
LCDtmp1         	EQU	RAMstart+6

bin		    	EQU 	RAMstart+7  ; 32-bit binary number (unsigned)
bcd		        EQU 	RAMstart+11 ; 10 BCD digits or 10 ascii chars
val24           EQU     RAMstart+21 ; 32 bits
pti		        EQU 	RAMstart+26 ; pointer
pto		        EQU 	RAMstart+27 ; pointer
ii			    EQU 	RAMstart+28 
temp			EQU 	RAMstart+29 
cnt			    EQU 	RAMstart+30 

w_temp		    EQU 	RAMstart+31
status_temp     EQU 	RAMstart+32
CptmS           EQU 	RAMstart+33
Seconde         EQU 	RAMstart+34
btmp            EQU 	RAMstart+35
_RsByte         EQU 	RAMstart+36
tmp             EQU 	RAMstart+37
cpt             EQU 	RAMstart+38
valeur          EQU 	RAMstart+39        ; 32 bits
valDigit          EQU   RAMstart+43
Nb              EQU   RAMstart+44
Drapeau         Equ  RAMstart+45

DELAY_W		EQU   RAMstart+47
DELAY_T		EQU   RAMstart+48
DELAY_H		EQU   RAMstart+49
DELAY_L		EQU   RAMstart+50
indice      EQU   RAMstart+51
sauve       EQU   RAMstart+52
IntervalSec EQU   RAMstart+53
LastRam     EQU	    RAMstart+54	
	IF ( (LastRam) > 0x4F )
		ERROR   "Attention debordement zone RAM"
	ENDIF


loadd	macro                     ; initalise mot de 32 bits
#define	number	192837465
	local	m,n,p
p = number / 16777216
	movlw	p
	movwf	bin                ; was bin
m = (number - p * 16777216) / 65536
	movlw	m
	movwf	bin+1
n = (number - p * 16777216 - m * 65536) / 256
	movlw	n
	movwf	bin+2
	movlw	number - p * 16777216 - m * 65536 - n * 256
	movwf	bin+3
	endm



;**************************************************************
; Program start
;**************************************************************
	ORG     0x00                ; RESET vector location
RESET           GOTO    DEBUT
;**************************************************************

        org 0x004		; adresse d'interruption

INTERRUPT   BCF     STATUS, RP0     ; Select bank 0
            movwf  	w_temp  	; sauver registre W
            swapf	STATUS , w	; swap status avec rsultat dans w
	      movwf	status_temp	; sauver status swapp
            btfss	INTCON,TOIF	; oui, tester si interrupt timer en cours
            call    IT_Timer
            swapf	status_temp,w	;fetch status, reswap nibbles
		movwf	STATUS		;restore status
		swapf	w_temp,f	;swap nibbles in preparation
		swapf	w_temp,w	;for the swap restoration of w
		retfie			;return from interrupt

IT_Timer        incf CptmS,f
                movf CptmS,W
                sublw 100
                BTFSC STATUS,Z
                goto IT_T2
                incf Seconde,f
                Clrf CptmS
                movf Seconde,W
                sublw 60
                BTFSC STATUS,Z
IT_T2           Goto $+1
                GOTO $+1
IT_T3           Goto $+1
                GOTO $+1  
IT_T4           MOVLW 60
                MOVWF TMR0              
                BCF INTCON,TOIF ;raz flag interrupt
                return

;=============================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=============================================================================

TABLE_ST      	
            ifdef miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
            endif
       MOVWF  PCL 
HexTable  
	ADDWF PCL, F
	DT "0123456789ABCDEF",0


;***************************************************************************
; Initialize processor registers
;*****************************************************************************
DEBUT                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear all int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB
                

		bank1
        	MOVLW   0x00      ; RA 4-3-2-1-0 outputs
		MOVWF   PORTA
		MOVLW   0x0F      ; RB 7-6-5-4 outputs,  RB 3-2-1-0 inputs
		MOVWF   PORTB
		MOVLW	B'00000111'	;   Option register setup:
					;0 RB Pullups
                                        ;0 interrupt on rising edge RB0
					;0 TMR0 fed from internal clock
                                        ;0 incr TMR0 on rising edge RA4
					;0 Assign prescaler to TMR0
					;111 use 1:256 prescaling ratio TMR0 rate
                
		MOVWF	OPTION_REG
		bank0
            MOVLW B'00001000'  ;Intcon Register:
                               ;0 GIE Disable interrupts
                               ;0 Disable EEIE EEwrite complete interrupt
                               ;0 Disable TOIE TMR0 Oververflow Interrupt
                               ;0 Disable INTE RBO Interrupt Enable
                               ;1 Enable RBIE Port change interrupt
                               ;0 Clear TOIF interrupt flag for TMR0 overflow                                
                               ;0 Clear INTF interrupt flag bit for RB0
                               ;0 Clear RBIF interrupt flag for RBx change
           ; MoVWF INTCON
           ; MOVLW 60
           ; MOVWF TMR0
	
	CALL    LCD_Init   ; Initialize LCDisplay
		
;============================
Pres
       
	call LCD_Cls
	MOVLW	LINE1	;
	CALL	LCD_Cde	; Set to first line
Pres1
      clrf Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call LCD_Putchar
	goto Pres3
Pres4
        clrf bcd+0
        clrf bcd+1
        clrf bcd+2
        clrf bcd+3


        movlw '1'
        movwf bcd
        movlw '2'
        movwf bcd+1     ; 10
        movlw '3'
        movwf bcd+2     ; 100
        movlw '4'
        movwf bcd+3     ;1000
        movlw '5'
        movwf bcd+4     ;10000
       movlw '0'
        movwf bcd+5     ;100000
       movlw '0'
        movwf bcd+6     
       movlw '0'
        movwf bcd+7     
       movlw '0'
        movwf bcd+8    
       movlw '0'
        movwf bcd+9     
 	call LCD_Clear1
        call affiche_10car
        call delay_2_5s

        movlw 5         ;nb de digits ascii donc 00000 a 99999 maxi
        movwf cpt
        movlw bcd       ; pointeur entree bcd ascii
        movwf pti
iter0  
        movf pti,w      ;pointeur sur bcd ascii
        addwf cpt,w 
        ADDLW -1    
        movwf FSR
        movf INDF,w
        movwf valDigit       ; recupere ascii
        movlw '0'       ;
        subwf valDigit,w
        andlw 0xFF      ; si zero on strap
        btfsC STATUS,Z
        goto iter2

        movwf Nb        ; nb iterations =val du digit
        ;calcul adresse eeprom
        movf cpt,w 
        ADDLW -1  
        movwf tmp
        bcf STATUS,C
        rLf tmp,f
        rLf tmp,f
        movf tmp,w      ; position digit *4 
        addlw EE1-EE0
  
        movwf tmp
        call read_EE     ; position eeprom suivante MSB
        movwf valeur+3
        incf tmp,f 
        movf tmp,w      ; position eeprom suivante
        call read_EE     ; poids binaire
        movwf valeur+2
        incf tmp,f 
        movf tmp,w      ; position eeprom suivante
        call read_EE     ; poids binaire
        movwf valeur+1
         incf tmp,f 
        movf tmp,w      ; position digit *4 
        call read_EE     ;position eeprom suivante LSB
        movwf valeur+0

        clrf bin+0
        clrf bin+1
        clrf bin+2
        clrf bin+3
        ;addition 32 bits
        movf Nb,w       ; nb iterations
    ; 24 bit add
iter1
        bcf Drapeau,7   ; overflow
        movf    valeur+0,w         ; Get the low byte increment
        addwf   bin,f           ; Add it to the low osc byte
        btfss   STATUS,C        ; Was there a carry?
        goto    add4              ; No, add the next bytes
        incfsz  bin+1,f           ; Ripple carry up to the next byte
        goto    add4              ; No new carry, add the next bytes
        incfsz  bin+2,f           ; Ripple carry up to the next byte
        goto    add4              ; No new carry, add the next bytes
        incf    bin+3,f           ; Ripple carry up to the highest byte
add4
        movf    valeur+1,w         ; Get the second byte increment
        addwf   bin+1,f           ; Add it to the second osc byte
        btfss   STATUS,C        ; Was there a carry?
        goto    add5              ; No, add the third bytes
        incfsz  bin+2,f           ; Ripple carry up to the next byte
        goto    add5              ; No new carry, add the third bytes
        incf    bin+3,f           ; Ripple carry up to the highest byte
add5
        movf    valeur+2,w         ; Get the third byte increment
        addwf   bin+2,f           ; Add it to the third osc byte
        btfss   STATUS,C        ; Was there a carry?
        goto    add6              ; No, add the fourth bytes
        incf    bin+3,f           ; Ripple carry up to the highest byte
add6
        movf    valeur+3,w         ; Get the fourth byte increment
        addwf   bin+3,f  

        bsf Drapeau,7   ; overflow

    
       decfsz Nb,f
       goto iter1
iter2
        decf cpt,f
        btfss STATUS ,Z
        goto iter0
 

	call LCD_Clear2
	call	b2bcd		; convert to 32-bit binary to 10 bcd
	call	bcd2a		; convert 10 bcd to 10 ascii
        call affiche_10car
        call delay_2_5s
       call delay_2_5s

	goto	Pres

;**********************************

affiche_10car
	movlw	bcd+7
	movwf	pto		; destination pointer
	movlw	8		; 5 car to process
	movwf	cnt
aff10	movf	pto,w		; get current output pointer
	movwf	FSR
	movf	INDF,w		; get 1 car
        call    LCD_Putchar
	DECF	pto,f		; prepare for next
	decfsz	cnt,f		; all digits?
	goto	aff10
        return


;******************************************************************
; Convert the 10 binary coded digits (5 bytes) starting at 
; <bcd> into an ascii string also starting at <bcd>. Original
; bcd digits are lost.
bcd2a	movlw	bcd+9
	movwf	pto		; destination pointer
	movlw	bcd+4
	movwf	pti		; source pointer
	movlw	5		; 5 bytes to process
	movwf	cnt
bcd2a1	movf	pti,w		; get current input pointer
	movwf	FSR
	decf	pti,f		; prepare for next
	movf	INDF,w		; get 2 bcds
	movwf	temp		; save for later
	movf	pto,w		; get current output pointer
	movwf	FSR
	decf	pto,f		; prepare for next
	decf	pto,f
	movf	temp,w		; get digits back
	andlw	0x0f		; process lsd
	addlw	'0'
	movwf	INDF		; to output
	decf	FSR,f
	swapf	temp,w		; process msd
	andlw	0x0f
	addlw	'0'
	movwf	INDF		; to output
	decfsz	cnt,f		; all digits?
	goto	bcd2a1
	return			; yes

;******************************************************************
; Convert 32-bit binary number at <bin> into a bcd number
; at <bcd>. Uses Mike Keitz's procedure for handling bcd 
; adjust; Modified Microchip AN526 for 32-bits.
b2bcd	movlw	32		; 32-bits
	movwf	ii		; make cycle counter
	clrf	bcd		; clear result area
	clrf	bcd+1
	clrf	bcd+2
	clrf	bcd+3
	clrf	bcd+4
b2bcd2	movlw	bcd		; make pointer
	movwf	FSR
	movlw	5
	movwf	cnt

; Mike's routine:
b2bcd3
	movlw	0x33		
	addwf	INDF,f		; add to both nybbles
	btfsc	INDF,3		; test if low result > 7
	andlw	0xf0		; low result >7 so take the 3 out
	btfsc	INDF,7		; test if high result > 7
	andlw	0x0f		; high result > 7 so ok
	subwf	INDF,f		; any results <= 7, subtract back
	incf	FSR,f		; point to next
	decfsz	cnt,f
	goto	b2bcd3
	rlf	bin+3,f		; get another bit
	rlf	bin+2,f
	rlf	bin+1,f
	rlf	bin+0,f
	rlf	bcd+4,f		; put it into bcd
	rlf	bcd+3,f
	rlf	bcd+2,f
	rlf	bcd+1,f
	rlf	bcd+0,f
	decfsz	ii,f		; all done?
	goto	b2bcd2		; no, loop
	return			; yes
   

;***********************************************

Affich_Hexa
        movwf  btmp		; affichage octet --> Hexadecimal 2 digits ( de 00 a FF )
        swapf btmp,w
        andlw 0x0F
        addlw HexTable
        call TABLE_ST
        call LCD_Putchar
        movf btmp,w
        andlw 0x0f
        addlw HexTable
        call TABLE_ST
        call LCD_Putchar
  	return

;========================

RS_CRLF
	movf _RsByte,w	;sauve W
	movlw 13
	call RS_Putchar
	movlw 10
	call RS_Putchar
	movwf _RsByte	;restitue W
	return


Init_DS1307:
        nop
        nop
        return

;======================================

;**************************************************************
; Envoi de message via table de message dans la zone programme
;**************************************************************
TABLE_MSG
		MOVWF   Cpt1         ; Point to the first char. we want
LOOP_WR         
		MOVF   Cpt1,W         ; Renew the pointer
		CALL    TABLE_ST        ; Initiate table lookup
		XORLW   0x00            ; Is this the terminating char?
		BTFSC   STATUS,Z
		GOTO    END_WR
		CALL    LCD_Putchar      ; Actually put the char on display
		INCF    Cpt1,f	; Point to the next char
		GOTO    LOOP_WR         ; Do next character
END_WR
		RETURN
;=========================
; rev 26 janv 2003 lcd4c.inc
; fichiers lis:   delais_b.inc  lcd4c.h
;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;	LCD_Init : initialisation de l'afficheur
;	LCD_Putchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCD_Cde  : envoi une commande ( contenue dans w)  l'afficheur
;	LCD_Cls  : efface l'afficheur
;	LCD_Clear1 : efface la premiere ligne de l'afficheur
;	LCD_Clear2 : efface la deuxieme ligne de l'afficheur
;	LCD_Home : renvoi le curseur en haut a gauche
;	LCD_Line1 : renvoi le curseur au debut de la ligne 1
;	LCD_Line2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset	call LCD_Cde
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset	call LCD_Cde

;	variables a definir dans le programme principal:
;	LCDtmp,LCDTmp1			; LCD

;	constantes a definir dans le programme principal:
;	LCD_DATA	EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CTRL	EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CTRL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E		EQU 1		; LCD: Ligne de commande de controle de l'afficheur
;not used LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur

;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes


LCD_Cls  
	movlw	D'01'			; effacage de l'ecran
	call	LCD_Cde
	goto	delay_2_5ms

;--------------------
LCD_Clear1				; effacage de la 1ere ligne
	movlw	D'16'			
	movwf	LCDtmp1
	movlw	LINE1			; 0x80
	call	LCD_Cde
	call	delay_2_5ms
LCDc111
	movlw	' '
	call	LCD_Putchar
	decfsz	LCDtmp1,f
	goto	LCDc111
LCD_Line1
	movlw	LINE1
	call	LCD_Cde
	goto	delay_2_5ms
;--------------

LCD_Clear2				; effacage de la deuxieme ligne
	movlw	D'16'		
	movwf	LCDtmp1
	movlw	LINE2			; 0xC0
	call	LCD_Cde
	call	delay_2_5ms
LCDcl21
	movlw	' '
	call	LCD_Putchar
	decfsz LCDtmp1,f
	goto	LCDcl21
LCD_Line2
	movlw	LINE2
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Home
	movlw	D'02'
	call	LCD_Cde
	goto delay_2_5ms

        
RS_Putchar nop

LCD_Putchar
	bank0				; rajout 7/03/03 
	movwf	LCDtmp
	call	delay_1ms
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	nop
	endif
	bsf     LCD_CTRL, LCD_RS
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	return

LCD_Init
	bcf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_RS
	nop
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	endif
	call 	delay_2_5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bank1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	bank0
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms		
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           ; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCD_Cde
	movlw   0x008		; display off
	call    LCD_Cde
	movlw   0x00C		; display on (0x00C sans curseur, 0x00E avec , 0x00F clign. )
	call    LCD_Cde
	movlw   0x006

LCD_Cde
	movwf   LCDtmp
	ifdef miniSimDE
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	endif
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL,LCD_RW
	nop
	endif
	bcf     LCD_CTRL,LCD_RS
	nop
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	return
;-----------------------
;delais4M.inc pour Fquartz=4Mhz
;last update: 28 mars 2003
;count1 count2 count3  en bank0 pour delay routines
;delay_RS special pour routine d'attente bit 4800 Bauds
;delay : 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us delay_100us  delay_200us 
;delay_1ms delay2_5ms  delay_10ms delay_100ms delay_500ms
;delay_1sec delay_10sec
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	   MOVLW           67           ; .67 pour 4800 bauds
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
         Return
;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------
delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   5
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
   
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     	movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1
;-----------------------

;****************************************************************************		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture
	return




	ORG EEPROM
      ;"1234567890123456"
EE0 DT "Test32bz.asm",0
EE1     
	 dt     0x00,0x00, 0x00, 0x17     ;1Hz
         dt     0x00,0x00, 0x00, 0xEA     ;10Hz
         dt     0x00,0x00, 0x09, 0x2C     ;100Hz
         dt     0x00,0x00, 0x5B, 0xC0     ;1000Hz
         dt     0x00,0x03, 0x95, 0x81     ;10000Hz
         dt     0x00,0x23, 0xD7, 0x0A     ;100000Hz



		END

