; attention un EQU sans label devant bloque l'assemblage!!!
; usage des plugins:  lCD 2x16/4 bits sur port B et CTRL sur port A  et Clavier/port B7..4
;**************************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************
        include <p16f84_.inc>
	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************

OSC_FREQ        EQU     D'4000000'      ; Oscillator Frequency is 4 MHz
;	constantes a definir dans le programme principal:
; afficheur LCD en mode 4 bits
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA	EQU PORTB	; LCD DATA 1,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL	EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
LCD_E           EQU 1		; LCD: Ligne de commande de controle de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
LINE1           EQU     0x080   ; Set display to line 1 character 0
LINE2           EQU     0x0C0   ; Set display to line 2 character 0

#DEFINE	Led_Hecto   3       ; led entre RA3 et +5V 1=eteint 0=allum
#define	 Trx        PORTA,4

;==== Currently set for 100 MHz Oscillator =======
ref_osc_3   equ 0x2A              ; Most significant osc byte
ref_osc_2   equ 0xF3              ; Next byte
ref_osc_1   equ 0x1D              ; Next byte
ref_osc_0   equ 0xC4              ; Least significant byte

; Limit contains the upper limit frequency as a 32 bit integer.
limit_3   equ 0x01                ; Most significant byte for 30 MHz
limit_2   equ 0xC9                ; Next byte
limit_1   equ 0xC3                ; Next byte
limit_0   equ 0x80                ; Least significant byte
; Default contains the default startup frequency as a 32 bit integer.
default_3 equ 0x00                ; Most significant byte for 14.025 MHz
default_2 equ 0xD6                ; Next byte
default_1 equ 0x01                ; Next byte
default_0 equ 0x28                ; Least significant byte 

#define RAMstart 0x0C			; pour 16F84


IndexP          EQU 	RAMstart
Cpt1            EQU 	RAMstart+1     
count1          EQU	RAMstart+2
count2          EQU	RAMstart+3
count3          EQU	RAMstart+4
LCDtmp          EQU	RAMstart+5
LCDtmp1         EQU	RAMstart+6
bin		EQU 	RAMstart+7 ; 32-bit binary number (unsigned)
bcd		EQU 	RAMstart+11; 10 BC digits or 10 ascii chars
pti,pto		EQU 	RAMstart+21; pointers
pto             EQU     RAMstart+22
ii		EQU 	RAMstart+23 
temp		EQU 	RAMstart+24 
cnt		EQU 	RAMstart+25 


;16bits
valx	EQU 	RAMstart+26	
val1    EQU 	RAMstart+28		
val2	EQU 	RAMstart+30	
val3	EQU 	RAMstart+32	
reste	EQU 	RAMstart+34	
result	EQU 	RAMstart+36
TN_Ext	EQU 	RAMstart+38
TF_Ext	EQU 	RAMstart+40






DELAY_W		EQU   RAMStart+47
DELAY_T		EQU   RAMStart+48
DELAY_H		EQU   RAMStart+49
DELAY_L		EQU   RAMStart+50
indice          EQU   RAMStart+51
sauve          	EQU   RAMStart+52
IntervalSec     EQU   RAMStart+53
LastRam         EQU   RAMstart+54	
	IF ( (LastRam) > 0x4F )
		ERROR   "Attention debordement zone RAM"
	ENDIF


#define KELVIN 	2730 + 20 	; 273K*10mv=2730  +20= ajustage offset 0C



;**************************************************************
; Program start
;**************************************************************
	ORG     0x00                ; RESET vector location
RESET           GOTO    DEBUT
;**************************************************************

        org 0x004		; adresse d'interruption

INTERRUPT   BCF     STATUS, RP0     ; Select bank 0
            movwf  	w_temp  	; sauver registre W
            swapf	STATUS , w	; swap status avec rsultat dans w
	      movwf	status_temp	; sauver status swapp
            btfss	INTCON,TOIF	; oui, tester si interrupt timer en cours
            call    IT_Timer
            swapf	status_temp,w	;fetch status, reswap nibbles
		movwf	STATUS		;restore status
		swapf	w_temp,f	;swap nibbles in preparation
		swapf	w_temp,w	;for the swap restoration of w
		retfie			;return from interrupt

IT_Timer    incf CptmS
                movf Cptms,W
                sublw 100
                BTFSC STATUS,Z
                goto IT_T1
                incf Seconde
                Clrf Cptms
                movf Seconde,W
                sublw 60
                BTFSC STATUS,Z
IT_T2           Goto $+1
                GOTO $+1
IT_T3           Goto $+1
                GOTO $+1  
IT_T4           MOVLW 60
                MOVWF TMR0              
                BCF INTCON,TOIF ;raz flag interrupt
                return

;=============================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=============================================================================

TABLE_ST      	
            ifdef miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
            endif
       MOVWF  PCL 
HexTable  
	ADDWF PCL, F
	DT "0123456789ABCDEF",0


;***************************************************************************
; Initialize processor registers
;*****************************************************************************
DEBUT                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear all int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB
                
             clrf _RsByte
             CLRF	valx
	       CLRF	valx+1
	       CLRF	val1
	       CLRF	val1+1
	       CLRF Nt1
	       CLRF	Nt1+1
	       CLRF Nt2
	       CLRF	Nt2+1

		bank1
        	MOVLW   0x00      ; RA 4-3-2-1-0 outputs
		MOVWF   PORTA
		MOVLW   0x0F      ; RB 7-6-5-4 outputs,  RB 3-2-1-0 inputs
		MOVWF   PORTB
		MOVLW	B'00000111'	;   Option register setup:
					;0 RB Pullups
                                        ;0 interrupt on rising edge RB0
					;0 TMR0 fed from internal clock
                                        ;0 incr TMR0 on rising edge RA4
					;0 Assign prescaler to TMR0
					;111 use 1:256 prescaling ratio TMR0 rate
                
		MOVWF	OPTION_REG
		bank0
            MOVLW B'00001000'  ;Intcon Register:
                               ;0 GIE Disable interrupts
                               ;0 Disable EEIE EEwrite complete interrupt
                               ;0 Disable TOIE TMR0 Oververflow Interrupt
                               ;0 Disable INTE RBO Interrupt Enable
                               ;1 Enable RBIE Port change interrupt
                               ;0 Clear TOIF interrupt flag for TMR0 overflow                                
                               ;0 Clear INTF interrupt flag bit for RB0
                               ;0 Clear RBIF interrupt flag for RBx change
           ; MoVWF INTCON
           ; MOVLW 60
           ; MOVWF TMR0
	
	CALL    LCD_Init   ; Initialize LCDisplay
		
;============================
Pres
       
	call LCD_Cls
	MOVLW	LINE1	;
	CALL	LCD_Cde	; Set to first line
Pres1
      clrf Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call LCD_Putchar
	goto Pres3
Pres4
      clrf indice
	call LCD_Clear1
    	movf indice,w
   	movWf sauve	; registre de travail
	call bcd3	; affichage valeur indice



mise a l'echelle mesure Ext base ZERO KELVIN 273
		movlw (high) KELVIN	; (KELVIN >>8); 0A  
		movwf val2		; (msb)
		movlw (low) KELVIN	;  (KELVIN-(KELVIN >> 8)*256); BE  
		movwf val2+1	; (lsb)
		call sub16		; val1=val1-val2
; modif 23/12/06 pour traitement affichage valeur negative
		btfss STATUS,C	; negatif
		goto UpperZero
		comf val1,f
		comf val1+1,f
		incf val1+1,f	; complement a 2
		bank0
		bsf  Drapeaux,7	; negative value
UpperZero	nop
                goto	$

;*******************************************************
;16 bit subtraction with borrow   Rudy Wieser
sub16 	
	movf    val2+1,W		; source
        subwf   val1+1,F		; dest
        movf    val2,W
        btfss   STATUS,C
        incfsz  val2,W
        subwf   val1,F		;dest = dest - source, WITH VALID CARRY
        return





;******************************************************************
; Convert the 10 binary coded digits (5 bytes) starting at 
; <bcd> into an ascii string also starting at <bcd>. Original
; bcd digits are lost.
bcd2a	movlw	bcd+9
	movwf	pto		; destination pointer
	movlw	bcd+4
	movwf	pti		; source pointer
	movlw	5		; 5 bytes to process
	movwf	cnt
bcd2a1	movf	pti,w		; get current input pointer
	movwf	fsr
	decf	pti,f		; prepare for next
	movf	indf,w		; get 2 bcds
	movwf	temp		; save for later
	movf	pto,w		; get current output pointer
	movwf	fsr
	decf	pto,f		; prepare for next
	decf	pto,f
	movf	temp,w		; get digits back
	andlw	0x0f		; process lsd
	addlw	"0"
	movwf	indf		; to output
	decf	fsr,f
	swapf	temp,w		; process msd
	andlw	0x0f
	addlw	"0"
	movwf	indf		; to output
	decfsz	cnt		; all digits?
	goto	bcd2a1
	return			; yes

;******************************************************************
; Convert 32-bit binary number at <bin> into a bcd number
; at <bcd>. Uses Mike Keitz's procedure for handling bcd 
; adjust; Modified Microchip AN526 for 32-bits.
b2bcd	movlw	32		; 32-bits
	movwf	ii		; make cycle counter
	clrf	bcd		; clear result area
	clrf	bcd+1
	clrf	bcd+2
	clrf	bcd+3
	clrf	bcd+4
b2bcd2	movlw	bcd		; make pointer
	movwf	fsr
	movlw	5
	movwf	cnt

; Mike's routine:
b2bcd3
	movlw	0x33		
	addwf	indf,f		; add to both nybbles
	btfsc	indf,3		; test if low result > 7
	andlw	0xf0		; low result >7 so take the 3 out
	btfsc	indf,7		; test if high result > 7
	andlw	0x0f		; high result > 7 so ok
	subwf	indf,f		; any results <= 7, subtract back
	incf	fsr,f		; point to next
	decfsz	cnt
	goto	b2bcd3
	rlf	bin+3,f		; get another bit
	rlf	bin+2,f
	rlf	bin+1,f
	rlf	bin+0,f
	rlf	bcd+4,f		; put it into bcd
	rlf	bcd+3,f
	rlf	bcd+2,f
	rlf	bcd+1,f
	rlf	bcd+0,f
	decfsz	ii,f		; all done?
	goto	b2bcd2		; no, loop
	return			; yes
   
;***********************************************

Affich_Hexa
        movwf  btmp		; affichage octet --> Hexadecimal 2 digits ( de 00 a FF )
        swapf btmp,w
        andlw 0x0F
        addlw HexTable
        call TABLE_ST
        call LCD_Putchar
        movf btmp,w
        andlw 0x0f
        addlw HexTable
        call TABLE_ST
        call LCD_Putchar
  	return
;========================

RS_CRLF
	movf _RsByte,w	;sauve W
	movlw 13
	call RS_Putchar
	movlw 10
	call RS_Putchar
	movwf _RsByte	;restitue W
	return


 Init_DS1307:
        nop
        nop
        return

;======================================

;**************************************************************
; Envoi de message via table de message dans la zone programme
;**************************************************************
TABLE_MSG
		MOVWF   Cpt1         ; Point to the first char. we want
LOOP_WR         
		MOVF   Cpt1,W         ; Renew the pointer
		CALL    TABLE_ST        ; Initiate table lookup
		XORLW   0x00            ; Is this the terminating char?
		BTFSC   STATUS,Z
		GOTO    END_WR
		CALL    LCD_Putchar      ; Actually put the char on display
		INCF    Cpt1,f	; Point to the next char
		GOTO    LOOP_WR         ; Do next character
END_WR
		RETURN
;=========================
; rev 26 janv 2003 
include "lcd4c.inc"
; fichiers lis:   delais_b.inc  lcd4c.h
;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;	LCD_Init : initialisation de l'afficheur
;	LCD_Putchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCD_Cde  : envoi une commande ( contenue dans w)  l'afficheur
;	LCD_Cls  : efface l'afficheur
;	LCD_Clear1 : efface la premiere ligne de l'afficheur
;	LCD_Clear2 : efface la deuxieme ligne de l'afficheur
;	LCD_Home : renvoi le curseur en haut a gauche
;	LCD_Line1 : renvoi le curseur au debut de la ligne 1
;	LCD_Line2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset	call LCD_Cde
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset	call LCD_Cde
;	variables a definir dans le programme principal:
;	LCDtmp,LCDTmp1			; LCD
;	constantes a definir dans le programme principal:
;	LCD_DATA		EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CTRL		EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CTRL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E			EQU 1		; LCD: Ligne de commande de controle de l'afficheur
;not used LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur
;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes
        
RS_Putchar nop

;-----------------------
include "delais4M.inc"	; pour Fquartz=4Mhz
;last update: 28 mars 2003
;count1 count2 count3  en bank0 pour delay routines
;delay_RS special pour routine d'attente bit 4800 Bauds
;delay : 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us delay_100us  delay_200us 
;delay_1ms delay2_5ms  delay_10ms delay_100ms delay_500ms
;delay_1sec delay_10sec
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	   MOVLW           67           ; .67 pour 4800 bauds
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
         Return

;****************************************************************************		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture

	return




	ORG EEPROM
      ;"1234567890123456"
EE0 DT "miSimDE 1.7.7",0
EE1 
	   dt    0x00, 0x00, 0x17     ;1Hz
         dt    0x00, 0x00, 0xEA     ;10Hz
         dt    0x00, 0x09, 0x2C     ;100Hz
         dt    0x00, 0x5B, 0xC0     ;1000Hz
         dt    0x03, 0x95, 0x81     ;10000Hz
         dt    0x03, 0x95, 0x81     ;10000Hz
         dt    0x23, 0xD7, 0x0A     ;100000Hz

EE1 
	   dt    0x00, 0x00, 0x01     ;1
         dt    0x00, 0x00, 0x0A     ;10
         dt    0x00, 0x09, 0x64     ;100
         dt    0x00, 0x03, 0xE8     ;1000
         dt    0x00, 0x27, 0x10     ;10000
         dt    0x01, 0x86, 0xA0     ;100000

		END

