; 27/12/06  tests pour 628reg10.asm   mesure temperature negative
; attention un EQU sans label devant bloque l'assemblage!!!
; usage des plugins:  lCD 2x16/4 bits sur port B et CTRL sur port A  et Clavier/port B7..4
;**************************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************
        include <p16f84_.inc>
	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************

OSC_FREQ        EQU     D'4000000'      ; Oscillator Frequency is 4 MHz
;	constantes a definir dans le programme principal:
; afficheur LCD en mode 4 bits
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA		EQU PORTB	; LCD DATA 1,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL		EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
LCD_E           EQU 2		; LCD: Ligne de commande de controle de l'afficheur
LCD_RW          EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
LINE1           EQU     0x080   ; Set display to line 1 character 0
LINE2           EQU     0x0C0   ; Set display to line 2 character 0

#DEFINE	Led_Hecto   3       ; led entre RA3 et +5V 1=eteint 0=allum
#define	 Trx        PORTA,4

#define RAMstart 0x0C			; pour 16F84

IndexP          EQU 	RAMstart
Cpt1            EQU 	RAMstart+1     
count1          EQU	RAMstart+2
count2          EQU	RAMstart+3
count3          EQU	RAMstart+4
LCDtmp          EQU	RAMstart+5
LCDtmp1         EQU	RAMstart+6
bin		EQU 	RAMstart+7 ; 32-bit binary number (unsigned)
bcd		EQU 	RAMstart+11; 10 BC digits or 10 ascii chars
pti		EQU 	RAMstart+21; pointers
pto             EQU     RAMstart+22
ii		EQU 	RAMstart+23 
temp		EQU 	RAMstart+24 
cnt		EQU 	RAMstart+25 
;16bits ------------------------------------
valx    EQU 	RAMstart+26	
val1    EQU 	RAMstart+28		
val2	EQU 	RAMstart+30	
STF_Ext EQU   	RAMstart+32	
TN_Ext	EQU 	RAMstart+34
TF_Ext	EQU 	RAMstart+36
reste	EQU 	RAMstart+38
result EQU 	RAMstart+40
;------------------------------------------

btmp    EQU     RAMstart+42
mille  EQU     RAMstart+43
cent   EQU     RAMstart+44
dix    EQU     RAMstart+45
un     EQU     RAMstart+46
dixmil	EQU   RAMStart+47
Special_MAE EQU   RAMStart+48
SommeTEX EQU 	RAMstart+49  
Mcount EQU  	RAMstart+50
Cptms   EQU 	RAMstart+51
Seconde EQU 	RAMstart+52
IntervalSec     EQU   RAMStart+53
Drapeaux	EQU   RAMstart+54


	IF ( (Drapeaux) >= 0x4F )
		ERROR   "Attention debordement zone RAM"
	ENDIF

#define CONTEXT 0x70
w_temp	        EQU CONTEXT+1
status_temp     EQU CONTEXT+2


#define KELVIN 	2730 + 20 	; 273K*10mv=2730  +20= ajustage offset 0C
#define moins40 2330
#define plus50  3230


;**************************************************************
; Program start
;**************************************************************
	ORG     0x00                ; RESET vector location
RESET           GOTO    DEBUT
;**************************************************************

        org 0x004		; adresse d'interruption

INTERRUPT   
        BCF     STATUS, RP0     ; Select bank 0
        movwf  	w_temp  	; sauver registre W
        swapf	STATUS , w	; swap status avec rsultat dans w
	    movwf	status_temp	; sauver status swapp
        btfss	INTCON,TOIF	; oui, tester si interrupt timer en cours
        call    IT_Timer
        swapf	status_temp,w	;fetch status, reswap nibbles
		movwf	STATUS		;restore status
		swapf	w_temp,f	;swap nibbles in preparation
		swapf	w_temp,w	;for the swap restoration of w
		retfie			;return from interrupt

IT_Timer
        incf CptmS
        movf Cptms,W
        sublw 100
        BTFSC STATUS,Z
        goto IT_T1
        incf Seconde
        Clrf Cptms
        movf Seconde,W
        sublw 60
        BTFSC STATUS,Z
        Goto $+1
IT_T1   MOVLW 60
        MOVWF TMR0              
        BCF INTCON,TOIF ;raz flag interrupt
        return
;========================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=======================================================================
TABLE_ST      	
            ifdef miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
            endif
       MOVWF  PCL 
HexTable  
	ADDWF PCL, F
	DT "0123456789ABCDEF",0
;*************************************
; Initialize processor registers
;*************************************
DEBUT                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear all int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB
                
;      clrf _RsByte
       CLRF	valx
       CLRF	valx+1
       CLRF	val1
       CLRF	val1+1
       CLRF	val2
       CLRF	val2+1
       bank1
       	MOVLW   0x00      ; RA 4-3-2-1-0 outputs
		MOVWF   PORTA
		MOVLW   0x0F      ; RB 7-6-5-4 outputs,  RB 3-2-1-0 inputs
		MOVWF   PORTB
		MOVLW	B'00000111'	;   Option register setup:
					;0 RB Pullups
                    ;0 interrupt on rising edge RB0
					;0 TMR0 fed from internal clock
                    ;0 incr TMR0 on rising edge RA4
					;0 Assign prescaler to TMR0
					;111 use 1:256 prescaling ratio TMR0 rate            
		MOVWF	OPTION_REG
		bank0
        MOVLW B'00001000'  ;Intcon Register:
                     ;0 GIE Disable interrupts
                     ;0 Disable EEIE EEwrite complete interrupt
                     ;0 Disable TOIE TMR0 Oververflow Interrupt
                     ;0 Disable INTE RBO Interrupt Enable
                     ;1 Enable RBIE Port change interrupt
                     ;0 Clear TOIF interrupt flag for TMR0 overflow                                
                     ;0 Clear INTF interrupt flag bit for RB0
                     ;0 Clear RBIF interrupt flag for RBx change
           ; MoVWF INTCON
           ; MOVLW 60
           ; MOVWF TMR0
	
	    CALL    LCD_Init   ; Initialize LCDisplay
		
;============================
Pres
    call LCD_Cls
	MOVLW	LINE1	;
	CALL	LCD_Cde	; Set to first line
Pres1
    clrf Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call LCD_Putchar
	goto Pres3
Pres4
    movlw EE2-EE0
    movwf Cpt1
Pres5
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres6 	
	Call LCD_Putchar
	goto Pres5
Pres6
    Clrf SommeTEX
	clrf STF_Ext
	clrf STF_Ext+1

; ------------------------- main --------------------
main
	 CALL LCD_Clear2
     call LCD_Clear1
     movlw 0x01
     movwf Special_MAE
L1
; test avec valeur autour de zero , avec "5 inter" 
; dont 4 utilis (pour LSB de l'octet) sur port B
; variable de -1,4C  +0.1C  pour valeur 00  0F
        clrf Special_MAE
        movlw 0x0A      ; 2730 mV 0C
        movwf val1
		movlw 0xA0 ; au lieu de BE  
		movwf val1+1	; (lsb)
        movf PORTB,w    ; lecture port B
        andLw 0x0F      ; masque sur les 4 inter
        xorwf val1+1,f  ; forcage LSB offset KELVIN
        movlw 0x09      ; 2330 mV 0C
        movwf val2
		movlw 0x1A ; au lieu de BE  
		movwf val2+1	; (lsb)
        call sub16
        call LCD_Clear1
        call bcd_temp
;Filtrage Arithmetique
        movf STF_Ext,w
       	movwf val2
		movf STF_Ext+1,W
		movwf val2+1
		call add16	
		movf val1,W
		movwf STF_Ext
		movf val1+1,W
		movwf STF_Ext+1
        incf SommeTEX,f
       	MOVLW   LINE1 + 12  
		CALL    LCD_Cde 
        movf SommeTEX,w
        call bcd3
        call delay_1s
		movlw 20              ; moyenne sur 20 mesures
		subwf SommeTEX,w
		btfss STATUS,C
		goto L1       	; filtrage non ateint
        call LCD_Clear2
		movlw 2
		movwf val2+1
		clrf val2
		Call div16
		movf val1,W
		movwf TF_Ext
		movf val1+1,W
		movwf TF_Ext+1
		clrf	SommeTEX
		clrf STF_Ext
		clrf STF_Ext+1      
		bsf Drapeaux,3
		movf TF_Ext,W	  	;Temp Exter Filtree
		movwf	val1
		movf TF_Ext+1,W
		movwf	val1+1
        call LCD_Clear1
        call bcd_temp
        CALL  LCD_Clear2 
      	movlw	 'F'
		call LCD_Putchar
		MOVLW   LINE2 + 3  	; Position 3
		CALL    LCD_Cde 
        movlw 0x01
        movwf Special_MAE
        movlw 0x0F      ; -4000   
        movwf val2
		movlw 0xA0  
		movwf val2+1	; (lsb)
        call sub16
        btfss val1,7
        goto UpperZero
       	comf val1,f
		comf val1+1,f
		incf val1+1,f	; complement a 2
        movlw 0x03
        movwf special_MAE
UpperZero
       call bcd_temp
		bcf Drapeaux,2
		bcf Drapeaux,3
        call delay_10s
        goto L1
;*******************************************
;16 bit subtraction with borrow   Rudy Wieser
sub16 	
	movf    val2+1,W		; source
    subwf   val1+1,F		; dest
    movf    val2,W
    btfss   STATUS,C
    incfsz  val2,W
    subwf   val1,F		;dest = dest - source, WITH VALID CARRY
    return
;-----------------------
add16	
	movf   val2,w		; addition 16 bits
	addwf  val1,f		; val1 = val1 + val2
	movf   val2+1,w
	addwf  val1+1,f
	btfsc  STATUS, C
	incf   val1,f
	return
;-------------------------------
div16	
	clrf    reste		; division 16 bits
	clrf    reste+1		; val1 = val1 / val2       ( reste )
	movlw   16
	movwf   Mcount
div161	rlf     val1+1,f
	rlf     val1,f
	rlf     reste+1,f
	rlf     reste,f
	movf    val2,w
	subwf   reste,W
	btfss   STATUS,Z
	goto    div162
	movf    val2+1,W
	subwf   reste+1,W

div162	btfss   STATUS,C
	goto    div163
	movf    val2+1,W
	subwf   reste+1,f
	movf    val2,W
	btfss   STATUS,C
	incfsz  val2,f
	subwf   reste,f
div163 	rlf     result+1,f
 	rlf     result,f
	DECFSZ  Mcount,f     
	goto    div161
fin16	movf   result,w
	movwf  val1
	movf   result+1,w
	movwf  val1+1
	return

;=========================
; rev 26 janv 2003 lcd4c.inc
; fichiers lis:   delais_b.inc  lcd4c.h
;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;	LCD_Init : initialisation de l'afficheur
;	LCD_Putchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCD_Cde  : envoi une commande ( contenue dans w)  l'afficheur
;	LCD_Cls  : efface l'afficheur
;	LCD_Clear1 : efface la premiere ligne de l'afficheur
;	LCD_Clear2 : efface la deuxieme ligne de l'afficheur
;	LCD_Home : renvoi le curseur en haut a gauche
;	LCD_Line1 : renvoi le curseur au debut de la ligne 1
;	LCD_Line2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset	call LCD_Cde
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset	call LCD_Cde
;
;	variables a definir dans le programme principal:
;	LCDtmp,LCDTmp1			; LCD
;
;	constantes a definir dans le programme principal:
;	LCD_DATA	EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CTRL	EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CTRL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E		EQU 1		; LCD: Ligne de commande de controle de l'afficheur
;not used LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur
;
;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes


LCD_Cls  
	movlw	D'01'			; effacage de l'ecran
	call	LCD_Cde
	goto	delay_2_5ms

;--------------------
LCD_Clear1				; effacage de la 1ere ligne
	movlw	D'16'			
	movwf	LCDtmp1
	movlw	LINE1			; 0x80
	call	LCD_Cde
	call	delay_2_5ms
LCDc111
	movlw	' '
	call	LCD_Putchar
	decfsz	LCDtmp1,f
	goto	LCDc111
LCD_Line1
	movlw	LINE1
	call	LCD_Cde
	goto	delay_2_5ms
;--------------

LCD_Clear2				; effacage de la deuxieme ligne
	movlw	D'16'		
	movwf	LCDtmp1
	movlw	LINE2			; 0xC0
	call	LCD_Cde
	call	delay_2_5ms
LCDcl21
	movlw	' '
	call	LCD_Putchar
	decfsz LCDtmp1,f
	goto	LCDcl21
LCD_Line2
	movlw	LINE2
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Home
	movlw	D'02'
	call	LCD_Cde
	goto delay_2_5ms

        
RS_Putchar nop

LCD_Putchar
	bank0				; rajout 7/03/03 
	movwf	LCDtmp
	call	delay_1ms
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	nop
	endif
	bsf     LCD_CTRL, LCD_RS
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	return

LCD_Init
	bcf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_RS
	nop
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	endif
	call 	delay_2_5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bank1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	bank0
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms		
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           ; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCD_Cde
	movlw   0x008		; display off
	call    LCD_Cde
	movlw   0x00C		; display on (0x00C sans curseur, 0x00E avec , 0x00F clign. )
	call    LCD_Cde
	movlw   0x006
	
LCD_Cde
	movwf   LCDtmp
	ifdef miniSimDE
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	endif
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL,LCD_RW
	nop
	endif
	bcf     LCD_CTRL,LCD_RS
	nop
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	return
;-----------------------
;delais4M.inc pour Fquartz=4Mhz
;last update: 28 mars 2003
;count1 count2 count3  en bank0 pour delay routines
;delay_RS special pour routine d'attente bit 4800 Bauds
;delay : 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us delay_100us  delay_200us 
;delay_1ms delay2_5ms  delay_10ms delay_100ms delay_500ms
;delay_1sec delay_10sec
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	   MOVLW           67           ; .67 pour 4800 bauds
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
         Return
;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------
delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   5
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
   
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     	movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1
;-----------------------

; variable pour convertion binaire --> BCD 16bits
;bcent		EQU 	RAMstart+32
;bdix		EQU 	RAMstart+33
;bun		EQU 	RAMstart+34
;btmp		EQU 	RAMstart+35
;btmp1		EQU 	RAMstart+36
;val1		EQU 	RAMstart+37		; variable pour stockage valeur 16 bits
;val2		EQU 	RAMstart+39
;===============================================

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  cent
	movwf  dix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   cent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   dix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  un
	movf   cent,w
	call   LCD_Putchar
	movf   dix,w
	call   LCD_Putchar
	movf   un,w
	call   LCD_Putchar
	return

;****************************************
bcd_temp
	movf	val1,W
	movwf	valx
	movf	val1+1,W
	movwf	valx+1
	swapf  val1,W	
	iorlw  0xf0
	movwf  mille 
	addwf  mille,F 
	addlw  0xE2		; 226 
	movwf  cent 
	addlw  0x32		;50 
	movwf  un 
	movf   valx,W 
	andlw  0x0F 
	addwf  cent,F 
	addwf  cent,F 
	addwf  un,F 
	addlw  0xE9		;233
	movwf  dix 
	addwf  dix,F 
	addwf  dix,F 
	swapf  valx+1,W 	;<- modif 20mars03 was val1
	andlw  0x0F 
	addwf  dix,F 
	addwf  un,F 
	rlf    dix,F 
	rlf    un,F 
	comf   un,F 
	rlf    un,F 
	movf   valx+1,W 
	andlw  0x0F 
	addwf  un,F 
	rlf    mille,F 
	movlw  0x07 
	movwf  dixmil 
      movlw  0x0A
Lb1: 	addwf  un,F 
	decf   dix,F 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  dix,F 
	decf   cent,F 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  cent,F 
	decf   mille,F 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  mille,F 
      decf   dixmil,F 
	btfss  STATUS,C
      goto   Lb4
	bank0
	movlw '+'
	btfss Special_MAE,1  ; si Special_MAE=3 on traite  le cas -
	goto Lb41
	btfss Special_MAE,0  ; si Special_MAE=3 on traite  le cas -
	goto Lb41
	movlw  '-'
Lb41	call   LCD_Putchar
        bank1
	movf   dixmil,W
	btfsc STATUS,Z
	goto Lb42
	addlw  '0'
	goto Lb43
Lb42	movlw ' '
Lb43 	call   LCD_Putchar

	movf   mille,w
	btfsc STATUS,Z
	goto Lb44
	addlw  '0'
	goto Lb45
Lb44	movlw ' '
Lb45	call   LCD_Putchar
 
	movf   cent,w
	addlw  '0'
	call   LCD_Putchar
	movlw ','
 	btfss Drapeaux,3
	goto Lb51
	btfss Special_MAE,2  ; bit 2 = 4 => affichage en mV
	call   LCD_Putchar
Lb51
	movf   dix,w
	addlw  '0'
	call   LCD_Putchar
	movlw ','	
 	btfsc Drapeaux,3
	goto Lb7
	btfss Special_MAE,2  ; bit 2 = 4 => affichage en mV
	call   LCD_Putchar
Lb7
	movf   un,W
	addlw  '0'
	call   LCD_Putchar
 	btfsc Special_MAE,2 ; bit 2 = 4 si TestJN
	goto En_mV

	movlw	'd'
	call   LCD_Putchar
 	movlw 'C'
	call   LCD_Putchar
 	return
En_mV	
	movlw 'm'
	call   LCD_Putchar
 	movlw 'V'
	call   LCD_Putchar
 	return


; voir 84_IRC5_.h pour environnment et variables
;*************************************************
		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture

	return

	
ORG EEPROM
      ;"1234567890123456"
EE0 DT "miSimDE 1.7.7",0
EE1 DT "Test_z_.",0
EE2 DT "27/12/2006 ",0
EE8 DT "sec: ",0



		END

