; rev 02 sept 2004
; B0 simule capteur de Tour : ~ 3 impuls par tour de pedale
; 761 tour de pedale pour 1km avec roue de diam 700
; PI.D=	2,199114858 metre
; rapport 52/16 =3,250	developp=7,147 M soit 139,9 tours de pedales par KM
; si 3,1 tour volant d'inertie par tour de pedale => 434 impuls= 1km   ou 43 impuls=100M
;-------------------
; routine LCD 2lignes de 8 car  6 bits I/O : PortB 7 6 5 4 et PortA  0 1
; inclus routine delai4m.inc @4MHz
; programme simple pour decoder/ lire Telecommande Infrarouge Marantz 5200
;*******************************************************
; Quartz   = 4MHz
; Cycle    = 1/Fosc = 1uSec
;*******************************************************
#define miniSimDE
	include <p16f84_.inc>

	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;*****************************************************************************
; Equates, I/O, vars
;*****************************************************************************
RESET_V         EQU     0x0000          ; Address of RESET Vector
ISR_V           EQU     0x0004          ; Address of Interrupt Vector
OSC_FREQ        EQU     D'4000000'      ; Oscillator Frequency is 4 MHz

;	constantes a definir dans le programme principal:

; afficheur LCD en mode 4 bits
LCD_DATA_TRIS	EQU TRISB	; LCD DATA		Port B 
LCD_DATA	EQU PORTB	; LCD DATA 11,12,13,14  bits 4,5,6,7
LCD_CTRL_TRIS	EQU TRISA	; LCD CTRL 		Port A  
LCD_CTRL	EQU PORTA	; LCD CTRL 4,5,6   	bits 0,1,2
	ifdef miniSimDE
LCD_E           EQU 2		; LCD: Ligne de commande de controle de l'afficheur
LCD_RW          EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	else
LCD_E           EQU 1		; LCD: Ligne de commande de controle de l'afficheur
LCD_RS          EQU 0		; LCD: Ligne de selection de l'afficheur-> RA0
	endif

; PORTA bits
Capteur         EQU  0  ; RA0

; misc.
LINE1           EQU     0x080   ; Set display to line 1 character 0
LINE2           EQU     0x0C0   ; Set display to line 2 character 0

#DEFINE	Led_Hecto       3       ; led entre RA3 et +5V 1=eteint 0=allum
#DEFINE	Trx             PORTA,4
#DEFINE	RAMstart        0x0C	; pour 16F84
#define Tpd1            43      ; impuls pour 100 M
#define Tpd2            434     ; impuls pour 1Km

IndexP          EQU 	RAMstart
Cpt1            EQU 	RAMstart+1     ; A counter, used multiple places
count1          EQU	RAMstart+2
count2          EQU	RAMstart+3
count3          EQU	RAMstart+4
LCDtmp          EQU	RAMstart+5
LCDtmp1         EQU	RAMstart+6
ASCII_O         EQU     RAMstart+7      ; ASCII One's digit to print
ASCII_T         EQU     RAMstart+8      ; ASCII Ten's digit to print
ASCII_H         EQU     RAMstart+9      ; ASCII Hundred's digit to print
; variable pour convertion binaire --> BCD 16bits
bdixmil         EQU 	RAMstart+10
bmille          EQU 	RAMstart+11
bcent		EQU 	RAMstart+12
bdix		EQU 	RAMstart+13
bun		EQU 	RAMstart+14
btmp		EQU 	RAMstart+15

valx		EQU 	RAMstart+16 
val1		EQU 	RAMstart+18 
val2		EQu	Ramstart+20
Nt1		EQU	RamStart+22    
Nt2		EQU	RamStart+24    ; Nb de tour de pedale pour Hectometre
Nt3		EQU	RamStart+26    ; Nb de tour de pedale pour Kms
Kms		EQU	RamStart+28
Moyenne	        EQU	RamStart+30
Speed		EQU	RamStart+32
COMND		EQu	RamStart+34
drapeau         EQU     RAMstart+35
LastRam         EQU     RAMstart+35

	IF ( (LastRam) > 0x2F )
		ERROR   "Attention debordement zone RAM"
	ENDIF
;**************************************************************
; Program start
;**************************************************************
	ORG     RESET_V                 ; RESET vector location
RESET           GOTO    DEBUT
;**************************************************************
; This is the Periperal Interrupt routine. Should NOT get here
;**************************************************************
	ORG     ISR_V                   ; Interrupt vector location
INTERRUPT       BCF     STATUS, RP0     ; Select bank 0
                nop
                nop
		GOTO    INTERRUPT

;=============================================================================
; Table message to display: kept right up front to avoid crossing 0xff boundary
;=============================================================================

TABLE_ST      	
            ifdef miniSimDE
               ADDLW 0xFF      ;-1      car PCL increment sur instruction MOVWF !!!
            endif
                MOVWF  PCL 
MSG_S      ;     nop 	          <- autre solution rajouter un nop
                RETLW   'S'
		RETLW   'P'
		RETLW   'E'
		RETLW   'E'
		RETLW   'D'
		RETLW   '='
		RETLW   0x00
MSG_M
                RETLW   'M'
		RETLW   'O'
		RETLW   'Y'
		RETLW   'E'
		RETLW   'N'
		RETLW   '='
		RETLW   0x00
MSG_U
                RETLW   'K'
		RETLW   'M'
		RETLW   '/'
		RETLW   'H'
		RETLW   0x00
                            
MSG_N      ;     nop 	          <- autre solution rajouter un nop
                RETLW   'N'
		RETLW   'T'
		RETLW   'P'
		RETLW   'D'
		RETLW   '='
		RETLW   0x00

MSG_K           RETLW   'K'
		RETLW   'M'
		RETLW   'x'
		RETLW   '1'
		RETLW   '0'
		RETLW   '='
		RETLW   0x00

;*****************************************************************************
; Initialize processor registers
;*****************************************************************************
DEBUT                                   ; POWER_ON Reset (Beginning of program)
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    INTCON          ; Clear int-flags, Disable interrupts
		CLRF    PCLATH          ; Keep in lower 2KByte
		CLRF    PORTA           ; ALL PORT outputs should output Low.
		CLRF    PORTB

	CLRF	valx
	CLRF	valx+1
	CLRF	val1
	CLRF	val1+1
	CLRF	Kms
	CLRF	Kms+1
	CLRF 	Nt1
	CLRF	Nt1+1
	CLRF 	Nt2
	CLRF	Nt2+1
	CLRF 	Nt3
	CLRF	Nt3+1

		bank1
        	MOVLW   0x00           ; RA4 RA3-2-1-0 outputs
		MOVWF   TRISA
		MOVLW   0x0F           ; RB7-6-5-4 outputs RB 3-2-1-0 inputs
		MOVWF   TRISB
		MOVLW	B'00010001'	; Option register setup:
					; RB Pullups
					; TMR0 fed from internal clock
					; Assign prescaler to TMR0
					; use 1:4 prescaling ratio
		MOVWF	OPTION_REG

		bank0
		CALL    LCD_Init         ; Initialize LCDisplay
		
;============================
Pres
        bCf PORTA,Led_Hecto           ; allume led

	call LCD_Cls
	clrf Cpt1
	MOVLW	LINE1	;
	CALL	LCD_Cde		; Set to first line
Pres1

        movf Cpt1,w
	CALL read_EE
	incf Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Pres2  	
	Call LCD_Putchar
	goto Pres1
Pres2
	MOVLW	LINE2			;
	CALL	LCD_Cde		; Set to first line
	movlw EE1-EE0
	MOVWF Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call LCD_Putchar
	goto Pres3
Pres4
	call delay_2_5s
	call LCD_Clear1
	MOVLW	LINE1			;
	CALL	LCD_Cde		; Set to first line
	movlw EE2-EE0
	MOVWF Cpt1
Pres5
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Pres6  	
	Call LCD_Putchar
	goto Pres5
Pres6
	ifdef miniSimDE
        nop
        else
        call delay_2_5s
        endif
	call LCD_Clear2
	call LCD_Clear1
        bSf PORTA, Led_Hecto           ; eteint led

Boucle_ICI	
	       MOVf PORTB,W   ;simulation cde par "five switches"
	       ANDLW 0x0F
               movwf COMND
	       BTFSC STATUS,Z
               goto  Boucle_ICI

TraiteCde				
  ;         call delay_10ms
 		movf COMND,W
		xorlw 1	;+V
		btfsc STATUS,Z
		goto trait1

		movf COMND,W
		xorlw 2	;-V
		btfsc STATUS,Z
		goto trait2

		movf COMND,W
		xorlw 4	;BP ROUGE
		btfsc STATUS,Z
		goto trait3
		goto Boucle_ICI

trait1		
	; incremente les 3 compteur s
		incf	Nt1+1,F	; incremente LSB
		BTFSC	STATUS,Z	; si debordement MSB
		incf	Nt1,F
		incf	Nt2+1,F	; incremente LSB
		BTFSC	STATUS,Z	; si debordement MSB
		incf	Nt2,F
		incf	Nt3+1,F	; incremente LSB
		BTFSC	STATUS,Z	; si debordement MSB
		incf	Nt3,F
		
	;comptage Hectometre
        	movf 	Nt2,W	
		movwf	val1
		movf 	Nt2+1,W
		movwf	val1+1
		movlw  Tpd1/256	
		movwf val2
		movlw (Tpd1-(Tpd1/256))
		movwf val2+1
		call comp_signed16 ; 43 tdp ?
		btfss STATUS,Z	; Z=1 si mesure=consigne
		goto	Suite1

                movlw 0x08              ;Led_Hecto clignote
                XORWF PORTA,F

        ;comptage kilometre
		incf	Kms+1,F	; incremente LSB hectometre
		BTFSC	STATUS,Z	; si debordement MSB
		incf	Kms,F
		clrf Nt2
		clrf Nt2+1
		call AfficheSpeed
		goto	Suite3
Suite1

		movf 	Nt3,W	
		movwf	val1
		movf 	Nt3+1,W
		movwf	val1+1
		movlw  Tpd2/256	
		movwf val2
		movlw (Tpd2-(Tpd2/256))
		movwf val2+1
		call comp_signed16 ;mesure<consigne?
		btfss STATUS,Z
		goto Suite2

		clrf Nt3
		clrf Nt3+1
		call AfficheMoyenne
	
Suite3
		call LCD_Clear1
		MOVLW   LINE1
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_K           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
		MOVLW   LINE1+9
		CALL    LCD_Cde        
		movf 	Kms,W	
		movwf	val1
		movf 	Kms+1,W
		movwf	val1+1
		call bcd5
		goto Boucle_ICI
	
trait2	  ; incremente compteur Tour de pedale de 10
		movf 	Nt1+1,W	; incremente LSB
		addlw 10
		movwf Nt1+1
		BTFSC	STATUS,C	; si debordement MSB
		incf Nt1,F
		goto Suite2

	
trait3	        ;raz compteurs 
                clrf Nt1
		clrf Nt1+1
		clrf Nt2
		clrf Nt2+1
		clrf Nt3
		clrf Nt3+1

		goto Pres
Suite2
	; affiche Nb de Tour de pedale
		call LCD_Clear2
		MOVLW   LINE2
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_N           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
		MOVLW   LINE2+8
		CALL    LCD_Cde        
		movf 	Nt1,W	
		movwf	val1
		movf 	Nt1+1,W
		movwf	val1+1
		call bcd5

		goto Boucle_ICI

; Fin du programme principal
;======================================
comp_signed16: 
	movf val1,w
	xorlw 0x80
	movwf valx
	movf val2,w
	xorlw 0x80
	subwf valx,w	; subtract val1-val2
	goto Are_they_equal
comp_unsigned_16: 
	movf val2,w
	subwf val1,w ; subtract Y-X
Are_they_equal:
	; Are they equal ?
	skpz
	goto result_comp
	; yes, they are equal -- compare lo
		movf val2+1,w
		subwf val1+1,w	; subtract Y-X
result_comp:
	; if val2=val1 then now Z=1.
	; if val1<val2 then now C=0.   
	; if val2<=val1 then now C=1.  
	return

;==============================	
AfficheMoyenne

		call LCD_Clear2
		MOVLW   LINE2
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_M           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
		MOVLW   LINE2+8
		CALL    LCD_Cde 
		movf 	Moyenne,W	
		movwf	val1
		movf 	Moyenne+1,W
Affiche_u
		movwf	val1+1
		call bcd5
		MOVLW   LINE2+12
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_U           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
	return
;----------------------
AfficheSpeed
		call LCD_Clear2
		MOVLW   LINE2
		CALL    LCD_Cde         ; Set cursor leftmost on line 2
		MOVLW   MSG_S           ; Point to Command message
		CALL    TABLE_MSG       ; Display the message
		MOVLW   LINE2+8
		CALL    LCD_Cde        
		movf 	Speed,W	
		movwf	val1
		movf 	Speed+1,W
		goto Affiche_u


;**************************************************************
; Envoi de message via table de message dans la zone programme
;**************************************************************
TABLE_MSG
		MOVWF   Cpt1         ; Point to the first char. we want
LOOP_WR         
		MOVF   Cpt1,W         ; Renew the pointer
		CALL    TABLE_ST        ; Initiate table lookup
		XORLW   0x00            ; Is this the terminating char?
		BTFSC   STATUS,Z
		GOTO    END_WR
		CALL    LCD_Putchar      ; Actually put the char on display
		INCF    Cpt1,f	; Point to the next char
		GOTO    LOOP_WR         ; Do next character
END_WR
		RETURN
;=========================
; rev 26 janv 2003 lcd4c.inc
; fichiers lis:   delais_b.inc  lcd4c.h
;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;	LCD_Init : initialisation de l'afficheur
;	LCD_Putchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCD_Cde  : envoi une commande ( contenue dans w)  l'afficheur
;	LCD_Cls  : efface l'afficheur
;	LCD_Clear1 : efface la premiere ligne de l'afficheur
;	LCD_Clear2 : efface la deuxieme ligne de l'afficheur
;	LCD_Home : renvoi le curseur en haut a gauche
;	LCD_Line1 : renvoi le curseur au debut de la ligne 1
;	LCD_Line2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset	call LCD_Cde
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset	call LCD_Cde
;
;	variables a definir dans le programme principal:
;	LCDtmp,LCDTmp1			; LCD
;
;	constantes a definir dans le programme principal:
;	LCD_DATA	EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CTRL	EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CTRL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E		EQU 1		; LCD: Ligne de commande de controle de l'afficheur
;not used LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur
;
;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes


LCD_Cls  
	movlw	D'01'			; effacage de l'ecran
	call	LCD_Cde
	goto	delay_2_5ms

;-----------------
LCD_Clear1				; effacage de la 1ere ligne
	movlw	D'16'			
	movwf	LCDtmp1
	movlw	LINE1			; 0x80
	call	LCD_Cde
	call	delay_2_5ms
LCDc111
	movlw	' '
	call	LCD_Putchar
	decfsz	LCDtmp1,f
	goto	LCDc111
LCD_Line1	movlw	LINE1
	call	LCD_Cde
	goto	delay_2_5ms
;--------------

LCD_Clear2				; effacage de la deuxieme ligne
	movlw	D'16'		
	movwf	LCDtmp1
	movlw	LINE2			; 0xC0
	call	LCD_Cde
	call	delay_2_5ms
LCDcl21
	movlw	' '
	call	LCD_Putchar
	decfsz LCDtmp1,f
	goto	LCDcl21
	
LCD_Line2
	movlw	LINE2
	call	LCD_Cde
	goto	delay_2_5ms

LCD_Home
	movlw	D'02'
	call	LCD_Cde
	goto delay_2_5ms

LCD_Putchar
	bank0				; rajout 7/03/03 
	movwf	LCDtmp
	call	delay_1ms
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	nop
	endif
	bsf     LCD_CTRL, LCD_RS
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	nop
	bsf     LCD_CTRL, LCD_E
	call		delay_25us
	bcf     LCD_CTRL, LCD_E
	call		delay_25us
	return

LCD_Init
	bcf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_RS
	nop
	ifdef miniSimDE
	bcf     LCD_CTRL, LCD_RW
	endif
	call 	delay_2_5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bank1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	bank0
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_2_5ms		
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           ; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL, LCD_E
	nop
	bcf     LCD_CTRL, LCD_E
	movlw   0x028		; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCD_Cde
	movlw   0x008		; display off
	call    LCD_Cde
	movlw   0x00C		; display on (0x00C sans curseur, 0x00E avec , 0x00F clign. )
	call    LCD_Cde
	movlw   0x006
	
LCD_Cde
	movwf   LCDtmp
	call 	delay_100ms		; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	ifdef miniSimDE
	bcf     LCD_CTRL,LCD_RW
	nop
	endif
	bcf     LCD_CTRL,LCD_RS
	nop
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CTRL,LCD_E
	nop
	bcf     LCD_CTRL,LCD_E
	return
;-----------------------
;delais4M.inc pour Fquartz=4Mhz
;last update: 28 mars 2003
;count1 count2 count3  en bank0 pour delay routines
;delay_RS special pour routine d'attente bit 4800 Bauds
;delay : 5(count3-1)+1282(count2-1)+327684(count1-1)+6
;delay_25us delay_100us  delay_200us 
;delay_1ms delay2_5ms  delay_10ms delay_100ms delay_500ms
;delay_1sec delay_10sec
;---------------------
;special pour routine d'attente bit 4800 Bauds
delay_RS
	   MOVLW           67           ; .67 pour 4800 bauds
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
         Return
;------------------------
delay           movlw   0x001       
                movwf   count1     
                movlw   0x001     
                movwf   count2    
                movlw   0x020       
                movwf   count3    
delay1          decfsz  count3,f    
                goto    $-1          
                decfsz  count2,f  
                goto    $-3           
                decfsz  count1,f      
                goto    $-5          
        return            
;--------------

delay_25us      movlw   0x01     
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   0x05
                movwf   count3
                goto    delay1
        
delay_100us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   20
                movwf   count3
                goto    delay1
        
delay_200us     movlw   0x01    
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   40
                movwf   count3
                goto    delay1
        
delay_1ms       movlw   0x01       
                movwf   count1
                movlw   0x01
                movwf   count2
                movlw   200
                movwf   count3
                goto    delay1

delay_2_5ms       movlw   0x01       
                movwf   count1
                movlw   0x02
                movwf   count2
                movlw   243
                movwf   count3
                goto    delay1


delay_10ms       movlw   0x01      
                movwf   count1
                movlw   8
                movwf   count2
                movlw   205
                movwf   count3
                goto    delay1
		
delay_100ms     movlw   0x01        
                movwf   count1
                movlw   79
                movwf   count2
                movlw   0x01
                movwf   count3
                goto    delay1

delay_500ms	movlw 2
		movwf count1	
		movlw 135
		movwf count2
		movlw 106
		movwf count3
		goto delay1
        
delay_1s      	movlw   4          
                movwf   count1
                movlw   14
                movwf   count2
                movlw   56
                movwf   count3
                goto   delay1
                
delay_2_5s      movlw   8          
                movwf   count1
                movlw   161
                movwf   count2
                movlw   218
                movwf   count3
                goto   delay1

delay_10s     	movlw   31       
                movwf   count1
                movlw   133
                movwf   count2
                movlw   51
                movwf   count3
                goto   delay1
;-----------------------

; variable pour convertion binaire --> BCD 16bits
;bcent		EQU 	RAMstart+32
;bdix		EQU 	RAMstart+33
;bun		EQU 	RAMstart+34
;btmp		EQU 	RAMstart+35
;btmp1		EQU 	RAMstart+36
;val1		EQU 	RAMstart+37		; variable pour stockage valeur 16 bits
;val2		EQU 	RAMstart+39
;===============================================

bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bcent,w
	call   LCD_Putchar
	movf   bdix,w
	call   LCD_Putchar
	movf   bun,w
	call   LCD_Putchar
	return



; affichage octet --> decimal 5 digits ( de 0 a 65535 )
bcd5    bCf drapeau,0
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1

	swapf  val1,w	
	iorlw  0xf0
	movwf  bmille 
	addwf  bmille,f 
	addlw  0xE2 
	movwf  bcent 
	addlw  0x32 
	movwf  bun 
	movf   val1,w 
	andlw  0x0F 
	addwf  bcent,f 
	addwf  bcent,f 
	addwf  bun,f 
	addlw  0xE9 
	movwf  bdix 
	addwf  bdix,f 
	addwf  bdix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  bdix,f 
	addwf  bun,f 
	rlf    bdix,f 
	rlf    bun,f 
	comf   bun,f 
	rlf    bun,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  bun,f 
	rlf    bmille,f 
	movlw  0x07 
	movwf  bdixmil 
        movlw  0x0A
Lb1: 	addwf  bun,f 
	decf   bdix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  bdix,f 
	decf   bcent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  bcent,f 
	decf   bmille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  bmille,f 
        decf   bdixmil,f 
	btfss  STATUS,C
        goto   Lb4 
	movf   bdixmil,w
        BTFSC STATUS,Z
        movlw -48+32
	addlw  '0'
        bsf drapeau,0
Lb40:   call   LCD_Putchar
	movf   bmille,w
        BTFSC STATUS,Z
        BTFSS drapeau,0
        goto Lb41
        movlw -48+32
        bsf drapeau,0
Lb41	addlw  '0'
	call   LCD_Putchar
	movf   bcent,w
        BTFSC STATUS,Z
        BTFSS drapeau,0
        goto Lb42
        movlw -48+32
        bsf drapeau,0
Lb42	addlw  '0'
      	call   LCD_Putchar
	movf   bdix,w
        BTFSC STATUS,Z
        BTFSS drapeau,0
        goto Lb43
        movlw -48+32
        bsf drapeau,0
Lb43	addlw  '0'
	call   LCD_Putchar
	movf   bun,w
	addlw  '0'
 	call   LCD_Putchar
	movlw	' '
	call LCD_Putchar
	movf valx,w
	movwf val1
	movf valx+1,w
	movwf	val1+1
	return
;-------------------
; voir 84_IRC5_.h pour environnment et variables
;*************************************************
;==================================================================
; HEX_TO_ASC .. Converts a hex digit to three ASCII characters
;               Enter with the hex digit in ASCII_O
;               Exit with Hundreds ascii digit in ASCII_H,
;               Tens ascii digit in ASCII_T,
;               and Ones ascii digit in ASCII_O.
;               The incoming byte is not preserved.
;==================================================================

HEX_TO_ASC      MOVLW   '0'             ; Preload a zero into 10's & 100's
		MOVWF   ASCII_T
		MOVWF   ASCII_H
DO_100s         MOVLW   D'100'
		SUBWF   ASCII_O,w       ; Subtract 100 to test size
		BNC     DO_10s          ; It's less than 100, so branch
		MOVWF   ASCII_O         ; It was bigger, so decrement it
		INCF    ASCII_H,f       ; Bump up the 100's digit
		GOTO    DO_100s         ; Loop again till < 100
DO_10s          MOVLW   D'10'
		SUBWF   ASCII_O,w       ; Subtract 10 to test size
		BNC     ADJUST          ; It's less than 10, so branch
		MOVWF   ASCII_O         ; It was bigger, so decrement it
		INCF    ASCII_T,f       ; Bump up the 10's digit
		GOTO    DO_10s          ; Loop again till < 10
ADJUST          MOVLW   '0'             ; The # in ASCII_O is now < 10
		ADDWF   ASCII_O,f       ; Turn it into an ASCII character
BLANK_ZEROS     MOVLW   '0'
		XORWF   ASCII_H,w       ; Is the 100's char a 0?
		BTFSS   STATUS,Z
		GOTO    HEX_DONE        ; No.
		MOVLW   ' '             ; Yes,
		MOVWF   ASCII_H         ; So replace it with a space.
		MOVLW   '0'
		XORWF   ASCII_T,w       ; Is the 10's char a 0?
		BTFSS   STATUS,Z
		GOTO    HEX_DONE        ; No.
		MOVLW   ' '             ; Yes,
		MOVWF   ASCII_T         ; So replace it with a space
HEX_DONE        RETURN


;****************************************************************************		
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture

	return


	ORG EEPROM
      ;"1234567890123456"
EE0 DT "miSimDE 1.7.7   ",0
EE1 DT "Velo_2Z.asm     ",0
EE2 DT "09 sept 2004    ",0
        

		END
#define MUTE_		13
#define OSD_		15
#define VOLUP_		16
#define VOLDOWN_	17
#define BASSUP_		22	
#define BASSDOWN_	23
#define UP_		28
#define DOWN_		29
#define TV_		63
#define RIGHT_		43
#define LEFT_		44
#define MENUON_		82	
#define MENUOFF_	83	
#define OK_		87
