; version PIC16F84 pour PicEmulator MiSimDE 1.77
; Rs_Tx (RB2)
; Rs_Rx (RB1 )
; SCL (RB3) 6 du DS1307
; SDA (RB0) 5 du DS1307
; TRIG (RA4) 7 du DS1307

; DS1307_2.ASM
; 31 oct 2002
; modif pour PIC16F628
; V.O. Program DS1307.ASM pour DS5000 =controller8051
; This program responds to commands received over the serial
; port to set the date/time as well as RAM data on the DS1307


include <p16f84_.inc>
#define miniSimDE

	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND
	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
	

;Registres du programme

#define Ram 0x20
W_TEMP EQU Ram
STATUS_TEMP	EQU Ram+1 

#define RamRS Ram+2

TEMP            EQU     RamRS             ;registre temporaire
RsCount         EQU     RamRS+1
TIME            EQU     RamRS+2
TIME1           EQU     RamRS+3
TIME2           EQU     RamRS+4
TXREG           EQU     RamRS+5
Temp3           EQU     RamRS+6
Temp4           EQU     RamRS+7
RCREG           EQU     RamRS+8
RsBuffer        EQU     RamRS+9
; ..... 8 octets .......
OverCnt		EQU	RamRS+18
TX_INDEX		EQU 	RamRS+19
DELAY1		EQU	RamRS+20
DELAY2		EQU	RamRS+21

#define RamCN RamRS+22

bcent		EQU RamCN+0
bdix		EQU RamCN+1
bun		EQU RamCN+2
btmp		EQU RamCN+3
btmp1		EQU RamCN+4
dixmil	EQU RamCN+5
mille		EQU RamCN+6
cent		EQU RamCN+7
dix		EQU RamCN+8
un		EQU RamCN+9
Cpt1		EQU RamCN+10
Cpt2		EQU RamCN+11

#define Ram16 RamCN+12
valx		EQU Ram16	; reg de sauvegarde
val1		EQU Ram16+2	; reg de travail
val2		EQU Ram16+4	; nb car OK
val3		EQU Ram16+6	; nb de car BAD
Ram16End	EQU Ram16+8

Rs_Tx           EQU     0x02
Rs_Rx           EQU     0x01
Rs_Port         EQU     0x06

#define FERR	PORTB,7 ; frame error			
#define OERR	PORTB,6 ; Overfloaw erreur
#define TRMT	PORTB,5 ; registre transmission vide

CR 		EQU 0x0D
LF 		EQU 0x0A

#define SCL 	PORTB,3
#define SDA 	PORTB,0
#define TRIG 	PORTA,4

DS1307W 	EQU 0x68 <1 + 0 ; D0	;@68H sur MSB=7bits + LSB=bit=Write=0
DS1307R 	EQU 0xD1	;@68H sur MSB=7bits + LSB=bit=READ=1

#define RamDS Ram16End
FLAGS	EQU	RamDS
BITCOUNT EQU 	RamDS+1
BYTECOUNT EQU 	RamDS+2
BYTE 	EQU 	RamDS+3
ByteLu	EQU	RamDS+4
ClockRegs 	EQU 	RamDS+5
CloFin	EQU 	RamDS+13
	

#Define LASTREAD FLAGS,0
#define _12_24 	FLAGS,1
#define PM_AM 	FLAGS,2
#define	OSC 	FLAGS,3
#define	SQW 	FLAGS,4
#define ACK 	FLAGS,5
#define BUS_FAULT FLAGS,6
#define _2W_BUSY FLAGS,7




        ORG     0x0000             
	goto Init
;--------------------------------
	org 0x04
	BCF INTCON,GIE		; masque toutes interruptions
	Movwf W_TEMP
	Swapf STATUS,W
	Movwf STATUS_TEMP
	BCF STATUS,RP0
;  recherche origine de l'interruption 
;	BTFSC	INTCON,T0IF	; Timer0 oveflow ?
;	Call    SPint_Timer0
;	BTFSC 	INTCON,INTF	; Change on RB0 ?
;	Call 	SPint_RB0
;	BTFSC	PIR1,RCIF	; reception USART ?
;	Call	Read_Char
;	BTFSC	PIR1,TXIF	; emission USART ?
;	Call	Emet_Car
;	BTFSC	PIR1,TMR1IF	; Timer 1 overflow ?
;	Call 	SPint_Timer1
	BCF STATUS,RP0
	MOVF W_TEMP,W
	SWAPF	STATUS_TEMP,W
	MOVWF	STATUS
	RETFIE

;------------------------------------------

MSG:
DAY:
	DT CR,LF,"DAY OF MONTH : ",0
MONTH:
	DT CR,LF,"MONTH (1  12) : ",0
YEAR:
	DT CR,LF,"YEAR (0  99) : ",0
DAYW:
	DT CR,LF,"DAY OF WEEK : ",0
HOUR:
	DT CR,LF,"HOUR (0  23) : ",0
MINUTE:
	DT CR,LF,"MINUTE (0  59) : ",0
SECOND:
	DT CR,LF,"SECOND (0  59) : ",0
TRIER:
	DT CR,LF,"regler l'heure"
TEXT1:
	DT CR,"DATE: ",0
TEXT2:
	DT "TIME: ",0
TEXT3:
	DT CR,LF,0
TEXT4:
	DT CR,LF,"Appui touche",CR,LF,0
TEXT5:
	DT CR,LF,"filling RAM",CR,LF,0
TEXT6:
	DT CR,LF,"RAM RAM"
	DT CR,LF,"ADDR DATA",CR,LF,0

TEXT0:
	DT CR,LF,"DALLAS DS1307"
	DT CR,LF,"A=Reglage B=Ecr RAM "
	DT CR,LF,"C=Lecture D=Lec RAM "
	DT CR,LF,"E=OSC ON F=OSC OFF ",CR,LF
	DT CR,LF,"G=SQW|1HZ ", CR,LF
	DT CR,LF,"K=SQW/OUT OFF"
	DT CR,LF,"L=Ecr RAM"
	DT CR,LF,"ESC=Quit",0
;------------------------------
;Routine d'initialisation du PORTA et du PortB

Init   
		CLRF    STATUS          ; Do initialization, Select bank 0
		CLRF    PORTA           ;ALL PORT outputs should output Low.
		CLRF    PORTB
		bank1
		MOVLW   0x000          ; RA 0,1,2,3,4 =outputs
		MOVWF   TRISA
		MOVLW   0x07	       ; RB 0,1,2= input  RB 3,4,5,6,7=output  		
		MOVWF	TRISB
Init_RS
	;reception
	;emission
	
		BCF  	OPTION_REG,NOT_RBPU 	; rappel resist  

		bank0   ; Select bank 0

;		MOVLW RsBuffer		; RAZ buffer
;		MOVWF FSR
;Init1
;		clrf INDF
;		btfss FSR,3		; 8 octets
;		goto Init1

	CLRF	valx
	CLRF	valx+1
	CLRF	val1
	CLRF	val1+1





	
Start
	BTFSS	SDA		; ENSURE SDA HIGH
	CALL 	SCL_HIGH	; ENSURE SCL HIGH
	CLRF 	FLAGS

	clrf Cpt1		; message en EPROM
Menu1
	movf Cpt1,w
	CALL read_EE
	incf Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Suite1  	
	CALL Emet_Car
	goto Menu1
	call Wait1


;------ THIS IS THE MASTER CONTROLLER LOOP-------

MASTER_CONTROLLER:
Suite1
Spool_Key
	movlw 0xFF
	andwf RsBuffer,W
	btfsc	STATUS,Z
	goto Spool_Key
	bcf RsBuffer,5		; en majuscule a=97 - 32 = A=65 
	movlw 'A'
	xorwf RsBuffer,W
	btfss	STATUS ,Z
	goto NOTA
	CALL SET_CLOCKM
	goto MASTER_CONTROLLER ;
NOTA:
	movlw 'B'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTB ;
	CALL SET_RAM
	CALL READ_RAM
	goto MASTER_CONTROLLER 
NOTB:
	movlw 'C'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTC ;
	CALL READ_CLOCK
	goto MASTER_CONTROLLER 
NOTC:
	movlw 'D'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTD ;
	CALL READ_RAM
	goto MASTER_CONTROLLER 
NOTD: 
	movlw 'E'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTE ;
	BCF OSC
	CALL OSC_CONTROL
	GOTO MASTER_CONTROLLER
NOTE: 
	movlw 'F'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTF ;
	BSF OSC
	CALL OSC_CONTROL
	GOTO MASTER_CONTROLLER
NOTF:
	movlw 'G'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTG ;
	BCF SQW
	CALL SQW_1HZ
	GOTO MASTER_CONTROLLER
NOTG: 
	movlw 'H'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTH ;
; empty cde
	GOTO MASTER_CONTROLLER

NOTH: 
	movlw 'K'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTK ;
	BCF SQW
	CALL SQW_4KHZ
	GOTO MASTER_CONTROLLER
NOTK: 
	movlw 'L'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTL ;
	BSF SQW
	CALL SQW_1HZ
	GOTO MASTER_CONTROLLER
NOTL: 
	movlw 'M'
	xorwf RsBuffer,W
	btfss STATUS,Z
	goto NOTM ;
	CALL SET_RAM_UNQ
	CALL READ_RAM
NOTM: 
	GOTO MASTER_CONTROLLER 



;--------------------------
SEND_START: ;
	BSF _2W_BUSY ; INDICATE THAT 2WIRE OPERATION IN PROGRESS
	BCF ACK ; CLEAR STATUS FLAGS
	BCF BUS_FAULT
	BTFSC SCL
	goto FAULT 	; CHECK FOR BUS CLEAR
	BTFSC SDA
	goto FAULT 	; BEGIN START CONDITION
	BSF  SDA ;
	CALL SCL_HIGH ; SDA
	BCF SDA	      ;
	CALL DELAY 	; SCL START CONDITION
	BCF SCL 	;
	return
FAULT:
	BSF BUS_FAULT ; SET FAULT STATUS
	return ; AND RETURN
;----------------------
; THIS SUB SENDS THE STOP CONDITION

SEND_STOP: ;
	BCF SDA ; SDA
	CALL SCL_HIGH ;
	BSF SDA ; SCL ^STOP CONDITION
	BCF _2W_BUSY
	return ;
;----------------------------------------------
; THIS SUB SENDS ONE BYTE OF DATA TO THE DS1307
SEND_BYTE:
	MOVWF Temp3
	CLRF BITCOUNT
	BSF BITCOUNT,3 ; SET COUNTER FOR 8 BITS
SB_LOOP:
	BTFSS Temp3,7
	goto NOTONE 	; CHECK TO SEE IF BIT 7 OF ACC IS A 1
	BSF SDA 	; SET SDA HIGH (1)
	goto ONE
NOTONE:
	BCF SDA 	; CLR SDA LOW (0)
ONE:
	CALL SCL_HIGH	 ; TRANSITION SCL LOWTOHIGH
	RLF Temp3,f	 ; ROTATE ACC LEFT ONE BIT
	BCF SCL 	; TRANSITION SCL HIGHTOLOW
	DECFSZ BITCOUNT,F
	goto SB_LOOP 	; LOOP FOR 8 BITS
	BSF SDA 	; SET SDA HIGH TO LOOK FOR ACKNOWLEDGE PULSE
	CALL SCL_HIGH ; TRASITION SCL LOWTOHIGH
	BCF ACK 	; CLEAR ACKNOWLEDGE FLAG
	BTFSS	SDA
	goto SB_EX 	; CHECK FOR ACK OR NOT ACK
	BSF ACK 	; SET ACKNOWLEDGE FLAG FOR NOT ACK
SB_EX:
	CALL DELAY ; DELAY FOR AN OPERATION
	BCF SCL ; TRANSITION SCL HIGHTOLOW
	CALL DELAY ; DELAY FOR AN OPERATION
	RETurn
;-------------------------------------------------
; THIS SUB READS ONE BYTE OF DATA FROM THE DS1307
READ_BYTE:
	CLRF ByteLu
	CLRF BITCOUNT
	BSF BITCOUNT,3 ; SET COUNTER FOR 8 BITS OF DATA
	BSF SDA 	; SET SDA HIGH TO ENSURE LINE FREE
READ_BITS:
	CALL SCL_HIGH ; TRANSITION SCL LOWTOHIGH
	BCF STATUS,C	; Carry=0;
	BTFSC SDA
	BSF STATUS,C	; MOVE DATA BIT INTO CARRY BIT \
	RLF ByteLu,f	; ROTATE CARRY BIT INTO ACC.0
	BCF SCL 	; TRANSITION SCL HIGHTOLOW
	DECF ByteLu,f
	goto READ_BITS
	BTFSC LASTREAD 	; CHECK TO SEE IF THIS IS THE LAST READ
	goto ACKN
	BCF SDA 	; IF NOT LAST READ SEND ACKNOWLEDGE BIT
ACKN:
	CALL SCL_HIGH 	; PULSE SCL TO TRANSIMIT ACKNOWLEDGE
	BCF SCL 	; OR NOT ACKNOWLEDGE BIT
	return
;---------------------------------------
; THIS SUB SETS THE CLOCK LINE HIGH
SCL_HIGH:
	BSF SCL ; SET SCL HIGH
SCLH1	BTFSS SCL
	GOTO SCLH1 ; LOOP UNTIL STRONG 1 ON SCL
	return
;------------------------
; THIS SUB DELAY THE BUS
DELAY:
	NOP ; DELAY FOR BUS TIMING
	Return
;---------------------------
; THIS SUB DELAYS 4 CYCLES
DELAY_4:
	NOP ; DELAY FOR BUS TIMING
	NOP
	NOP
	NOP
	RETurn
;--------------------------------
; THIS SUB SETS THE CLOCK (MANUAL)
SET_CLOCKM:

; =========  suivre
	return
;-----------------------
; THIS SUB SETS THE DS1307 USER RAM TO THE VALUE IN BYTE
SET_RAM:

	return
;-----------------------
; THIS SUB SETS THE DS1307 USER RAM TO THE UNIQUE PATTERN
SET_RAM_UNQ:

	return
;-------------------------
; THIS SUB READS THE DS1307 RAM AND WRITES IT TO THE SCRATCH PAD MEMORY
READ_RAM:

	return
;-----------------------------
; THIS SUB DISPLAYS THE RAM DATA SAVED IN SCRATCHPAD MEMORY
DISP_RAM:

	return
;-------------------------------
; THIS SUB READS THE CLOCK AND WRITES IT TO THE SCRATCH PAD MEMORY ;
READ_CLOCK:
	MOVLW TEXT0 ; KEY PRESS MSG
	call ENVOI_TXT
READ_AGAIN:
;MOV R1,#28H ; START OF CLOCK REG IN SCRATCHPAD
	CLRF BYTECOUNT ; COUNTER UP TO 8 BYTES FOR CLOCK
	BCF LASTREAD ; FLAG TO CHECK FOR LAST READ
	CALL SEND_START ; SEND START CONDITION
	MOVLW DS1307W ; SET POINTER TO REG 00H ON DS1307
	CALL SEND_BYTE
	MOVLW 0
	CALL SEND_BYTE
	CALL SEND_STOP ; SEND STOP CONDITION
	CALL SEND_START ; SEND START CONDITION
	MOVLW DS1307R ; SEND READ COMMAND TO DS1307
	CALL SEND_BYTE
READ_LOOP:
	MOVf BYTECOUNT,W 	; CHECK TO SEE OF DOING LAST READ
	ANDLW 0x07
	BTFSC STATUS,Z
	goto NOT_LAST
	BSF LASTREAD 		; SET LASTREAD FLAG
NOT_LAST:
	CALL READ_BYTE 		;  sauvegard dans ByteLu
	call Store_it
	movf BYTECOUNT,W	;CHECK TO SEE IF READING SECONDS REG
	ANDLW 0xFF
	BTFSC STATUS,Z		;saut si ce n'est pas le 1er
	goto NOT_FIRST
				; Test bit 7 du registre sSECONDS
	BCF OSC 		; CLR OSC FLAG
	BTFSC ByteLu,7
	goto NO_OSC
	BSF OSC 		; SET OSC FLAG, BIT 7 IS A 1
	BCF ByteLu,7		; FOR DISPLAY PURPOSES
NO_OSC:
NOT_FIRST:
	INCF BYTECOUNT,F
	BTFSS BYTECOUNT,3	; 8 registres lu ?
	goto READ_LOOP
	CALL SEND_STOP 		; SEND 2WIRE STOP CONDITION
	CALL DISP_CLOCK 	; DISPLAY DATE/TIME FROM SCRATCHPAD
	btfsc RsCount,1
	goto READ_AGAIN
	BCF RsCount,1
	return
;------------------
Store_it:
	movf ClockRegs,W
	addlw BYTECOUNT
	movf FSR,W	;MOV @R1,A ; MOVE DATA IN SCRATCHPAD MEMORY
	movf ByteLu,W
	movf INDF,W
	return
;-------------------------------
Locate_To:
	addwf ClockRegs,W
	movf FSR,W	;MOV @R1,A ; MOVE DATA IN SCRATCHPAD MEMORY
	movf INDF,W
	return

;------------------------------

; DISPLAYS THE DATE AND TIME SAVED IN SCRATCHPAD MEMORY
DISP_CLOCK:
	MOVLW TEXT1-MSG 	; DATE:
	call ENVOI_TXT
	movlw 0x2C 		; Date
	call Locate_To
	call WRITE_BCD
	movlw '/'
	CALL Emet_Car

	movlw 0x2D 		; MOIS
	call Locate_To
	call WRITE_BCD
	movlw '/'
	CALL Emet_Car

	movlw 0x2E 		; ANNEE
	call Locate_To
	call WRITE_BCD
	movlw 0x09		;TAB
	CALL Emet_Car

	MOVLW TEXT2-MSG 	; TIME:
	call ENVOI_TXT
	movlw 0x2A 		; HEURES
	call Locate_To
	call WRITE_BCD
	movlw ':'		;0x31 COLON
	CALL Emet_Car

	movlw 0x29 		; MINUTES
	call Locate_To
	call WRITE_BCD
	movlw 0x3A		;COLON
	CALL Emet_Car

	movlw 0x28 		;SECONDES
	call Locate_To
	call WRITE_BCD
	return


; THIS SUB SETS THE OSCILLATOR ACCORDING TO THE OSC BIT
OSC_CONTROL:
	CALL SEND_START ; SEND START CONDITION
	MOVLW DS1307W 	; SET POINTER TO REG 00H ON; DS1307
	CALL SEND_BYTE
	MOVLW 0x00
	CALL SEND_BYTE
	BSF LASTREAD 	; SET LAST READ FOR SINGLE READ
	CALL SEND_STOP 	; SEND STOP CONDITION
	CALL SEND_START ; SEND START CONDITION
	MOVLW DS1307R 	; SEND READ COMMAND TO DS1307
	CALL SEND_BYTE
	CALL READ_BYTE 	; READ SECONDS REGISTER
	BCF W,7 	; TURN OSC ON
	BTFSS OSC
	goto OSC_SET
	BSF W,7		; TURN OSC OFF IF OSC BIT IS SET IN
OSC_SET: 		; SECONDS REGISTER
	MOVWF Temp3	; SAVE SECONDS DATA ON STACK
	CALL SEND_STOP ; SEND STOP CONDITION
	CALL SEND_START ; SEND START CONDITION
	MOVLW	DS1307W ; SET POINTER TO REG 00H ON DS1307
	CALL SEND_BYTE
	MOVLW 0
	CALL SEND_BYTE
	MOVF Temp3,W	; POP ACC
	CALL SEND_BYTE ; OSCILLATOR ON DS1307
	CALL SEND_STOP
	return

; -- THIS SUB CONTROLS THE SQW OUTPUT 1HZ -------
SQW_1HZ:
	CALL SEND_START 
	MOVLW DS1307W ; SET POINTER TO REG 07H ON DS1307
	CALL SEND_BYTE
	MOVLW 0x07
	CALL SEND_BYTE
	MOVLW 0x90	 ; SQW/OUT ON AT 1HZ
	BTFSS SQW
	goto SQW_SET   ; JUMP IF SQW BIT IS ACTIVE
	MOVLW 0x80     ; TURN SQW/OUT OFF  OFF HIGH
SQW_SET:
	CALL SEND_BYTE
	CALL SEND_STOP
	return

;----------------
SQW_4KHZ:

	return
;-----------------
SQW_8KHZ:

	return
;--------------
SQW_32KHZ:
	return

;------------ 
TRIGGER:
	BCF TRIG
	nop
	BSF TRIG
	CALL Wait1
	BCF TRIG
	return
;---------------
; THIS SUB READS DATA FROM THE SCREEN AND CONVERTS IT TO BCD FORM
; DATA SHOULD BE HEX DIGITS: 1,2,3...9,A,B,C,D,E,F
READ_BCD:

	return

;-------------------------------------------
WRITE_BCD:
	movwf Temp4
	swapf Temp4,W
	ANDLW 0x0F ; CLEAR BITS 4 a 7 OF ACC
	ADDLW 0x07 ; ADD 7 TO ACC TO CONVERT TO
	BTFSS W,4
	goto LESS9
	MOVWF Temp3
	ANDWF 0x10,F
	btfss STATUS,Z
	goto NOT9
LESS9:
	ADDLW -0x07 ; 
NOT9:
	ADDLW 0x30 
	call Emet_Car
	movf Temp4,w
	ANDLW 0x0F
	ADDLW 0x07
	BTFSS W,4
	goto LESS92
	MOVWF Temp3
	ANDWF 0x10,F
	btfss STATUS,Z
	goto NOT92
LESS92:
	ADDLW -0x07 ; 
NOT92:
	ADDLW 0x30 
	call Emet_Car
	return

;-----------------------------
Read_Char
	clrf RsBuffer		; Raz buffer
	incf	val2+1,F	; incremente MSB
	BTFSC	STATUS,Z	; si debordement LSB=0=256
	incf	val2,F	
	BTFSC FERR	; frame error			
	Goto Read_Err
	BTFSC	OERR	;Overfloaw erreur
	Goto Read_Err
Read_Ok
	MOVF RCREG,W
	MOVWF RsBuffer
	BSF RsCount,1
	Call Emet_Car
       Return                    

Read_Err
	bank0
 	MOVF  RCREG,W
 	MOVF  RCREG,W
	MOVLW 0
 	MOVWF  RCREG
; incremente compteur erreur
	incf	val3+1,F	; incremente LSB
	BTFSC	STATUS,Z	; si debordement LSB=0=256
	incf	val3,F		; => Incr MSB
	call Send_CRLF
	bank0
	return
            
;-----------------------------------------

TX_MSG
	nop			; W contient le deplacement dans la table message
TX_1
	MOVWF	TX_INDEX	; sauve index message 
	CALL	MSG
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	TX_END  
	call Emet_Car
	MOVF	TX_INDEX, W	; Pointe sur car suivant
	ADDLW	1
	GOTO	TX_1
TX_END
	RETURN

;-----------------------------
ENVOI_TXT
	BCF STATUS,IRP
	MOVWF	TX_INDEX	; sauve index message 
	movwf FSR	
	movf INDF,W
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	ENVOI_FIN  
	call Emet_Car
	MOVF	TX_INDEX, W	; Pointe sur car suivant
	ADDLW	1
	GOTO	ENVOI_TXT
ENVOI_FIN
	RETURN

;-------------------------------

Emet_Car
       movwf TXREG         ; on envoi l'octet sur le port serie
      BTFSS TRMT    ; 1=buffer d'emission vide ?
	goto Emet_1
	bank0
        RETURN

Emet_1
	bank0 
 	incf OverCnt,F		; incremente compteur error transmission 
	BCF	PORTA,0
	MOVLW 10
	Call X_DELAY5
	BSF	PORTA,0
	MOVLW 10
	Call X_DELAY5
  	return
;----------------------------
SPint_RB0:
	
	return
;-----------------------------
		
;boucle d'attente (Wait1) de 1Hz

Wait1   MOVLW   0x03                   ; Loop 3
         MOVWF   TIME2
LOOP2   MOVLW   0xD8                   ; 1 bit= 0,0046Hz
         MOVWF   TIME1
LOOP1   CLRWDT
         MOVLW   0xFF                   ; Loop 0
         MOVWF   TIME
LOOP0   DECFSZ  TIME,1
         GOTO    LOOP0
         NOP                             ;to adjust the loop to 1.000 sec.
         DECFSZ  TIME1,1
         GOTO    LOOP1
         DECFSZ  TIME2,1
         GOTO    LOOP2
         RETURN                        ; Back
;---------------------------
DELAY500	MOVLW	D'165'	; +1		1 cycle
		MOVWF	DELAY1		; +2		1 cycle
DELAY500_L
		DECFSZ	DELAY1, F	; step 1	1 cycle
		GOTO	DELAY500_L	; step 2	2 cycles
		RETURN			; +3		2 cycles

X_DELAY5	
		MOVWF	DELAY2		; +1		1 cycle
X_DL5
		CALL	DELAY500	; step1		wait 500uSec
		DECFSZ	DELAY2, F	; step2		1 cycle
		GOTO	X_DL5		; step3		2 cycles
		RETURN			; +2		2 cycles
;---------------------------
; affichage octet --> decimal 5 digits ( de 0 a 65535 )
bcd5
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1

	swapf  val1,w	
	iorlw  0xf0
	movwf  mille 
	addwf  mille,f 
	addlw  0xE2 
	movwf  cent 
	addlw  0x32 
	movwf  un 
	movf   val1,w 
	andlw  0x0F 
	addwf  cent,f 
	addwf  cent,f 
	addwf  un,f 
	addlw  0xE9 
	movwf  dix 
	addwf  dix,f 
	addwf  dix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  dix,f 
	addwf  un,f 
	rlf    dix,f 
	rlf    un,f 
	comf   un,f 
	rlf    un,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  un,f 
	rlf    mille,f 
	movlw  0x07 
	movwf  dixmil 
        movlw  0x0A
Lb1: 	addwf  un,f 
	decf   dix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  dix,f 
	decf   cent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  cent,f 
	decf   mille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  mille,f 
        decf   dixmil,f 
	btfss  STATUS,C
        goto   Lb4 
	movf   dixmil,w
	addlw  '0'
	call   Emet_Car
	movf   mille,w
	addlw  '0'
	call   Emet_Car
	movf   cent,w
	addlw  '0'
	call   Emet_Car
	movf   dix,w
	addlw  '0'
	call   Emet_Car
	movf   un,w
	addlw  '0'
	call   Emet_Car
	movlw	' '
	call Emet_Car

	return

; ******************** EE write routine ************************
; see data sheet for full explanation on EEPROM programming operation

write_EE
	bsf     STATUS,RP0     	;page 1
	movlw   0x55            ;do write seq.
	movwf   EECON2          ;       /
	movlw   0xaa            ;      / 
	movwf   EECON2          ;     /  
	bsf     EECON1,WR       ;initiate write
wo1     
	btfsc   EECON1,WR       ;write complete?
	goto    wo1             ;no then keep checking
	bcf     STATUS,RP0     	;pg 0
	return

read_EE	
	bsf     STATUS,RP0     	; bank 1
	movwf   EEADR           ; defini offset addresse
	bsf     EECON1,RD       ; mode lecture
	movf    EEDATA,W       	; recupere lecture
	bcf     STATUS,RP0     	; bank 0
	return
; ---------------

Send_CRLF
     	Movlw   13
     	Call    Emet_Car
	Movlw   10
     	Call    Emet_Car
	return

;-----------------
	ORG EEPROM

EE0 DT CR,LF,"Pic16F628 Rouge",CR,LF
EE1 DT "DS1307_2.asm",CR,LF
EE2 DT "version 2.11.02",CR,LF,0
ZEEfin	EQU $


	END

