;	routines en mode 4 Bits avec afficheur 2*16  base de HD77480
;
;	LCDinit : initialisation de l'afficheur
;	LCDchar : envoi un caractere ( contenu dans w ) sur l'afficheur
;	LCDins  : envoi une commande ( contenue dans w)  l'afficheur
;	LCDcls  : efface l'afficheur
;	LCDcls2 : efface la deuxieme ligne de l'afficheur
;	LCDhome : renvoi le curseur en haut a gauche
;	LCDlin1 : renvoi le curseur au debut de la ligne 1
;	LCDlin2 : renvoi le curseur au debut de la ligne 2
;	pour positionner le curseur sur la ligne 1 :	movlw 0x80+offset
;							call LCDins
;	pour positionner le curseur sur la ligne 2 : 	movlw 0xC0+offset
;							call LCDins
;
;	variables a definir dans le programme principal:
;
;	LCDtmp,LCDtmp2		; LCD
;	LCDt0,LCDt1,LCDt2,LCDt3,LCDt4	; LCD

;
;	constantes a definir dans le programme principal:
;
;	LCD_DATA	EQU PORTB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_DATA_TRIS	EQU TRISB	; LCD: Port ou est branche le bus de donnee ( bits 4  7 )
;	LCD_CNTL	EQU PORTA	; LCD: Port ou est branche le bus de commande
;	LCD_CNTL_TRIS	EQU TRISA	; LCD: Port ou est branche le bus de commande
;	LCD_E		EQU 2		; LCD: Ligne de commande de controle de l'afficheur
;	LCD_RW		EQU 1		; LCD: Ligne de Lecture/Ecriture de l'afficheur
;	LCD_RS		EQU 0		; LCD: Ligne de selection de l'afficheur
;	offset		EQU 0	
;
;	IMPORTANT : ce programme est optimis --> ne pas changer l'ordre des commandes

LCDcls  movlw	D'01'			; effacage de l'ecran
	call	LCDins
	goto	LCDlo5			; temporisation 1,5ms
LCDcls2 movlw	D'16'			; effacage de la deuxieme ligne
	movwf	LCDtmp2
	movlw	0xC0
	call	LCDins
	call	LCDlo5			; temporisation 1,5ms
LCDcl21	movlw	' '
	call	LCDchar
	decfsz	LCDtmp2,f
	goto	LCDcl21
LCDlin2	movlw	0xC0
	call	LCDins
	goto	LCDlo5			; temporisation 1,5ms
LCDhome movlw	D'02'
	call	LCDins
	goto	LCDlo5			; temporisation 1,5ms
LCDlin1	movlw	0x80
	call	LCDins
	goto	LCDlo5			; temporisation 1,5ms
LCDchar	movwf	LCDtmp
	call	LCDlo2			; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w
	andlw   0xF0
	iorwf   LCD_DATA,F
	bcf     LCD_CNTL, LCD_RW
	bsf     LCD_CNTL, LCD_RS
	bsf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_E
	return

LCDinit	bcf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_RS
	bcf     LCD_CNTL, LCD_RW
	call	LCDlo2			; temporisation 1,5ms
	movlw	0x0f
	andwf	LCD_DATA,F
	movlw	0x030			; Commande pour interface 4 bits
	iorwf	LCD_DATA,F
	bsf     STATUS, RP0		; Bank 1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS		; Port en sortie
	BCF     STATUS, RP0		; Bank 0
	bsf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_E
	movlw   d'252'
	movwf   LCDt1
	movlw   D'05'
	call	LCDlo2			; temporisation 5ms
	bsf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_E
	call 	LCDlo4			; tempo 100ms
	bsf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_E
	call 	LCDlo4			; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movlw   0x020           	; Commande pour interface 4 bits
	iorwf   LCD_DATA,F
	bsf     LCD_CNTL, LCD_E
	bcf     LCD_CNTL, LCD_E
	movlw   0x028			; Envoi de la commande Fonction 4-bit , Font, Nombre de lignes
	call    LCDins
	movlw   0x008			; display off
	call    LCDins
	movlw   0x00F			; display on (0x00C sans, 0x00E pour cursor on , 0x00F pour curseur clign. )
	call    LCDins
	movlw   0x006
LCDins	movwf   LCDtmp
	call 	LCDlo4			; tempo 100ms , remplace l'attente Wait_Busy de l'afficheur
	movlw   0x0f
	andwf   LCD_DATA,F
	movf    LCDtmp,w          
	andlw   0xF0
	iorwf   LCD_DATA,F
	bcf     LCD_CNTL,LCD_RW
	bcf     LCD_CNTL,LCD_RS
	bsf     LCD_CNTL,LCD_E
	bcf     LCD_CNTL,LCD_E
	movlw   0x0f
	andwf   LCD_DATA,F
	swapf   LCDtmp,W
	andlw   0xF0
	iorwf   LCD_DATA,F
	bsf     LCD_CNTL,LCD_E
	bcf     LCD_CNTL,LCD_E
	return

LCDlo2	movwf   LCDt2		; temporisation 8ms
	movlw   D'04'
	movwf   LCDt3
	movwf   LCDt4
LCDlo3	nop             
	decfsz  LCDt1,f
	goto    LCDlo3
	decfsz  LCDt2,f
	goto    LCDlo3
	decfsz  LCDt3,f
	goto    LCDlo3
	decfsz  LCDt4,f
	goto    LCDlo3
	return

LCDlo4	movlw   d'50'		; temporisation 100ms
	movwf   LCDt1
	movlw   d'01'
	goto	LCDlo2

LCDlo5	movlw   d'160'		; temporisation 1,5ms
	movwf   LCDt1
	movlw   D'15'
	goto	LCDlo2

Tempo2s			; tempo 2sec =250*8mS
	movlw  d'250'
	movwf   LCDt0
tp2	call 	LCDlo2
	decfsz  LCDt0,f
	goto    tp2
	return
