; rev 24/10/08 pour test 2 compteurs
; rev 08/10/02 LCD_012Z.ASM issu de 
; version LCD_012.ASM  08 octobre 2002   fonctionne rel OK
; voir version PICEmulateur: LCD_010z.asm 
; port B -> 8 lignes =DATA  ; port A0,A1,A2 = CRTL
; Fosc		= 4MHz
; Cycle_time	= 1uSec
;******************
;  BUG
; si ralentissement affichage:
; au bout d'un moment seul les 8 car de ligne 1 et de ligne 2 restent affiches
; la 2em partie 9em car au 16em disparait sur les 2 lignes ??
; PB idem en mode 8 bits ou 4 bits !!
;*****************

	include <p16f84_.inc>

#define miniSimDE

	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor       16F84
	endif
	Radix           DEC
	EXPAND

	__CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;***********************
; Equates, I/O, vars
;***********************
RESET_V		EQU	0x0000		; Address of RESET Vector
ISR_V		EQU	0x0004		; Address of Interrupt Vector
OSC_FREQ	EQU	D'4000000'	; Oscillator Frequency is 4 MHz

LCD_DATA	EQU	PORTB		; LCD data lines interface
LCD_DATA_TRIS	EQU	TRISB
LCD_CTRL	EQU	PORTA		; LCD control lines interface

LCD_LINE0	EQU	0x000
LCD_LINE1	EQU	0x040

; PORTA bits
LCD_E		EQU	2	; LCD Enable control line
LCD_RW	EQU	1		; LCD Read/Write control line
LCD_RS	EQU	0		; LCD Register-Select control line

; PORTB bits
DB7		EQU	7		; LCD dataline 7 (MSB)
DB6		EQU	6		; LCD dataline 6
DB5		EQU	5		; LCD dataline 5
DB4		EQU	4		; LCD dataline 4
DB3		EQU	3		; LCD dataline 3
DB2		EQU	2		; LCD dataline 2
DB1		EQU	1		; LCD dataline 1
DB0		EQU	0		; LCD dataline 0 (LSB)

FirstCar	EQU	' '		; espace
NbCar		EQU	95		; was 95

	ORG 0x020
LCD_TEMP	EQU	$		; LCD subroutines internal use
T1_INDEX	EQU	$+1		; Index to table1 strings
T2_INDEX	EQU	$+2		; Index to table2 strings
T3_INDEX	EQU	$+3		; Index to table3 strings
COUNT		EQU	$+4		; A counter
DELAY		equ	$+5		; Used in DELAYxxx routines
DELAY1		equ	$+6
DELAY2		equ	$+7
X_DELAY		equ	$+8		; Used in X_DELAYxxx routines
Cpt1		equ	$+9
Cpt2		equ	$+10
Cpt3		equ	$+11
Cpt4		EQU	$+12
;---------------------
	ORG 0x20+13
Dummy		EQU $
bcent		EQU $+1
bdix		EQU $+2
bun		EQU $+3
btmp		EQU $+4
btmp1		EQU $+5
valx		EQU $+6	;2
val1		EQU $+8	;2
val2		EQU $+10	;2
val3		EQU $+12	;2
dixmil	EQU $+14
mille		EQU $+15
cent		EQU $+16
dix		EQU $+17
un		EQU $+18



;***********************
; Program start
;***********************
	ORG	RESET_V			; RESET vector location
RESET		GOTO	START


;***********************
; This is the Periperal Interrupt routine. Should NOT get here
;***********************
	ORG	ISR_V			; Interrupt vector location
INTERRUPT	NOp
                NOP
		GOTO    ICI

;***********************
; Initialize processor registers
;***********************
START					; POWER_ON Reset (Beginning of program)
		CLRF	STATUS		; Do initialization, Select bank 0
		CLRF	INTCON		; Clear int-flags, Disable interrupts
		CLRF	PCLATH		; Keep in lower 2KByte
		CLRF	PORTA		; ALL PORT output should output Low.
		CLRF	PORTB
		BSF	STATUS, RP0	; Select bank 1
		MOVLW	0xF8		; RA2-0 = outputs, RA3-4= inputs
		MOVWF	TRISA
		MOVLW	0x00		; RB7-0 outputs
		MOVWF	TRISB
		BCF	OPTION_REG,7	; enable PORTB pull-ups (was disable BSF..)
mainloop:
		CLRF	val1	;registres 16 bits
		CLRF	val1+1
		CLRF	val2
		CLRF 	val2+1
		CLRF	val3
		CLRF 	val3+1
		CLRF	valx
		CLRF 	valx+1

	

		BCF	STATUS, RP0	; Select bank 0
		CLRF 	PORTB
		BSF	PORTA,3		; RAS 8 latches circuit 74HCT574 sur PortB
		BCF	PORTA,3
		CLRF 	Cpt4
	
Boucle:
		MOVLW	FirstCar
		MOVWF	Cpt1
		MOVLW	NbCar
		MOVWF	Cpt2
		CALL	LCDINIT		; Initialize LCDisplay
		NOP
Loop:
		MOVLW	0x030		; ASCII '0'
		MOVWF	COUNT
		MOVLW	LCD_LINE0
		CALL	LCDSDDA		; Position cursor leftmost on first line
		CALL	T1_MSG		; Display message
		MOVLW	LCD_LINE0 + 7
		CALL	LCDSDDA		; Position cursor
		MOVF	COUNT, W
		CALL	LCDPUTCHAR	; Display line number

		MOVLW	LCD_LINE0 + 10
		CALL	LCDSDDA
		incf 	Cpt1,F
		movf	Cpt1,w	
		CALL	LCDPUTCHAR

		MOVLW	LCD_LINE0 + 13
		CALL	LCDSDDA
		movf 	Cpt1,w	
		call 	bcd3
	
		ifndef miniSimDE
		movlw 5
		call 	X_DL100ms
		endif

		INCF	COUNT, F

		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		CALL	T3_MSG		; COMPT 16B=
		MOVLW	LCD_LINE1 + 11	; position curseur 2em ligne 10em car
		CALL	LCDSDDA

		INCF	Cpt4,F		; incremente LSB
		BTFSC	STATUS,Z		; si debordement LSB=0=256
		incf	val1,F		; incremente MSB 
		movf 	Cpt4,w	
		movwf val1+1		; maj LSB 
		call 	bcd5			; affichage 5 digits

		decfsz	Cpt2,f
		goto 	Loop

	ifndef miniSimDE
		movlw 10
		call 	X_DL100ms
	endif
		MOVLW	LCD_LINE1
		CALL	LCDSDDA
		CALL	T2_MSG			; FERTIG...
	ifndef miniSimDE
		movlw 10
		call 	X_DL100ms
	endif
		MOVF	val1, W
		andlw 0x03
		BTFSC STATUS,Z	
		goto	Boucle
;-------------------		
		movlw 10
		call 	X_DL100ms
		call LCDCLEAR

		Movlw 0		
		movwf	Cpt1
		MOVLW	LCD_LINE0
		CALL	LCDSDDA
encor1
		movf	Cpt1,w
		MOVWF EEADR		;adresse EEPROM+0 => PIC16F84-04P
		BSF 	STATUS,RP0
		BSF 	EECON1,RD
		BCF 	STATUS,RP0
		MOVF 	EEDATA,W
		CALL	LCDPUTCHAR
		incf	Cpt1,f
		btfss	Cpt1,4		; bit 4=1  16em car ?
		goto 	encor1
		movlw 10
		call 	X_DL100ms
		
		Movlw 0		
		movwf	Cpt1
		MOVLW	LCD_LINE1
		CALL	LCDSDDA
encor2
		movf	Cpt1,w
		addlw	16
		MOVWF EEADR		; adresse EEPROM +16 => lcd_012.asm
		BSF 	STATUS,RP0
		BSF 	EECON1,RD
		BCF 	STATUS,RP0
		MOVF 	EEDATA,W
		CALL	LCDPUTCHAR
		incf	Cpt1,f
		btfss	Cpt1,4	
		goto 	encor2
		movlw   10
		call 	X_DL100ms
		
		call LCDCLEAR
		MOVLW	LCD_LINE0
		CALL	LCDSDDA


	movf val2,W	;	val1 en entree
	movwf	val1
	movf val2+1,W
	movwf	val1+1
	call 	bcd5	; affiche nb de car recus OK
	movf valx,W		; valx en sortie
	movwf	val2
	movf valx+1,W
	movwf	val2+1
	movlw '/'
	call   LCDPUTCHAR

	movf val3,W
	movwf	val1
	movf val3+1,W
	movwf	val1+1
	call 	bcd5	; Affiche Nb de car BAD !!
	movf valx,W
	movwf	val3
	movf valx+1,W
	movwf	val3+1

	movlw 'b'
	call   LCDPUTCHAR
	movlw 'a'
	call   LCDPUTCHAR
	movlw 'd'
	call   LCDPUTCHAR


		Movlw 0
		movwf	Cpt1
encor3
		movf	Cpt1,w
		addlw	32
		MOVWF EEADR		;adresse EEPROM +32 => 08/10/02    
		BSF 	STATUS,RP0
		BSF 	EECON1,RD
		BCF 	STATUS,RP0
		MOVF 	EEDATA,W
		CALL	LCDPUTCHAR
		incf	Cpt1,f
		btfss	Cpt1,4	
		goto 	encor3
	ifndef miniSimDE
		movlw 10
		call 	X_DL100ms
	endif
	;decalage texte  gauche 16 fois

		Movlw 16	
		movwf	Cpt1
decalage
		movlw	0x18
		call	LCDPUTCMD
	ifndef miniSimDE
		movlw   2
		call 	X_DL100ms
	endif
		decf	Cpt1,f
		btfss	STATUS,Z
		goto 	decalage
	ifndef miniSimDE
		movlw   25
		call 	X_DL100ms
	endif
		goto 	mainloop

finprog	equ $	

;=====================================
; Table message to display
;=====================================
MSG1
	addwf	PCL ,F		;Jump to char pointed to in W reg
	retlw	'L'
	retlw	'I'
	retlw	'G'
	retlw	'N'
	retlw	'E'
	retlw	' '
	retlw	'#'
	retlw	' '
	retlw	':'
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
	retlw	' '
MSG1_END
	retlw	0
;
	IF ( (MSG1 & 0x0FF) >= (MSG1_END & 0x0FF) )
		MESSG   "Warning - User Definded: Table 'MSG1' crosses page boundry in computed jump"
	ENDIF

MSG2
		addwf	PCL ,F		;Jump to char pointed to in W reg
		retlw	' '
		retlw	'F'
		retlw	'I'
		retlw	'N'
		retlw	'.'
		retlw	'E'
		retlw	'N'
		retlw	'D'
		retlw	'.'
		retlw	'F'
		retlw	'E'
		retlw	'R'
		retlw	'T'
		retlw	'I'
		retlw	'G'
		retlw	'.'
MSG2_END
		retlw	0
;
	IF ( (MSG2 & 0x0FF) >= (MSG2_END & 0x0FF) )
		MESSG   "Warning - User Definded: Table 'MSG2' crosses page boundry in computed jump"
	ENDIF
MSG3
		addwf	PCL ,F		;Jump to char pointed to in W reg
		retlw	'C'
		retlw	'O'
		retlw	'M'
		retlw	'P'
		retlw	'T'
		retlw	' '
		retlw	'1'
		retlw	'6'
		retlw	'B'
		retlw	'='
		retlw	'>'
		retlw	' '
		retlw	'.'
		retlw	'.'
		retlw	'.'
		retlw	'.'
		retlw	' '
MSG3_END
		retlw	0
;
	IF ( (MSG3 & 0x0FF) >= (MSG3_END & 0x0FF) )
		MESSG   "Warning - User Definded: Table 'MSG3 crosses page boundry in computed jump"
	ENDIF
			
;***********************
; Send a message using a table to output a message
;***********************
T1_MSG
		MOVLW	0		; Startindex of table message
T1_1
		MOVWF	T1_INDEX	; Holds message address
		CALL	MSG1
		ANDLW	0x0FF		; Check if at end of message
		BTFSC	STATUS, Z	; (zero returned at end)
		GOTO	T1_END             
		CALL	LCDPUTCHAR	; Display character
		MOVF	T1_INDEX, W	; Point to next character
		ADDLW	1
		GOTO	T1_1
T1_END
		RETURN
;*************************
T2_MSG
		MOVLW	0		; Startindex of table message
T2_1
		MOVWF	T2_INDEX	; Holds message address
		CALL	MSG2
		ANDLW	0x0FF		; Check if at end of message
		BTFSC	STATUS, Z	; (zero returned at end)
		GOTO	T2_END             
		CALL	LCDPUTCHAR	; Display character
		MOVF	T2_INDEX, W	; Point to next character
		ADDLW	1
		GOTO	T2_1
T2_END
		RETURN
;*************************
T3_MSG
		MOVLW	0		; Startindex of table message
T3_1
		MOVWF	T3_INDEX	; Holds message address
		CALL	MSG3
		ANDLW	0x0FF		; Check if at end of message
		BTFSC	STATUS, Z	; (zero returned at end)
		GOTO	T3_END             
		CALL	LCDPUTCHAR	; Display character
		MOVF	T3_INDEX, W	; Point to next character
		ADDLW	1
		GOTO	T3_1
T3_END
		RETURN
;*************************

BlankLine
		movlw 16
		movwf	Cpt3
Blk1:		movlw	' '
		CALL	LCDPUTCHAR		
		decfsz Cpt3,f
		goto Blk1
		return
;***********************
; LCD Module Subroutines
;***********************
;
;=========================
; LCDINIT
; Initilize LC-Display Module
; Should be modified to your needs (i.e. display type, cursor on/off, etc.)
;=========================
LCDINIT
					; Busy-flag is not yet valid
;		CLRF	LCD_CTRL	; ALL PORT output should output Low.
					; power-up delay

		BCF PORTA,2
		BCF PORTA,1
		BCF PORTA,0
		;movlw 	0xF8		;RAZ	RA0,RA1,RA2
		;MOVWF	LCD_CTRL
		MOVLW	0x030		; 
		CALL	LCDPUTCMD
		MOVLW	30
		CALL	X_DELAY5	; 30 * 0.5mS = 15mS
		MOVLW	0x030		; 
		CALL	LCDPUTCMD
		movlw   10
		CALL	X_DELAY5
		MOVLW	0x030		; 
		CALL	LCDPUTCMD
		MOVLW	0x038		; 8-bit-interface, 2-lines
		CALL	LCDPUTCMD
		MOVLW	0x000		; disp.off, curs.off, no-blink
		CALL	LCDDMODE
		CALL	LCDCLEAR
		MOVLW	0x005		; disp.on, curs.blink
		CALL	LCDDMODE
		MOVLW	0x002		; auto-inc (shift-cursor)
		CALL	LCDEMODE
		RETURN
;=========================
; LCD_ENABLE
; Pulses LCD enable pin
;=========================
LCD_ENABLE
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		NOP
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		RETURN
;=========================
; LCDBUSY
; Returns when LCD busy-flag is inactive
;=========================
LCDBUSY
		BSF	STATUS,RP0	; Select Register page 1
		MOVLW	0x0FF		; Set PORTB for input
		MOVWF	LCD_DATA_TRIS
		BCF	STATUS, RP0	; Select Register page 0
		BCF	LCD_CTRL, LCD_RS; Set LCD for command mode
		BSF	LCD_CTRL, LCD_RW; Setup to read busy flag
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		nop
		MOVF	LCD_DATA, W	; Read busy flag + DDram address
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		ANDLW	0x80		; Check Busy flag, High = Busy
		BTFSS	STATUS, Z
		GOTO	LCDBUSY
LCDNOTBUSY	BCF	LCD_CTRL, LCD_RW
		BSF	STATUS, RP0	; Select Register page 1
		MOVLW	0x000
		MOVWF	LCD_DATA_TRIS	; Set PORTB for output
		BCF	STATUS, RP0	; Select Register page 0
		RETURN
;=========================
; LCDCLEAR
; Clears display and returns cursor to home position (upper-left corner).
;=========================
LCDCLEAR
		MOVLW	0x001
		CALL	LCDPUTCMD
		RETURN
;=========================
; LCDHOME
; Returns cursor to home position.
; Returns display to original position (when shifted).
;=========================
LCDHOME
		MOVLW	0x002
		CALL	LCDPUTCMD
		RETURN
;=========================
; LCDEMODE
; Sets entry mode of display.
; Required entry mode must be set in W
;  b0	: 0 = no display shift	1 = display shift
;  b1	: 0 = auto-decrement	1 = auto-increment
;  b2-7	: don't care
;=========================
LCDEMODE
		ANDLW	0x003		; Strip upper bits
		IORLW	0x004		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
; LCDDMODE
; Sets display control.
; Required display mode must be set in W
;  b0	: 0 = cursor blink off	1 = cursor blink on
;  b1	: 0 = cursor off	1 = cursor on
;  b2	: 0 = display off	1 = display on (display data remains in DDRAM)
;  b3-7	: don't care
;=========================
LCDDMODE
		ANDLW	0x007		; Strip upper bits
		IORLW	0x008		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
; LCDSCGA
; Sets Character-Generator-RAM address. 
; CGRAM is read/written after  this setting.
; Required CGRAM address must be set in W
;  b0-5	: required CGRAM address
;  b6-7	: don't care
;=========================
LCDSCGA
		ANDLW	0x03F		; Strip upper bits
		IORLW	0x040		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
; LCDSDDA
; Sets the Display-Data-RAM address. DDRAM data is read/written after
;  this setting.
; Required DDRAM address must be set in W
;  b0-6	: required DDRAM address
;  b7	: don't care
;=========================
LCDSDDA
		IORLW	0x080		; Function set
		CALL	LCDPUTCMD
		RETURN
;=========================
; LCDGADDR
; Returns address counter contents, used for both DDRAM and CGRAM.
; RAM address is returned in W
;=========================
LCDGADDR
		BSF	STATUS,RP0	; Select Register page 1
		MOVLW	0x0FF		; Set PORTB for input
		MOVWF	LCD_DATA_TRIS
		BCF	STATUS, RP0	; Select Register page 0
		BCF	LCD_CTRL, LCD_RS; Set LCD for command mode
		nop
		BSF	LCD_CTRL, LCD_RW; Setup to read busy flag
		nop
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		MOVF	LCD_DATA, W	; Read busy flag + RAM address
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		ANDLW	0x07F		; Strip upper bit
		BCF	LCD_CTRL, LCD_RW
		BSF	STATUS, RP0	; Select Register page 1
		MOVLW	0x000
		MOVWF	LCD_DATA_TRIS	; Set PORTB for output
		BCF	STATUS, RP0	; Select Register page 0
		RETURN
;======================================
bcd3	movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )
	movlw  '0'
        movwf  bcent
	movwf  bdix
bcd31	movlw  100
        subwf  btmp,w
	bnc    bcd32
	movwf  btmp
	incf   bcent,f
	goto   bcd31
bcd32   movlw  10
	subwf  btmp,w
	bnc    bcd33
	movwf  btmp
	incf   bdix,f
	goto   bcd32
bcd33	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bcent,w
	call   LCDPUTCHAR
	movf   bdix,w
	call   LCDPUTCHAR
	movf   bun,w
	goto   LCDPUTCHAR
	
;***********************************
; affichage octet --> decimal 5 digits ( de 0 a 65535 )
bcd5
	movf	val1,w
	movwf	valx
	movf	val1+1,w
	movwf	valx+1

	swapf  val1,w	
	iorlw  0xf0
	movwf  mille 
	addwf  mille,f 
	addlw  0xE2 
	movwf  cent 
	addlw  0x32 
	movwf  un 
	movf   val1,w 
	andlw  0x0F 
	addwf  cent,f 
	addwf  cent,f 
	addwf  un,f 
	addlw  0xE9 
	movwf  dix 
	addwf  dix,f 
	addwf  dix,f 
	swapf  val1+1,w 
	andlw  0x0F 
	addwf  dix,f 
	addwf  un,f 
	rlf    dix,f 
	rlf    un,f 
	comf   un,f 
	rlf    un,f 
	movf   val1+1,w 
	andlw  0x0F 
	addwf  un,f 
	rlf    mille,f 
	movlw  0x07 
	movwf  dixmil 
        movlw  0x0A
Lb1: 	addwf  un,f 
	decf   dix,f 
	btfss  STATUS,C
	goto   Lb1 
Lb2:	addwf  dix,f 
	decf   cent,f 
	btfss  STATUS,C
	goto   Lb2 
Lb3:	addwf  cent,f 
	decf   mille,f 
	btfss  STATUS,C
	goto   Lb3 
Lb4:	addwf  mille,f 
        decf   dixmil,f 
	btfss  STATUS,C
        goto   Lb4 
	movf   dixmil,w
	addlw  '0'
	call   LCDPUTCHAR
	movf   mille,w
	addlw  '0'
	call   LCDPUTCHAR
	movf   cent,w
	addlw  '0'
	call   LCDPUTCHAR
	movf   dix,w
	addlw  '0'
	call   LCDPUTCHAR
	movf   un,w
	addlw  '0'
;	goto   LCDPUTCHAR
;=====================================
; LCDPUTCHAR
; Sends character to LCD, Required character must be in W
;=====================================
LCDPUTCHAR
		MOVWF	LCD_TEMP	; Character to be sent is in W
		CALL	LCDBUSY		; Wait for LCD to be ready
		BCF	LCD_CTRL, LCD_RW; Set LCD in read mode	
		BSF	LCD_CTRL, LCD_RS; Set LCD in data mode  ; inversion
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		nop
		MOVF	LCD_TEMP, W
		MOVWF	LCD_DATA	; Send data to LCD
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		incf	val3+1,F	; incremente MSB
		BTFSC	STATUS,Z	; si debordement LSB=0=256
		incf	val3,F	
		RETURN
;=====================================
; LCDPUTCMD
; Sends command to LCD
; Required command must be in W
; OK
;=====================================
LCDPUTCMD
		MOVWF	LCD_TEMP	; Command to be sent is in W
		CALL	LCDBUSY		; Wait for LCD to be ready
		BCF	LCD_CTRL, LCD_RW; Set LCD in read mode
		nop
		BCF	LCD_CTRL, LCD_RS; Set LCD in command mode
		nop
		BSF	LCD_CTRL, LCD_E	; LCD E-line High
		nop
		MOVF	LCD_TEMP, W
		MOVWF	LCD_DATA	; Send data to LCD
		BCF	LCD_CTRL, LCD_E	; LCD E-line Low
		incf	val2+1,F	; incremente MSB
		BTFSC	STATUS,Z	; si debordement LSB=0=256
		incf	val2,F	

		RETURN

;***********************
; Delay_time	= ((DELAY_value * 3) + 4) * Cycle_time
; DELAY_value	= (Delay_time - (4 * Cycle_time)) / (3 * Cycle_time)
; i.e. (@ 4MHz crystal)
; Delay_time	= ((32 * 3) + 4) * 1uSec = 100uSec
; DELAY_value	= (500uSec - 4) / 3 = 165.33	= 165
;***********************

DELAY500	MOVLW	D'165'	; +1		1 cycle
		MOVWF	DELAY		; +2		1 cycle
DELAY500_L
		DECFSZ	DELAY, F	; step 1	1 cycle
		GOTO	DELAY500_L	; step 2	2 cycles
		RETURN			; +3		2 cycles
;
DELAY100ms
		MOVLW	D'200'		; +1		1 cycle
		MOVWF	DELAY1		; +2		1 cycle
D100ms		CALL DELAY500
		DECFSZ DELAY1, F	; step 1	1 cycle
		GOTO	D100ms		; step 2	2 cycles
		RETURN			; +3		2 cycles
;

X_DELAY5	
		MOVWF	X_DELAY		; +1		1 cycle
X_DL5_L
		CALL	DELAY500	; step1		wait 500uSec
		DECFSZ	X_DELAY, F	; step2		1 cycle
		GOTO	X_DL5_L		; step3		2 cycles
		RETURN			; +2		2 cycles
;**************************

X_DL100ms	
		MOVWF	DELAY2		; +1		1 cycle
X_DL100L
		CALL DELAY100ms		; step1		wait 500uSec
		DECFSZ DELAY2, F	; step2		1 cycle
		GOTO	X_DL100L	; step3		2 cycles
		RETURN			; +2		2 cycles
;**************************

	org EEPROM
;           1234567890123456	
	DT " PIC16F84-04P   "
	DT " lcd_012Z.asm   "
	DT " 08/10/02 P.F.  "
	DT " XT 9941        "
		
	END				; End of program

