; 21 mars 2004
;Building SINEDDS2.HEX...
;Compiling SINEDDS2.ASM:
;Command line: "F:\MPLAB\MPASMWIN.EXE /aINHX8M /e+ /l+ /x+ /c+ /rdec /p16F84 /q F:\MPLAB\DDS\SINEDDS2.ASM"
;Build completed successfully.
; 13 mars 2004 rev PF
;Compiling SINEDDS1.ASM:
;-----------------------
;#define miniSimDE
	ifdef miniSimDE
	p=16F84
	else
	ERRORLEVEL      -302
	Processor	16F84
	endif
	include <p16f84.inc>
;	Radix           DEC
	EXPAND
         __CONFIG        _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC

;**************************************************
; (C) Copyright 2003 by Richard Prinz.OE1RIB Richard.Prinz@MIN.at
;       Schematic  /  Loop version
;                                                                          
;   16F84             AD558   +5V           + 9V          
;   4 MHz                     |             |  
;   +------+          +-------+-+           /                               
;   |      |----------|1 D0   11|         |/       
;   |      |  B0-B7   |       16|---------|  2N2222                       
;   |      |----------|8 D7     |out      |\ > 
;   |      |  gnd ----|9 CS     |           \ 
;   |      |  Gnd ----|10 CE  15|-----------+-- analog Fout ----->                     
;   |      |          +------+--+  sense    |                     
;   |      |  A2    Key      | 12           -                              
;   |      |---------/ -     | 13          | |                               
;   |      |  A3            -+-0V          | |                           
;   |      |-------->LED                    -                           
;   +------+                                |  
;                                           -                            
;**************************************************
;       Definitions
;**************************************************
#define PAGE0           BCF 3,5
#define PAGE1           BSF 3,5
;#define Debug          1
;**************************************************
;       Variables
;**************************************************
      	ifdef miniSimDE
                   org 0x0C  
FREQ_H	Equ $
FREQ_M	Equ $+1
FREQ_L	Equ $+2
ACC_H		Equ $+3
ACC_M		Equ $+4
ACC_L		Equ $+5
TEMP		Equ $+6
SER		Equ $+7
DELAY_W	Equ $+8
DELAY_T	Equ $+9
DELAY_H	Equ $+10
DELAY_L	Equ $+11

	else
             
             cblock     0x0C
FREQ_H
FREQ_M
FREQ_L
ACC_H
ACC_M
ACC_L
TEMP
SER
DELAY_W
DELAY_T
DELAY_H
DELAY_L
   		 endc
    	endif
;**************************************************

PCLBit macro label,bit,check
        local mask
mask set (1 << bit)
        if (check == 1)
            if (high($)) == (high(label))
                messg "Source and destination "label" on same Page!"
            endif
        endif
        if ((high($) & mask) == (high(label) & mask))
            bcf     PCLATH,bit
        else
            bsf     PCLATH,bit
        endif       
    endm
    
gotoEX macro label
        local gotoEXLabel
        PCLBit label,0,1
        PCLBit label,1,1
            goto        label
gotoEXLabel:            
        PCLBit gotoEXLabel,0,0
        PCLBit gotoEXLabel,1,0
    endm

callEX macro label
        local callEXLabel
        PCLBit label,0,1
        PCLBit label,1,1
            call        label
callEXLabel:            
        PCLBit callEXLabel,0,0
        PCLBit callEXLabel,1,0
    endm

DelaySet macro HighWait,LowWait
        movlw   HighWait
        movwf   DELAY_H
        movlw   LowWait
        movwf   DELAY_L
    endm

DelayCPU macro HighWait,LowWait
        DelaySet HighWait,LowWait
        callEX  Delay
    endm

;**************************************************
;       M A I N - E N T R Y
;**************************************************
                ORG             0x000
Start
                PAGE1
                ; set PORTA
                ; A0 - 
                ; A1 - 
                ; A2 - Key
                ; A3 - Led
                ; A4 - 
                movlw           B'00000100'
                movwf           TRISA

                ; set PORTB
                ; B0 - Data 0 out
                ; B1 - Data 1 out
                ; B2 - Data 2 out
                ; B3 - Data 3 out
                ; B4 - Data 4 out
                ; B5 - Data 5 out
                ; B6 - Data 6 out
                ; B7 - Data 7 out
                movlw           B'00000000'
                movwf           TRISB

                PAGE0
                  
;**************************************************
;       Output frequency (using 24 bit accumulator)
;   f = deltaPhase * fClock/2^24
;   fClock is in this case the CPU clock divided by the
;   number of cycles to output the data ( 32 cycles )
;   (the output loop needs between 28 and 32 cycles to
;   output calculate, lookup and the data)
;   f = FREQ_H/FREQ_M/FREQ_L * (1000000/28)/16777216
;   f = FREQ_H/FREQ_M/FREQ_L * 0.00212874
;   fMax (theoretical) = 0.5 * fClock
;   example frequency words
;
;     1 Hz =     470 ( 0x0001D6 )
;     3,1372Hz = 1474( 0x0005C2 ) SSTV color step
;    10 Hz =    4698 ( 0x00125A )
;   100 Hz =   46976 ( 0x00B780 )
;  1000 Hz =  469761 ( 0x702B01 )
;  1200 Hz =  563714 ( 0x089A02 ) SSTV Sync
;  1500 Hz =  704642 ( 0x0AC082 ) SSTV Black
;  2300 Hz = 1080451 ( 0x107C83 ) SSTV White
;  3000 Hz = 1409284 ( 0x158104 )
;=========================================================
;10	4698	0	18	89	001259	00 12 59
;50	23488	0	91	192	005BC0	00 5B C0
;100	46976	0	183	128	00B780	00 B7 80
;500	234881	3	149	129	039581	03 95 81
;1000	469762	7	43	2	072B02	07 2B 02
;1100	516738	7	226	130	07E282	07 E2 82
;1200	563714	8	154	2	089A02	08 9A 02
;1300	610691	9	81	130	095182	09 51 82
;1400	657667	10	9	2	0A0902	0A 09 02
;1500	704643	10	192	131	0AC083	0A C0 83
;1600	751619	11	120	3	0B7803	0B 78 03
;1700	798595	12	47	131	0C2F83	0C 2F 83
;1800	845572	12	231	3	0CE703	0C E7 03
;2000	939524	14	86	4	0E5604	0E 56 04
;===========================================================


    ; ---- START ----
    ; 25 Hz
    #define STARTAT_H       0x00
    #define STARTAT_M       0x2d
    #define STARTAT_L       0xe0

    ; ---- STEP ----
    ; 25 Hz
    #define STEP_H          0x00
    #define STEP_M          0x2d
    #define STEP_L          0xE0

    ; ---- ROLL ----
    ; 1000 Hz
    #define ROLLAT_H        0x07
    #define ROLLAT_M        0x2b
    #define ROLLAT_L        0x02
;**************************************************
;       Main Loop
;**************************************************

                clrf            ACC_H
                clrf            ACC_M
                clrf            ACC_L
                clrf            PORTA
                clrf            PORTB
                
                   
                call            Init_F_Depart           ; set START frequency
                goto            Attente_Depart         
NCOLoop
IsCmd
                ; entree  1 ?
                btfsc           PORTA,2                 ; 1 / 2
                goto            ProcessCmd              ; 2

AddFreq
                ; add freq value to phase accumulator 24bit
                movf            FREQ_L,w                ; 1
                addwf           ACC_L,f                 ; 1
                movf            FREQ_M,w                ; 1
                btfsc           STATUS,C                ; 1 / 2
                incfsz          FREQ_M,w                ; 1 / 2
                addwf           ACC_M,f                 ; 1
                movf            FREQ_H,w                ; 1
                btfsc           STATUS,C                ; 1 / 2
                incfsz          FREQ_H,w                ; 1 / 2
                addwf           ACC_H,f                 ; 1
LookupSine
                movf            ACC_H,w                 ; 1
                callEX          SINE_TABLE              ; 2 + 5 in subroutine
                                                        ; + 4 bsf's and bcf's
                                                        ; in callEX macro
;Sortie sur DAC558 8 bits
                movwf           PORTB                   ; 1
                goto            NCOLoop                 ; 2
               
;**************************************************
;       Process commands to NCO
;**************************************************
ProcessCmd
                call DebugCmd
                goto NCOLoop
Attente_Depart
                btfss           PORTA,2
                goto            Attente_Depart
                goto            ProcessCmd
DebugCmd
                ; just for debuging - key debounce 5ms
                movlw           0x00
                movwf           DELAY_H
                movlw           0x05
                movwf           DELAY_L
                callEX          Delay
                btfss           PORTA,2
                return
TestTouche
                btfsc           PORTA,2
                goto            TestTouche
                ; just for debuging - toggle led at A3
                movlw           B'00001000'
                xorwf           PORTA,f
                
                
                ; increment freq by STEP with every key press
                ; 24 bit add
                movlw           STEP_L
                addwf           FREQ_L,f
                movlw           STEP_M
                movwf           TEMP
                btfsc           STATUS,C
                incfsz          TEMP,w
                addwf           FREQ_M,f
                movlw           STEP_H
                movwf           TEMP
                btfsc           STATUS,C
                incfsz          TEMP,w
                addwf           FREQ_H,f           
                ; check for overrun ar ROLLAT
                ; 24 bit subtract
                movlw           ROLLAT_H
                subwf           FREQ_H,w
                btfss           STATUS,C
                return
                btfss           STATUS,Z
                goto            Init_F_Depart
                movlw           ROLLAT_M
                subwf           FREQ_M,w
                btfss           STATUS,C
                return
                btfss           STATUS,Z
                goto            Init_F_Depart
                movlw           ROLLAT_L
                subwf           FREQ_L,w
                btfss           STATUS,C
                return
                
Init_F_Depart
                ; roll over to START freqency
                movlw           STARTAT_H
                movwf           FREQ_H
                movlw           STARTAT_M
                movwf           FREQ_M
                movlw           STARTAT_L
                movwf           FREQ_L             
                return
;**************************************************
;       SINE Frequency Table with 256 entries
;       copy and paste from SineDDS MatLab script
;**************************************************
                ORG             0x1FD
SINE_TABLE
                bsf             PCLATH,1                                ; 1
                bcf             PCLATH,0                                ; 1
                addwf           PCL,f                                   ; 1
                ; each dt is internaly a retlw so 2 cycles              ; 2
                dt              0x80,0x83,0x86,0x89,0x8c,0x8f,0x92,0x95 
                dt              0x98,0x9c,0x9f,0xa2,0xa5,0xa8,0xab,0xae
                dt              0xb0,0xb3,0xb6,0xb9,0xbc,0xbf,0xc1,0xc4
                dt              0xc7,0xc9,0xcc,0xce,0xd1,0xd3,0xd5,0xd8
                dt              0xda,0xdc,0xde,0xe0,0xe2,0xe4,0xe6,0xe8
                dt              0xea,0xec,0xed,0xef,0xf0,0xf2,0xf3,0xf5
                dt              0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfc
                dt              0xfd,0xfe,0xfe,0xff,0xff,0xff,0xff,0xff
                dt              0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0xfe
                dt              0xfd,0xfc,0xfc,0xfb,0xfa,0xf9,0xf8,0xf7
                dt              0xf6,0xf5,0xf3,0xf2,0xf0,0xef,0xed,0xec
                dt              0xea,0xe8,0xe6,0xe4,0xe2,0xe0,0xde,0xdc
                dt              0xda,0xd8,0xd5,0xd3,0xd1,0xce,0xcc,0xc9
                dt              0xc7,0xc4,0xc1,0xbf,0xbc,0xb9,0xb6,0xb3
                dt              0xb0,0xae,0xab,0xa8,0xa5,0xa2,0x9f,0x9c
                dt              0x98,0x95,0x92,0x8f,0x8c,0x89,0x86,0x83
                dt              0x80,0x7c,0x79,0x76,0x73,0x70,0x6d,0x6a
                dt              0x67,0x63,0x60,0x5d,0x5a,0x57,0x54,0x51
                dt              0x4f,0x4c,0x49,0x46,0x43,0x40,0x3e,0x3b
                dt              0x38,0x36,0x33,0x31,0x2e,0x2c,0x2a,0x27
                dt              0x25,0x23,0x21,0x1f,0x1d,0x1b,0x19,0x17
                dt              0x15,0x13,0x12,0x10,0x0f,0x0d,0x0c,0x0a
                dt              0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x03
                dt              0x02,0x01,0x01,0x00,0x00,0x00,0x00,0x00
                dt              0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01
                dt              0x02,0x03,0x03,0x04,0x05,0x06,0x07,0x08
                dt              0x09,0x0a,0x0c,0x0d,0x0f,0x10,0x12,0x13
                dt              0x15,0x17,0x19,0x1b,0x1d,0x1f,0x21,0x23
                dt              0x25,0x27,0x2a,0x2c,0x2e,0x31,0x33,0x36
                dt              0x38,0x3b,0x3e,0x40,0x43,0x46,0x49,0x4c
                dt              0x4f,0x51,0x54,0x57,0x5a,0x5d,0x60,0x63
                dt              0x67,0x6a,0x6d,0x70,0x73,0x76,0x79,0x7c     
SINE_TABLE_fin	equ $
;**************************************************
;       Tool routines
;**************************************************
                ORG             0x300              
; delay
; parameter
; DELAY_H   msb
; DELAY_L   lsb
; of the 16 bit number of milliseconds to wait.
; so it is possible to wait from 1ms to 65535ms
; (about 1min) 1min is exact EA60 (60000)
; at 4MHz, 1000 instruction cycles are exact 1ms
; completely exact time is not possible. the
; routine always needs 5 instructions at the
; beginning and 1 instruction at the end. so the
; total delay instruction count is always + 6
;**************************************************
Delay
        ifdef Debug
            return
        else
            comf        DELAY_H,f   ; 1     1
            comf        DELAY_L,f   ; 1     1
            incf        DELAY_L,f   ; 1     1
            btfsc       STATUS,Z    ; 1/2   1/2
            incf        DELAY_H,f   ; 1     1
; ------------------------------------- = 5 always at etry
; inner loop for 1000 instruction cycles
; at 4MHz each instruction takes 4 clock
; cycles
; 1000 instruction cycles = 1ms
; ---------------------------------------Cycles-----
Delay01
            movlw       D'248'      ; 1     1
            movwf       DELAY_T     ; 1     1
Delay02
            nop                     ; 1     248x1
            decfsz      DELAY_T,f   ; 1/2   247x1 + 1x2
            goto        Delay02     ; 2     247x2
            nop                     ; 1     1
            nop                     ; 1     1
; ------------------------------------- = 995 cycles
            incf        DELAY_L,f   ; 1     1
            btfsc       STATUS,Z    ; 1/2   1/2
            incfsz      DELAY_H,f   ; 1/2   1/2
            goto        Delay01     ; 2     2 in the loop always 5
; ------------------------------------- = 5 cycles
            return                  ; 2     on exit the 5 from above + 1
; ------------------------------------- = 6 cycles
        endif
DelayEnd        
        if (high (Delay) != high (DelayEnd) )
            MESSG "Procedure (Delay) hits page boundary!"
        endif
;***************************************************
FinProgramme	EQU $
		ORG 0x2100
	;  "1234567890123456"
; message taille modulo 16
EE0	DT "SINEDDS2.asm     "
EE1	DT "84-0045-04      "
EE2	DT "200304 AD558   ",0

finEprom	EQU $
   
   
        end


