; 13 juin 2004
; rajout indexation valeur frequence en Hz
; 8 avril 2004
; indexation frequnce sur indice
;07 avril 2004
; adaptation PF pour AD588 
; SINEDDS3.asm  version avec PIC @ 20Mhz
; 21 mars 2004
;Building SINEDDS2.HEX...  16F84 quartz 4MHZ
;Compiling SINEDDS2.ASM:
;Command line: "F:\MPLAB\MPASMWIN.EXE /aINHX8M /e+ /l+ /x+ /c+ /rdec /p16F84 /q F:\MPLAB\DDS\SINEDDS2.ASM"
;Build completed successfully.
; 13 mars 2004 rev PF  SINEDDS1.ASM:
;SINDDS (C) Copyright 2003 by Richard Prinz.OE1RIB Richard.Prinz@MIN.at
;-----------------------
#define miniSimDE
	ifdef miniSimDE
	p=16F84
	__CONFIG  0x3FF2
	RADIX DEC
	else
	ERRORLEVEL      -302
	Processor	16F84
	EXPAND
      __CONFIG        _CP_OFF & _WDT_OFF & _PWRTE_ON & _HS_OSC
	endif
	include <p16f84_.inc>
	

;**************************************************
; 
;       Schematic  /  Loop version
;                     DAC 8bits                                                     
;   16F84             AD558   +5V           + 9V          
;   20 MHz                     |             |  
;   +------+          +-------+-+           /                               
;   |      |----------|1 D0   11|         |/       
;   |      |  B0-B7   |       16|---------|  2N2222  NPN                     
;   |      |----------|8 D7     |out      |\> 
;   |      |  gnd ----|9 CS   14|-----------\ 
;   |      |  Gnd ----|10 CE  15|-----------+-- analog Fout ----->                     
;   |      |          +------+--+  sense    |                     
;   |      |  A1    Key      | 12           |                              
;   |    18|---------/ -     | 13           |      
;   |      |  A2    Key       -+-0V         |                        
;   |    1 |---------/ +                    -                              
;   |      |  A3                           | |  R                         
;   |    2 |-------->RS232 Tx              | | 2,2K  
;   |      |  A4                           | |                           
;   |    3 |-------|<|---R 1,2K--<+5V       +                           
;   |      |                                |
;   +------+                               -|- 0V 
;
;**************************************************
;       Definitions
;**************************************************
#define PAGE0           BCF 3,5
#define PAGE1           BSF 3,5
;#define Debug          1
;**************************************************
;       Variables
;**************************************************
      	ifdef miniSimDE
                   org 0x0C  
FREQ_H		Equ $
FREQ_M		Equ $+1
FREQ_L		Equ $+2
ACC_H		Equ $+3
ACC_M		Equ $+4
ACC_L		Equ $+5
TEMP		Equ $+6
SER		Equ $+7
DELAY_W		Equ $+8
DELAY_T		Equ $+9
DELAY_H		Equ $+10
DELAY_L		Equ $+12
RsCount		Equ $+13
RsBuffer	Equ $+14
count1		Equ $+15
indice		Equ $+16
RsByte		Equ $+17
Cpt1		Equ $+18
sauve		Equ $+19
btmp		Equ $+20
bun		EQU $+21
bdix		EQU $+22



	else
             
             cblock     0x0C
FREQ_H
FREQ_M
FREQ_L
ACC_H
ACC_M
ACC_L
TEMP
SER
DELAY_W
DELAY_T
DELAY_H
DELAY_L
indice
RsCount
RsBuffer
count1
RsByte	
Cpt1
sauve
	 endc
    	endif
;**************************************************
; -- input --
#define Rs_Port	PORTA
#define Rs_Rx   0	; RA0
#define KeyUp   2	; RA1
#define KeyDown 1	; RA2
; --output --
#define Rs_Tx   3	; RA3
#define LedR  4 	; RA4

#define Augmente PORTA,KeyUp   ;
#define Diminue  PORTA,KeyDown ;
#define SERIAL_TX  Rs_Port,Rs_Tx  ; serial RS232 output
#define SERIAL_RX  Rs_Port,Rs_Rx  ; serial RS232 input

PCLBit macro label,bit,check
        local mask
mask set (1 << bit)
        if (check == 1)
            if (high($)) == (high(label))
                messg "Source and destination "label" on same Page!"
            endif
        endif
        if ((high($) & mask) == (high(label) & mask))
            bcf     PCLATH,bit
        else
            bsf     PCLATH,bit
        endif       
    endm
    
;**************************************************
;       M A I N - E N T R Y
;**************************************************
                ORG             0x000
Start
                PAGE1
                movlw           B'00000111'
                movwf           TRISA
                movlw           B'00000000'
                movwf           TRISB
                PAGE0
                  
;**************************************************
;       Output frequency (using 24 bit accumulator)
;   f = deltaPhase * fClock/2^24
;   fClock is in this case the CPU clock divided by the
;   number of cycles to output the data ( 32 cycles )
;   (the output loop needs between 28 and 32 cycles to
;   output calculate, lookup and the data)
;   f = FREQ_H/FREQ_M/FREQ_L * (5000000/28)/16777216
;   f = FREQ_H/FREQ_M/FREQ_L * 0.00212874
;   fMax (theoretical) = 0.5 * fClock
;   example frequency words
;=========================================================
    ; ---- START ----
    ; 10 Hz
    #define STARTAT_H       0x00
    #define STARTAT_M       0x03
    #define STARTAT_L       0xEE
 ; ---- STEP ----
 ; 100 Hz
 ;   #define STEP_H          0x00
 ;   #define STEP_M          0x27
 ;   #define STEP_L          0x52

    ; ---- ROLL ----
    ; 5001 Hz
    #define ROLLAT_H        0x07
    #define ROLLAT_M        0xAE
    #define ROLLAT_L        0x79

;**************************************************
;       Main Loop
;**************************************************
       
Pres
	clrf Cpt1
        clrf indice
        clrf sauve

        goto NoPresentation

	CALL RS_CRLF	
Pres1
	movf Cpt1,w
	CALL read_EE
	incf Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO	Pres2  	
	Call RS_Putchar
	goto Pres1
Pres2
	CALL RS_CRLF	
	movlw EE1-EE0
	MOVWF Cpt1
Pres3
	movf Cpt1,w
	CALL read_EE
	incf	Cpt1,f
	ANDLW	0x0FF		; test sur (W)
	BTFSC	STATUS, Z	; zero= fin de message ?
	GOTO Pres4  	
	Call RS_Putchar
	goto Pres3
          
Pres4          
          	CALL RS_CRLF

 NoPresentation      	
                clrf            ACC_H
                clrf            ACC_M
                clrf            ACC_L
                clrf            PORTA
                clrf            PORTB
                goto            Init_F_Depart           ; set START frequency
      
NCOLoop
; entree  1 ?
                btfsS           PORTA,2                ; 1 / 2
                goto            Augmentation            ; 2
                btfsS           PORTA,1                 ; 1 / 2
                goto            Diminution              ; 2
AddFreq
                ; add freq value to phase accumulator 24bit
                movf            FREQ_L,w                ; 1
                addwf           ACC_L,f                 ; 1
                movf            FREQ_M,w                ; 1
                btfsc           STATUS,C                ; 1 / 2
                incfsz          FREQ_M,w                ; 1 / 2
                addwf           ACC_M,f                 ; 1
                movf            FREQ_H,w                ; 1
                btfsc           STATUS,C                ; 1 / 2
                incfsz          FREQ_H,w                ; 1 / 2
                addwf           ACC_H,f                 ; 1
LookupSine
                movf            ACC_H,w                 ; 1
                call          SINE_TABLE              ; 2 + 5 in subroutine
                                                        ; + 4 bsf's and bcf's
                                                        ; in callEX macro
;Sortie sur DAC558 8 bits
                movwf           PORTB                   ; 1
                goto            NCOLoop                 ; 2

               
;**************************************************
;       Process commands to NCO
;**************************************************

Augmentation
 		btfss           PORTA,2                ; 1 / 2
                goto            Augmentation            ; 2
                incf indice,f
		goto changeF
	
Diminution
	        btfss           PORTA,1                 ; 1 / 2
                goto            Diminution              ; 2
                decf indice,f
                goto changeF
changeF	
                movlw           B'00010000'
                xorwf           PORTA,f
             
		    	movlw 0x1F
			andwf indice,f
   			movf indice,w
			movWf sauve		; registre de travail

	ifNdef miniSimDE
			call bcd2		; affichage valeur indice
			movlw '='
			call RS_Putchar
        ENDIF
        ; mutliplie indice par 3
                        BCF STATUS,C
			rlf  sauve,w	; sauve=indice *2
                        ADDWf indice,w  ; sauve= indice*2 + indice
		       	movwf sauve
                        call Freq_Table 
	                movWf  FREQ_H
			call hex8	
  			incf sauve
			movf sauve,W
			call Freq_Table
                	movWf  FREQ_M
			call hex8
 			incf sauve
			movf sauve,W
			call Freq_Table
                	movWf  FREQ_L
                        call hex8

  	ifNdef miniSimDE
                        movlw '='
			call RS_Putchar
        endif
                        MOVF indice,w
                        call Affiche_Frequence
                               
                movf           indice,W
                subLw           20
                btfsC           STATUS,C
                goto            NCOLoop

 Init_F_Depart                            
                movlw 02                ; pour tets !
                movwf indice            ; pour test
                ;CLRF            indice
                CLRF            sauve
                movlw           STARTAT_H
                movwf           FREQ_H
                movlw           STARTAT_M
                movwf           FREQ_M
                movlw           STARTAT_L
                movwf           FREQ_L             
                goto NCOLoop
               

              ORG             0x0fd
Freq_TABLE
               bSf             PCLATH,0                                ; 1
               bcf             PCLATH,1                                ; 1
               addwf           PCL,f                                   ; 1
                ; each dt is internaly a retlw so 2 cycles              ; 2
        dt    0x00, 0x00, 0x64     ;1Hz
	dt    0x00, 0x03, 0xEE     ;10Hz
	dt    0x00, 0x09, 0xD4     ;25Hz
	dt    0x00, 0x13, 0xA9     ;50Hz
	dt    0x00, 0x27, 0x52     ;100Hz
	dt    0x00, 0x4E, 0xA4     ;200Hz
	dt    0x00, 0x62, 0x4D     ;250Hz
	dt    0x00, 0xAD, 0x03     ;440Hz
	dt    0x00, 0xC4, 0x9B     ;500Hz
	dt    0x01, 0x26, 0xE9     ;750Hz
	dt    0x01, 0x89, 0x37     ;1000Hz
	dt    0x02, 0x4D, 0xD2     ;1500Hz
	dt    0x03, 0x12, 0x6E     ;2000Hz
	dt    0x03, 0xD7, 0x0A     ;2500Hz
	dt    0x04, 0x9B, 0xA5     ;3000Hz
	dt    0x05, 0x60, 0x41     ;3500Hz
	dt    0x06, 0x24, 0xDD     ;4000Hz
	dt    0x06, 0xE9, 0x78     ;4500Hz
	dt    0x07, 0xAE, 0x14     ;5000Hz
Freq_TABLE_fin	equ $              		

        		

Freq_value EQU $
        DT    "...1"
	dt    "..10"
	dt    "..25"
	dt    "..50"
	dt    ".100"
	dt    ".200"
	dt    ".250"
	dt    ".440"
	dt    ".500"
	dt    ".750"
	dt    "1000"
	dt    "1500"
	dt    "2000"
	dt    "2500"
	dt    "3000"
	dt    "3500"
	dt    "4000"
	dt    "4500"
	dt    "5000"
Freq_value_fin	equ $              		

EcartTable    EQU Freq_value -(Freq_TABLE +3)


Affiche_Frequence
                movwf Cpt1
                BCF STATUS,C
                RLF Cpt1,f                ;indice  x 2
                RLF Cpt1,w                 ;indice  x 2
                ADDLW EcartTable        ; indice *4 + deplacement
                movwf sauve
                clrf Cpt1
Encore_Affich
                movf sauve,w
                call Freq_TABLE
       	ifNdef miniSimDE
                 call RS_Putchar   
        endif
                incf Sauve,f      
                incf Cpt1,f
                movf Cpt1,W
                andLW 0x03
                btfsC   STATUS,Z
                goto   Affich_fin
                Goto Encore_Affich
 Affich_fin
       	ifNdef miniSimDE
                 movlw 'H'
                call RS_Putchar 
                 movlw 'Z'
                call RS_Putchar 
        	call RS_CRLF
        ENDIF
                return











;**************************************************
;       SINE Frequency Table with 256 entries
;       copy and paste from SineDDS MatLab script
;**************************************************
                ORG             0x1FD
SINE_TABLE
                bsf             PCLATH,1                                ; 1
                bcf             PCLATH,0                                ; 1
                addwf           PCL,f                                   ; 1
                ; each dt is internaly a retlw so 2 cycles              ; 2
                dt              0x80,0x83,0x86,0x89,0x8c,0x8f,0x92,0x95 
                dt              0x98,0x9c,0x9f,0xa2,0xa5,0xa8,0xab,0xae
                dt              0xb0,0xb3,0xb6,0xb9,0xbc,0xbf,0xc1,0xc4
                dt              0xc7,0xc9,0xcc,0xce,0xd1,0xd3,0xd5,0xd8
                dt              0xda,0xdc,0xde,0xe0,0xe2,0xe4,0xe6,0xe8
                dt              0xea,0xec,0xed,0xef,0xf0,0xf2,0xf3,0xf5
                dt              0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfc
                dt              0xfd,0xfe,0xfe,0xff,0xff,0xff,0xff,0xff
                dt              0xff,0xff,0xff,0xff,0xff,0xff,0xfe,0xfe
                dt              0xfd,0xfc,0xfc,0xfb,0xfa,0xf9,0xf8,0xf7
                dt              0xf6,0xf5,0xf3,0xf2,0xf0,0xef,0xed,0xec
                dt              0xea,0xe8,0xe6,0xe4,0xe2,0xe0,0xde,0xdc
                dt              0xda,0xd8,0xd5,0xd3,0xd1,0xce,0xcc,0xc9
                dt              0xc7,0xc4,0xc1,0xbf,0xbc,0xb9,0xb6,0xb3
                dt              0xb0,0xae,0xab,0xa8,0xa5,0xa2,0x9f,0x9c
                dt              0x98,0x95,0x92,0x8f,0x8c,0x89,0x86,0x83
                dt              0x80,0x7c,0x79,0x76,0x73,0x70,0x6d,0x6a
                dt              0x67,0x63,0x60,0x5d,0x5a,0x57,0x54,0x51
                dt              0x4f,0x4c,0x49,0x46,0x43,0x40,0x3e,0x3b
                dt              0x38,0x36,0x33,0x31,0x2e,0x2c,0x2a,0x27
                dt              0x25,0x23,0x21,0x1f,0x1d,0x1b,0x19,0x17
                dt              0x15,0x13,0x12,0x10,0x0f,0x0d,0x0c,0x0a
                dt              0x09,0x08,0x07,0x06,0x05,0x04,0x03,0x03
                dt              0x02,0x01,0x01,0x00,0x00,0x00,0x00,0x00
                dt              0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01
                dt              0x02,0x03,0x03,0x04,0x05,0x06,0x07,0x08
                dt              0x09,0x0a,0x0c,0x0d,0x0f,0x10,0x12,0x13
                dt              0x15,0x17,0x19,0x1b,0x1d,0x1f,0x21,0x23
                dt              0x25,0x27,0x2a,0x2c,0x2e,0x31,0x33,0x36
                dt              0x38,0x3b,0x3e,0x40,0x43,0x46,0x49,0x4c
                dt              0x4f,0x51,0x54,0x57,0x5a,0x5d,0x60,0x63
                dt              0x67,0x6a,0x6d,0x70,0x73,0x76,0x79,0x7c     
SINE_TABLE_fin	equ $
;**************************************************
;       Tool routines
;**************************************************
    

;====================================================              
; delay parameter
; DELAY_H   msb
; DELAY_L   lsb
; of the 16 bit number of milliseconds to wait.
; so it is possible to wait from 1ms to 65535ms
;**************************************************
Delay
            comf        DELAY_H,f   ; 1     1
            comf        DELAY_L,f   ; 1     1
            incf        DELAY_L,f   ; 1     1
            btfsc       STATUS,Z    ; 1/2   1/2
            incf        DELAY_H,f   ; 1     1
; ------------------------------------- = 5 always at etry
; inner loop for 1000 instruction cycles
; at 20MHz each instruction takes 4 clock
; 1 cycle =0,2S 
; 5000 instruction cycles = 1ms
; ---------------------------------------Cycles-----
Delay01
            movlw       D'250'      ; 1     1
            movwf       DELAY_T     ; 1     1
Delay02
            goto $+1		; 2 -> 0.4S
            goto $+1		; 2
            goto $+1		; 2
            goto $+1		; 2
            goto $+1		; 2
            goto $+1		; 2
            goto $+1		; 2
            goto $+1		; 2 --- 16x0,2S=3.2S
            decfsz      DELAY_T,f   ; 1/2   249*1 + 1x2
            goto        Delay02     ; 2     249*x2
            
            goto $+1                     ; 2
            goto $+1                     ; 2
            goto $+1                     ; 2
; ------------------------------------- = 4994 cycles
            incf        DELAY_L,f   ; 1     1
            btfsc       STATUS,Z    ; 1/2   1/2
            incfsz      DELAY_H,f   ; 1/2   1/2
            goto        Delay01     ; 2     2 in the loop always 5
; ------------------------------------- = 5 cycles
            return                  ; 2     on exit the 5 from above + 1
; ------------------------------------- = 6 cycles

;***************************************************

;special pour routine d'attente bit 4800 Bauds @20Mhz
delay_RS4800	   
   	 MOVLW     	 172  		; 170 * 3 cycles *0,2S=103S         
         MOVWF           count1
         DECFSZ          count1,F
         GOTO            $-1
	 MOVLW        172           ; 103S
         MOVWF           count1		; 4800 bauds => 208S
         DECFSZ          count1,F
         GOTO            $-1
         Return
;---------------

hex8	
        movwf   btmp		; affichage octet --> hexadecimal 2 digits ( de 00 a FF )
        swapf   btmp,W
        andlw   0x0f
        addlw   -0x0a
        btfsc   STATUS,C
        addlw   0x07
        addlw   0x3a
 	ifNdef miniSimDE
        call RS_Putchar   
        endif
        movf    btmp,W
        andlw   0x0f
        addlw   -0x0a 
        btfsc   STATUS, C 
        addlw   0x07 
        addlw   0x3a
 	ifNdef miniSimDE
         call RS_Putchar   
      	 movlw '.'
   	 call   RS_Putchar 
        endif
return
;----------------------
bcd2	movwf  btmp		; affichage octet --> decimal 2 digits ( de 0 a 99 )
	movlw  '0'
	movwf  bdix
bcd21   movlw  10
	subwf  btmp,w
	bnc    bcd22
	movwf  btmp
	incf   bdix,f
	goto   bcd21
bcd22	movlw  '0'
	addwf  btmp,w
	movwf  bun
	movf   bdix,w
 	ifNdef miniSimDE
        call RS_Putchar   
   	movf   bun,w
        call RS_Putchar   
        endif
        return
;----------------------





RS_Putchar
	bank0
	movwf	 RsBuffer
	Movlw           8           	;correspond  un byte de 8 bits
        Movwf           RsCount       	;place dans RsCount
        Bcf             SERIAL_TX    	;bit start  0
        Call            delay_RS4800         	;wait valeur 1bit 4800 Bauds
        Rrf             RsBuffer,F    	;shift droite dans carry
        Btfsc           STATUS,C     	;si carry 0 alors saute
        Goto            $+3         	;carry =1
        Bcf             SERIAL_TX    	;Tx =0
        Goto            $+2
        Bsf             SERIAL_TX      	;Tx =1
        Call            delay_RS4800
        Decfsz          RsCount,F      	;RsCount =RsCount -1
        Goto            $-8
        Bsf             SERIAL_TX       ;bit de stop  1
    	Call            delay_RS4800          ;byte envoye
    	Call            delay_RS4800
	return
;---------------
RS_CRLF
	movf RsByte,w	;sauve W
	movlw	13
	call RS_Putchar
	movlw 10
	call RS_Putchar
	movwf RsByte	;restitue W
	return
;------------------------------
Read_RS  Clrf            RsByte
         Movlw           H'08'          ;byte 8 bit
         Movwf           RsCount
         Btfsc           SERIAL_RX      ;Attendre bit start
         Goto            $-1            ;si zero = bit start = goto loop
Rx_Loop  call            Delay          ;bit de start
         Bcf             STATUS,C      	;Carry=0
         Btfsc           SERIAL_RX      ;lit et test l'entre RB0
         Bsf             STATUS,C       ;Rx =1, saute si Rx =0
         rrf             RsByte,F       
         Decfsz          RsCount,F
         Goto            Rx_Loop                
         Return   
;------------------
read_EE	

	movwf   EEADR           ; defini offset addresse
	bank1			; 16F84 !!!!
	bsf     EECON1,RD       ; mode lecture
	bank0			; 16F84 !!!!
	movf    EEDATA,W       	; recupere lecture
	return












FinProgramme	EQU $
		ORG 0x2100
	;  "1234567890123456"
; message taille modulo 16
EE0	DT "SINEDDSZ.asm    "
EE1	DT "84-0130 G83-20  "
EE2	DT "080404 AD558   ",0

finEprom	EQU $
   
   
        end


