W                            EQU     0x0000 
F                            EQU     0x0001 

;----- Register Files--------------------------------
INDF                         EQU     0x0000 
TMR0                         EQU     0x0001 
PCL                          EQU     0x0002 
STATUS                       EQU     0x0003 
FSR                          EQU     0x0004 
PORTA                        EQU     0x0005 
PORTB                        EQU     0x0006 
EEDATA                       EQU     0x0008 
EEADR                        EQU     0x0009 
PCLATH                       EQU     0x000A 
INTCON                       EQU     0x000B 
OPTION_REG                   EQU     0x0081 
TRISA                        EQU     0x0085 
TRISB                        EQU     0x0086 
EECON1                       EQU     0x0088 
EECON2                       EQU     0x0089 

;----- STATUS Bits ----------------------------------
IRP                          EQU     0x0007 
RP1                          EQU     0x0006 
RP0                          EQU     0x0005 
NOT_TO                       EQU     0x0004 
NOT_PD                       EQU     0x0003 
Z                            EQU     0x0002 
DC                           EQU     0x0001 
C                            EQU     0x0000 

;----- INTCON Bits ----------------------------------
GIE                          EQU     0x0007 
EEIE                         EQU     0x0006 
T0IE                         EQU     0x0005 
INTE                         EQU     0x0004 
RBIE                         EQU     0x0003 
T0IF                         EQU     0x0002 
INTF                         EQU     0x0001 
RBIF                         EQU     0x0000 

;----- OPTION Bits -----------------------------------
NOT_RBPU                     EQU     0x0007 
INTEDG                       EQU     0x0006 
T0CS                         EQU     0x0005 
T0SE                         EQU     0x0004 
PSA                          EQU     0x0003 
PS2                          EQU     0x0002 
PS1                          EQU     0x0001 
PS0                          EQU     0x0000 



;----- EECON1 Bits ----------------------------------
EEIF                         EQU     0x0004 
WRERR                        EQU     0x0003 
WREN                         EQU     0x0002 
WR                           EQU     0x0001 
RD                           EQU     0x0000 

;---- RAM Definition --------------------------------
        __MAXRAM 0xAF 
        __BADRAM 0x07 , 0x30 -0x7F , 0x87 

;----- Configuration Bits ---------------------------
_CP_ON                       EQU     0x3FEF 
_CP_OFF                      EQU     0x3FFF 
_PWRTE_ON                    EQU     0x3FFF 
_PWRTE_OFF                   EQU     0x3FF7 
_WDT_ON                      EQU     0x3FFF 
_WDT_OFF                     EQU     0x3FFB 
_LP_OSC                      EQU     0x3FFC 
_XT_OSC                      EQU     0x3FFD 
_HS_OSC                      EQU     0x3FFE 
_RC_OSC                      EQU     0x3FFF 

